﻿(function () {
'use strict';
//TODO (ashokkul): add cluster title strings in resources, and check the performance after adding these clusters. 
WinJS.Namespace.define("SportsJS.Controls.Cluster",
{
TempClusterController: WinJS.Class.derive(SportsJS.Controls.Cluster.ClusterController, function TempClusterController_constructor(element, config) {
SportsJS.Controls.Cluster.ClusterController.call(this, element, config);
this._removeTempClusterHandler = this._removeTempCluster.bind(this);
this._element.addEventListener("removeTempCluster", this._removeTempClusterHandler);
}, {
_name: "SportsJS.Controls.Cluster.TempClusterController",
_removeTempClusterHandler: null,
_removeTempCluster: function _removeTempCluster() {
if (this._config && this._config.removeClusterCallback && typeof this._config.removeClusterCallback === "function") {
this._config.removeClusterCallback(this);
}
},
renderCompleteCallback: function renderCompleteCallback() {
if (this._config && this._config.clusterClass) {
// set additional class on the cluster. (hacky way)
// This is used by next steps cluster, to render full background.
var clusterNode = this._element.parentNode;
if (WinJS.Utilities.hasClass(clusterNode, "platformCluster")) {
WinJS.Utilities.addClass(clusterNode, this._config.clusterClass);
}
}
},
cleanUp: function cleanUp() {
if (this._element) {
this._element.removeEventListener("removeTempCluster", this._removeTempClusterHandler);
}
SportsJS.Controls.Cluster.ClusterController.prototype.cleanUp.call(this);
}
})
}),
WinJS.Namespace.define("SportsJS.Controls.ViewControls",
{
TempClusterViewControl: WinJS.Class.derive(SportsJS.Controls.ViewControls.ViewControlInterface, function TempClusterControl_constructor(element, config) {
SportsJS.Controls.ViewControls.ViewControlInterface.call(this, element, config);
this._removeClusterHandler = this.removeCluster.bind(this);
}, {
_name: "SportsJS.Controls.ViewControls.TempClusterViewControl",
_removeClusterHandler: null,
render: function render(response) {
var that = this;
if (!response || !response.messageData || !response.messageData.data) {
return WinJS.Promise.wrapError(false);
}
this._element.innerHTML = "";
var tempClusterConfig = {};
tempClusterConfig.messageData = response.messageData.data;
tempClusterConfig.templateName = response.templateName;
var tempCluster = new CommonJS.TempCluster(that._element, tempClusterConfig);
tempCluster.removeClusterHandler = that._removeClusterHandler;
return tempCluster.render();
},
removeCluster: function removeCluster() {
SportsJS.Controls.Utilities.dispatchCustomEvent(this._element, "removeTempCluster");
return;
},
}),
});
WinJS.Namespace.define("SportsJS.Controls.Models",
{
TempClusterDataModel: WinJS.Class.derive(SportsJS.Controls.Models.ClusterDataModel, function PlatformClusterDataModel_Constructor(config) {
SportsJS.Controls.Models.ClusterDataModel.call(this, config);
this._templateName = config.templateName;
}, {
_templateName: "",
transformer: function transformer(data) {
var that = this;
var result = null;
if (data) {
try {
result = SportsJS.Controls.Utilities.jsonParse(data.dataString);
} catch (exp) {
return null;
}
}
if (!result) {
return null;
}
var tempClusterProvider = new CommonJS.TempClusterDataProvider();
var query = this.constructQuery();
var templateName = "";
var messageData = null;
if (query.uiScenario === AppEx.Sports.Services.TypeDefs.Request.UiScenarioEnum.gettingStarted) {
messageData = tempClusterProvider.parseData(result);
templateName = "gsTemplate";
}
else if (query.uiScenario === AppEx.Sports.Services.TypeDefs.Request.UiScenarioEnum.nextSteps) {
messageData = tempClusterProvider.parseNextStepsData(result);
templateName = "nsTemplate";
}
else {
return null;
}
return { type: "TempClusterViewControl", messageData: messageData, isValid: true, etag: data.etag, templateName: templateName };
}
})
});
})();