﻿(function () {
"use strict";
////TODO(chthakur): check why do we need this. Copied from WinJS
var Control = WinJS.Class.define(null, {
raiseEvent: function raiseEvent(type, details) {
/// <summary locid="170">
/// Raises an event of the specified type and with additional properties.
/// </summary>
/// <param name="type" locid="171">
/// The type (name) of the event.
/// </param>
/// <param name="details" locid="172">
/// The set of additional properties to be attached to the event object when the event is raised.
/// </param>
/// <returns type="Boolean" locid="173">
/// Boolean indicating whether preventDefault was called on the event.
/// </returns>
this.dispatchEvent(type, details);
}
});
WinJS.Class.mix(Control, WinJS.UI.DOMEventMixin);
WinJS.Namespace.define("SportsJS.UI", {
SportsCluster: WinJS.Class.derive(Control, function (element, options) {
//setting these before init is important for profile mark to work
this._leagueType = (options && options.league) ? options.league : null;
if (!this._leagueType) {
this._leagueType = options && options.leagueType ? options.leagueType : null;
}
this._clusterType = (options && options.id) ? options.id : null;
this._hasSubmodulesLoaded = false;
this._traceMsProfileMarkInfo(SportsJS.UI.ProfilerMarkType.Start);
this.initialize(element, options);
SportsJS.Utilities.setAutomationId(this.element, SportsJS.UI.AutomationComponentType.Cluster, this._clusterType);
this.element.setAttribute("role", "region");
this.element.setAttribute("aria-labelledby", "sports_cluster_header");
this.hasClusterDataProvider = typeof this.dataProvider === "function";
this._msSetImmediateIdentifierList = [];
this._clusterNavigableItems = [];
}, {
//// public interface
isValid: false,
element: null,
submodules: null,
_fragmentPath: null,
_leagueType: null,
_clusterType: null,
_isClusterObjectValid: true,
_dataPromiseStack: [],
_fetchDataTimerId: null,
// list of all the msSetImmediate call references to dispose during clean-up
_msSetImmediateIdentifierList: null,
isStaleResponse: false,
lastUpdateTime: null,
// Load module should happen only once
// This is required to stop loading modules multiple times on progress & complete 
_hasSubmodulesLoaded: null,
// list of cluster navigable items
_clusterNavigableItems: null,
// set the storage provider to be used for caching response
_cacheDataStorageType: {
get: function get() {
return SportsJS.Consts.storageType.PLATFORM;
}
},
leagueType: {
get: function get() {
return this._leagueType;
}
},
clusterType: {
get: function get() {
return this._clusterType;
}
},
initialize: function initialize(element, options) {
var that = this;
element = element || document.createElement("div");
element.style.visibility = 'hidden';
this.Title = 'Not Set';
//// required to make an element a control
this.element = element;
element.winControl = this;
if (options) {
//// Apply className on element
if (options.className) {
WinJS.Utilities.addClass(element, options.className);
}
//// Doing this here since the set Options will no longer be called in Pano control
//// TODO(saarya): Remove the set Options once all clusters are migrated to Pano
this._fragmentPath = options.fragmentPath ? options.fragmentPath : "";
this._dynamicOptions = options.dynamicOptions ? { dynamicOptions: options.dynamicOptions } : {};
this.onRenderCompleteCallerCallBack = options.onRenderComplete;
this.onRenderInitCallBack = options.onClusterRenderInit;
WinJS.UI.setOptions(this, options);
}
this.submodules = []; ////TODO move this as property
that._trace(SportsJS.Msg.ObjectionConstruction);
this.isValid = true;
return true;
},
options: {
get: function get() {
return this._options;
},
set: function set(value) {
if (value) {
this._options = value;
WinJS.UI.setOptions(this, value);
//// setOptions only sets ownProperties of options (value in this case).
//// For clusters which have config class, the config is not ownProperty.
//// Below is a workaround to set the config on the cluster.
//// Will go away once all clusters move to config functions.
SportsJS.Utilities.setOptions(this, value);
this._fragmentPath = value.moduleInfo.fragmentPath;
this._dynamicOptions = { dynamicOptions: value.dynamicOptions };
}
}
},
// Push submodules to get their respective data -> triggering consumption of cluster response just arrived
_getSubmodulesData: function _getSubmodulesData(clusterResponse, bypassCache, isInlineRefreshRequest) {
var that = this;
var submoduleDataPromises = [];
for (var k = 0, maxlength = that.submodules.length; k < maxlength; k++) {
var submodule = that.submodules[k];
//// set the dynamic options for module here, not the best place, chthakur move to derived module control
WinJS.UI.setOptions(submodule, that._dynamicOptions);
submodule.clusterResponse = clusterResponse;
submoduleDataPromises.push(submodule.getData(bypassCache, isInlineRefreshRequest));
}
var p = WinJS.Promise.join(that._promiseStack(submoduleDataPromises));
return p;
},
_renderSubmodules: function _renderSubmodules() {
var that = this;
var submoduleRenderPromises = [];
for (var k = 0, maxlength = that.submodules.length; k < maxlength; k++) {
var submodule = that.submodules[k];
submoduleRenderPromises.push(submodule.render());
}
return submoduleRenderPromises;
},
// In order is slow. chthakur - figure out alternative for the same
_renderSubmodulesInOrder: function _renderSubmodulesInOrder() {
var that = this;
var submoduleRenderPromises = [];
var previousRenderPromise = WinJS.Promise.wrap(true);
var delayBetweenSubmoduleRender = 10; //ms, 
for (var k = 0, maxlength = that.submodules.length; k < maxlength; k++) {
var submodule = that.submodules[k];
var currentSubmodulePromise;
// we dont need a timeout for last module. Timeout at cluster render complete would do.
var isLastSubmodule = ((k + 1) === maxlength);
var isTimeoutNeeded = !isLastSubmodule;
(function (currentSubmodule, previousSubmodulePromise, needTimeout) {
currentSubmodulePromise = new WinJS.Promise(function (complete) {
previousSubmodulePromise.then(function () {
currentSubmodule.render().then(function () {
if (needTimeout) {
that._promiseStack($SpMgr.uiThreadTimer.getUiThreadReleasePromise()).then(function () {
complete();
},
function (errRes) {
if (SportsJS.Utilities.isCancellationError(errRes)) {
// simple return, no error if the promise has been cancelled
return;
}
complete(); // this will not happen, here for sake of completeness
});
} else {
complete();
}
});
});
});
})(submodule, previousRenderPromise, isTimeoutNeeded);
previousRenderPromise = currentSubmodulePromise;
submoduleRenderPromises.push(currentSubmodulePromise);
}
return submoduleRenderPromises;
},
_onDataProviderValidResponse: function _onDataProviderValidResponse(clusterResponse, bypassCache, isInlineRefreshRequest) {
var that = this;
that._clusterDataSource = clusterResponse;
// This function is more close to consume data counterpart in modulecontrol
// register for inline refresh if required. 
// On valid response, we should re-evaluate our decision to inline refresh
// no refresh -> refresh,if we are not in inline refresh mode, registration will be reconsidered based on data
// refresh -> no refresh, if we are in inline refresh mode, the registration is re-evaluated by registerInlineRefresh() itself. 
that._registerInlineRefresh();
return that._loadModules(clusterResponse).then(function () {
if (!that.submodules || that.submodules.length === 0) {
that._trace("Couldn't load modules data");
return WinJS.Promise.wrapError();
}
return that._getSubmodulesData(clusterResponse, bypassCache, isInlineRefreshRequest);
}).then(function (submodulesData) {
that._checkForStaleResponse();
that._setResponseLastUpdateTime();
//// Attach event listeners to datarefreshed event for each submodule
var updateStalenessParametersBinding = that._getUpdateStalenessParametersBinding();
for (var k = 0, maxlength = that.submodules.length; k < maxlength; k++) {
var submodule = that.submodules[k];
submodule.element.addEventListener("datarefreshed", updateStalenessParametersBinding);
}
});
},
_fetchData: function _fetchData(bypassCache, isInlineRefreshRequest) {
var that = this;
that._traceMsProfileMarkInfo(SportsJS.UI.ProfilerMarkType.Start, SportsJS.UI.ProfilerTagType.DataFetch);
var p = new WinJS.Promise(function (complete, error) {
var isComplete = false; // we need to complete only once with progress handlers
var bypassProgress = false;
if (typeof that.dataProvider !== "function") {
that.dataProvider = function (bypassCache1, bypassProgress1) {
return WinJS.Promise.wrap(null);
};
}
var errorHandler = function (errRes) {
if (SportsJS.Utilities.isCancellationError(errRes)) {
return;
}
that._traceMsProfileMarkInfo(SportsJS.UI.ProfilerMarkType.End, SportsJS.UI.ProfilerTagType.DataFetch);
error(errRes);
};
var validResponseCompleteHandler = function () {
if (!isComplete) {
that._traceMsProfileMarkInfo(SportsJS.UI.ProfilerMarkType.End, SportsJS.UI.ProfilerTagType.DataFetch);
isComplete = true;
complete();
}
};
var dataProviderCompleteHandler = function (completeHandlerResponse) {
that._hasValidData = true;
var clusterResponse = completeHandlerResponse && completeHandlerResponse.response ? completeHandlerResponse.response : null;
if (that.dataProviderKey && completeHandlerResponse && completeHandlerResponse.response && completeHandlerResponse.response.isValid) {
SportsJS.mainProcessManager.jsCache.addObject(that.dataProviderKey, completeHandlerResponse.response, { storeToDisk: true, storageType: that._cacheDataStorageType });
}
var validResponsePromise = that._promiseStack(that._onDataProviderValidResponse(clusterResponse, bypassCache, isInlineRefreshRequest));
validResponsePromise.then(validResponseCompleteHandler, errorHandler);
};
var dataProviderProgressHandler = function (progressResponse) {
if (bypassProgress) {
return;
}
// progress here, this will only be called for non-dummy cluster data source
that._hasValidData = true;
var clusterResponse = progressResponse && progressResponse.response ? progressResponse.response : null;
if (that.dataProviderKey && progressResponse && progressResponse.response && progressResponse.response.isValid) {
SportsJS.mainProcessManager.jsCache.addObject(that.dataProviderKey, progressResponse.response, { storeToDisk: true, storageType: that._cacheDataStorageType });
}
var validResponsePromise = that._promiseStack(that._onDataProviderValidResponse(clusterResponse, bypassCache, null));
validResponsePromise.then(validResponseCompleteHandler, errorHandler);
};
var getDataFromDataProvider = function () {
var dataPromise = that._promiseStack(that.dataProvider(bypassCache, bypassProgress));
dataPromise.then(dataProviderCompleteHandler, errorHandler, dataProviderProgressHandler);
};
var memoryCacheResponseHandler = function (inMemoryResponse, requiresFetch) {
that._hasValidData = true;
var clusterResponse = inMemoryResponse && inMemoryResponse.response ? inMemoryResponse.response : null;
var validResponsePromise = that._promiseStack(that._onDataProviderValidResponse(clusterResponse, bypassCache, null));
validResponsePromise.then(function () {
if (!isComplete) {
that._traceMsProfileMarkInfo(SportsJS.UI.ProfilerMarkType.End, SportsJS.UI.ProfilerTagType.DataFetch);
isComplete = true;
bypassProgress = true;
if (requiresFetch) {
// make actual data provider call after 100ms. This call is just to update the memory cache.
that._fetchDataTimerId = setTimeout(function () {
that._fetchDataTimerId = null;
getDataFromDataProvider();
}, 500);
}
complete();
}
}, errorHandler);
};
var dataProviderKey = that.dataProviderKey;
if (bypassCache || isInlineRefreshRequest || !dataProviderKey) {
getDataFromDataProvider();
return;
}
// Check we have response in our memory cache.
// error not required. null response in case of failure
SportsJS.mainProcessManager.jsCache.getObjectAsync(dataProviderKey, { storageType: that._cacheDataStorageType }).then(function (resObject) {
if (!that._isClusterObjectValid) {
return;
}
if (!resObject || !resObject.isValid) {
getDataFromDataProvider();
return;
}
var requiresFetch = true;
if (resObject.isStaleResponse === false) {
requiresFetch = false;
}
memoryCacheResponseHandler({ response: resObject }, requiresFetch);
});
});
return p;
},
_renderCluster: function _renderCluster() {
var that = this;
that._traceMsProfileMarkInfo(SportsJS.UI.ProfilerMarkType.Start, SportsJS.UI.ProfilerTagType.Render);
var p = new WinJS.Promise(function (complete, error) {
var clusterRenderPromises = that._renderSubmodulesInOrder();
clusterRenderPromises.push(that._loadClusterTemplate());
if ($SpMgr.isPlaceholderFeatureEnabled && that.showPlaceholder) {
that._promiseStack(clusterRenderPromises);
// Cluster wont be visible till we complete the rendering. so we Complete the promise here to make the placeholder visible when we have placeholder.
// IMPACT: module render failures wont be handled.
complete();
} else {
WinJS.Promise.join(that._promiseStack(clusterRenderPromises)).then(function () {
that._traceMsProfileMarkInfo(SportsJS.UI.ProfilerMarkType.End, SportsJS.UI.ProfilerTagType.Render);
complete();
}, function (errRes) {
if (SportsJS.Utilities.isCancellationError(errRes)) {
//// simple return, no error if the promise has been cancelled.
return;
}
that._traceMsProfileMarkInfo(SportsJS.UI.ProfilerMarkType.End, SportsJS.UI.ProfilerTagType.Render);
error(errRes);
});
}
});
return p;
},
render: function render(bypassCache) {
var that = this;
var p = new WinJS.Promise(function (c, e) {
if (that.onRenderInitCallBack) {
that.onRenderInitCallBack(that, c, bypassCache);
}
else {
that._promiseStack(that.fetchAndRender(bypassCache)).then(function () {
c();
}, function () {
// complete even if it is error
c();
});
}
});
return p;
},
fetchAndRender: function fetchAndRender(bypassCache) {
var that = this;
// this is required as renderProxy is public API, We can't assume caller to cancel this after cleanup
if (!that._isClusterObjectValid) {
return WinJS.Promise.wrap(true);
}
var promise = new WinJS.Promise(function (complete, error) {
that._promiseStack(that.fetchProxy(bypassCache)).then(function (success) {
if (!success) { complete(); return; }
that._promiseStack(that.renderProxy()).then(function () {
complete();
}, function (errRes) {
if (SportsJS.Utilities.isCancellationError(errRes)) {
// simple return, no error if the promise has been cancelled
return;
}
error(errRes);
});
}, function (errRes) {
if (SportsJS.Utilities.isCancellationError(errRes)) {
// simple return, no error if the promise has been cancelled
return;
}
error(errRes);
});
});
return promise;
},
fetchProxy: function fetchProxy(bypassCache) {
var that = this;
// this is required as fetchProxy is public API, We can't assume caller to cancel this after cleanup
if (!that._isClusterObjectValid) {
return WinJS.Promise.wrap(true);
}
that._trace(SportsJS.Msg.GetDataRequestReceived);
var promise = new WinJS.Promise(function (complete) {
var fetchPromise = that._promiseStack(that._fetchData(bypassCache, null));
fetchPromise.then(function (res) {
complete(true);
}, function (errRes) {
if (SportsJS.Utilities.isCancellationError(errRes)) {
// simple return, no error if the promise has been cancelled
return;
}
that._clusterRenderFailure(complete, errRes);
});
});
return promise;
},
renderProxy: function renderProxy() {
var that = this;
// this is required as renderProxy is public API, We can't assume caller to cancel this after cleanup
if (!that._isClusterObjectValid) {
return WinJS.Promise.wrap(true);
}
var promise = new WinJS.Promise(function (complete) {
var renderPromise = that._promiseStack(that._renderCluster());
renderPromise.then(function () {
that._clusterRenderSuccess(complete);
}, function (errRes) {
if (SportsJS.Utilities.isCancellationError(errRes)) {
// simple return, no error if the promise has been cancelled
return;
}
that._clusterRenderFailure(complete, null);
});
});
return promise;
},
dataProvider: function dataProvider(bypassCache, bypassProgress) {
var that = this;
if (typeof that.processResponse !== "function" || typeof that.constructUiQuery !== "function") {
return WinJS.Promise.wrap(null);
}
var processResponseWrapper = function (sportsResponseData) {
var modelResponse = null;
// there is no reason this will fail
if (sportsResponseData && sportsResponseData.dataObject) {
modelResponse = that.processResponse(sportsResponseData.dataObject);
if (modelResponse) {
// ideally we should copy the complete sportsResponse meta. chthakur - keeping changes minimal to avoid hitting against any side effects
modelResponse.etag = sportsResponseData.etag;
modelResponse.maxAge = sportsResponseData.maxAge;
}
} else {
modelResponse = { response: null };
}
return modelResponse;
};
var promise = new WinJS.Promise(function (complete, error, progress) {
var controller = that._controller ? that._controller : AppEx.Sports.Services.SportsController();
var uiQuery = that.constructUiQuery();
if (!uiQuery) {
return SportsJS.Utilities.fallbackResponsePromise();
}
uiQuery.bypassCache = bypassCache;
that._promiseStack(controller.requestV2(uiQuery)).then(
function (res) {
var modelResponse = (res && res.dataObject) ? res.dataObject : null;
if (that._canRejectCompleteResponse(res)) {
that._updateStalenessParameters(modelResponse);
promise.cancel();
return;
}
var response = processResponseWrapper(res);
if (response) {
complete({ response: response });
}
else {
complete({ response: { data: null, isValid: false } });
}
}, function () {
}, function (progressData) {
if (that.shouldHandleProgress === false || bypassCache || bypassProgress) {
return;
}
if (progressData) {
var response = processResponseWrapper(progressData.modelResponse);
if (response) {
progress({ response: response });
}
}
});
});
return promise;
},
_registerInlineRefresh: function _registerInlineRefresh() {
var that = this;
var providerResponse = that._clusterDataSource;
// Inline refresh not required if clusterDataSource is not valid
if (that.hasClusterDataProvider === false || !providerResponse || !providerResponse.nextRefreshInterval || providerResponse.nextRefreshInterval <= 0) {
return;
}
var nextRefreshInterval = providerResponse.nextRefreshInterval;
that._clearTimer();
that._refreshTimerId = setTimeout(function () {
var bypassCache = true;
that._isInlineRefreshRequest = true;
// chthakur -> it would have been good to set the next refresh interval after completion of newer datafetch.
// fetchData dies silently on notmodified respones & all, the promise cancellation doesn't bubble up. This is not possible right now.
// keep this in mind for newer solutions
var autoRefreshEnabled = SportsJS.SettingsManager.isAutoRefreshEnabled();
if (autoRefreshEnabled) {
that._fetchData(bypassCache, that._isInlineRefreshRequest).then(function () {
// Error not used here.
}, function () {
// Error not used here.
});
}
that._registerInlineRefresh();
}, nextRefreshInterval * 1000);
},
_clusterRenderSuccess: function _clusterRenderSuccess(complete) {
var that = this;
that.element.style.visibility = 'visible';
that._makeSportsItemsNavigable();
that._onRenderComplete(true);
complete(true);
},
_clusterRenderFailure: function _clusterRenderFailure(complete, res) {
var that = this;
var clusterResponse = null;
if (!that._isClusterObjectValid) {
complete(false);
return;
}
var retryCallback = that.getClusterRetryCallback();
var errorModuleWidth = 250;
var errorModuleHeight = 250;
var errorModule = CommonJS.Error.getErrorModuleItem(retryCallback, errorModuleWidth + "px", errorModuleHeight + "px");
if (errorModule) {
WinJS.UI.Fragments.renderCopy(errorModule.moduleInfo.fragmentPath).then(function (errorModuleFragment) {
if (errorModuleFragment) {
var errorModuleTemplate = errorModuleFragment.querySelector("#" + errorModule.moduleInfo.templateId);
if (errorModuleTemplate) {
//// Since height and width are variable, need to be set through js
errorModuleTemplate.style.height = errorModule.moduleInfo.height;
errorModuleTemplate.style.width = errorModule.moduleInfo.width;
// if offline hide retry, update the error message and re-position it in the center
if (!SportsJS.Networking.isInternetAvailable) {
errorModule.errorContainerClassName += " sportsErrorModuleOffline";
errorModule.message = PlatformJS.Services.resourceLoader.getString("NoDataInOfflineText");
var retryButton = errorModuleTemplate.querySelector('.platformRetryButton');
retryButton.style.display = "none";
var message = errorModuleTemplate.querySelector('.platformErrorMessage');
WinJS.Utilities.addClass(message, "sportsErrorMessageOffline");
}
WinJS.Binding.processAll(errorModuleTemplate, errorModule);
//// For the clusters which insert modules programmatically, we can just remove them
//// as they will be inserted again when getData gets called on retry.
//// For the clusters which insert modules declaratively, we need to hide the modules and show them on retry.
//// Will call getModuleConfigs to find if this cluster inserts modules programatically
if (that.submodules && that.submodules.length > 0) {
var isDeclarative = false;
var profileMark = "Sports:getModuleConfigs";
SportsJS.Utilities.sportsMsWriteProfilerMark(profileMark + ":s");
that._promiseStack(that.getModuleConfigs(clusterResponse)).then(function (moduleConfigs) {
SportsJS.Utilities.sportsMsWriteProfilerMark(profileMark + ":e");
if (moduleConfigs.length === 0) {
isDeclarative = true;
}
for (var i = 0; i < that.submodules.length; i++) {
var submoduleElement = that.submodules[i].element;
if (isDeclarative) {
submoduleElement.style.display = "none";
}
else {
try {
that.element.removeChild(submoduleElement);
} catch (e) {
// do not worry if submodule is already removed
}
}
}
//// For clusters which insert modules programmatically,
//// we need to clear the submodules array as getData call reinserts them
if (!isDeclarative) {
that.submodules = [];
}
}, function () {
//// nothing to do here
});
}
that.element.style.visibility = 'visible';
that.element.innerHTML = '';
that.element.appendChild(errorModuleTemplate);
that._onRenderComplete(false);
}
}
});
}
that._makeSportsItemsNavigable();
complete(false);
},
getModuleConfigs: function getModuleConfigs(clusterResponse) {
// TODO: chthakur to remove once migration to new structure is complete
//"getModuleConfigs should be defined in derived page class"
return WinJS.Promise.wrap({});
},
_loadClusterTemplate: function _loadClusterTemplate() {
var that = this;
var p = new WinJS.Promise(function (complete, error) {
if (!that._fragmentPath || !that.templateId) {
complete();
return;
}
var moduleInfo = {
fragmentPath: that._fragmentPath,
templateId: that.templateId,
};
CommonJS.loadModule(moduleInfo, that, that.element, null, null).then(function (clusterTemplate) {
if (clusterTemplate) {
complete();
}
else {
error();
}
},
function () {
error();
});
});
return p;
},
// This function will load the module control inside fragmentPath provider.
// TODO: chthakur, merge this with getdata once we migrate to cluster and module configs
_loadModules: function _loadModules(clusterResponse) {
var that = this;
if (that._hasSubmodulesLoaded && that.submodules.length > 0) {
// we do not support adding modules on the fly. 
// progress && complete expected to have same number of modules
// TODO: chthakur, can we add support?
return WinJS.Promise.wrap(true);
}
//// creating a heading div parallel to modules' div, which satisfies the cluster level div's accessibility
var clusterHeaderElement = SportsJS.Utilities.createDiv("sports_cluster_header", "heading", "Sports Cluster");
that.element.appendChild(clusterHeaderElement);
var p = new WinJS.Promise(function (complete) {
that._promiseStack(that.getModuleConfigs(clusterResponse)).then(function (moduleConfigs) {
var promises = [];
// push all modules to nbe loaded into the array
for (var j = 0, max = moduleConfigs.length; j < max; j++) {
promises.push(WinJS.UI.Fragments.cache(moduleConfigs[j].moduleInfo.fragmentPath));
}
// load all modules. TODO: merge with getdata above. Waiting on all promises to complete will go away
WinJS.Promise.join(promises).then(function (moduleFragments) {
if (!that._isClusterObjectValid) {
return;
}
for (var i = 0; i < moduleFragments.length; i++) {
var moduleFragment = moduleFragments[i];
if (moduleFragment) {
if (moduleConfigs[i].moduleInfo.control) {
var moduleControl = PlatformJS.Utilities.createObject(moduleConfigs[i].moduleInfo.control, null, moduleConfigs[i]);
if (!moduleControl || !moduleControl.element) {
that._trace("Couldn't load module fragment " + moduleConfigs[i].moduleInfo.fragmentPath);
continue;
}
var moduleElement = moduleControl.element;
WinJS.Utilities.addClass(moduleElement, "moduleFragmentWrapper");
if (moduleConfigs[i].className) {
WinJS.Utilities.addClass(moduleElement, moduleConfigs[i].className);
}
if (moduleControl && (moduleControl instanceof SportsJS.UI.SportsModule)) {
//TODO: chthakur, this is just to support legacy, will go away. HACK
moduleControl.fragmentObject = moduleFragment;
////TODO: chthakur - finalize if setting options from here is ok
WinJS.UI.setOptions(moduleControl, moduleConfigs[i]);
that.element.appendChild(moduleElement);
that.submodules.push(moduleControl);
}
}
}
else {
that._trace("Couldn't load module fragment " + moduleConfigs[i].moduleInfo.fragmentPath);
}
}
that._hasSubmodulesLoaded = true;
complete(true);
});
}, function (errRes) {
if (SportsJS.Utilities.isCancellationError(errRes)) {
// simple return, no error if the promise has been cancelled
return;
}
that._clusterRenderFailure(complete, null);
});
});
return p;
},
// make specific cluster elemnts with css class 'sportsNavigableItem' applied, cross cluster navigable
_makeSportsItemsNavigable: function _makeSportsItemsNavigable() {
var that = this;
var processNavigableItems = function () {
if (!that._isClusterObjectValid) {
return;
}
that._clusterNavigableItems = that.element.querySelectorAll(".sportsNavigableItem");
if (!that._clusterNavigableItems || that._clusterNavigableItems.length <= 0) {
return;
}
// add keydown event to all queried items
var index = 0;
var maxCount = that._clusterNavigableItems.length;
while (index < maxCount) {
that._clusterNavigableItems[index].addEventListener("keydown", that._sportsItemNavigationCallback, true);
index++;
}
};
that._msSetImmediateIdentifierList.push(msSetImmediate(processNavigableItems));
},
// callback for keydown events on navigable cluster items
_sportsItemNavigationCallback: function _sportsItemNavigationCallback(e) {
var that = this;
if (!e || !e.keyCode || !e.srcElement) {
return;
}
// move the focus to appropriate neighbor cluster
if (e.keyCode === WinJS.Utilities.Key.rightArrow) {
CommonJS.NavigableView.dispatchBoundaryEvent(e.srcElement, CommonJS.NavigableView.Direction.RIGHT);
e.stopPropagation();
}
else if (e.keyCode === WinJS.Utilities.Key.leftArrow) {
CommonJS.NavigableView.dispatchBoundaryEvent(e.srcElement, CommonJS.NavigableView.Direction.LEFT);
e.stopPropagation();
}
},
// Key used for JsCache
dataProviderKey: {
get: function get() {
var that = this, key;
if (typeof that.constructUiQuery !== "function") {
return null;
}
var uiQuery = that.constructUiQuery();
if (uiQuery && uiQuery.isValid && that.id) {
key = AppEx.Sports.Services.SportsController.getUrl(uiQuery);
key = key + "&clusterId=" + that.id;
}
return key;
}
},
_clearTimer: function _clearTimer() {
var that = this;
if (that._refreshTimerId) {
clearTimeout(that._refreshTimerId);
that._refreshTimerId = null;
}
if (that._fetchDataTimerId) {
clearTimeout(that._fetchDataTimerId);
}
},
cleanUp: function cleanUp(isNavigating) {
var that = this;
if (that._isClusterObjectValid === true) {
that._clearTimer();
if (that._msSetImmediateIdentifierList && that._msSetImmediateIdentifierList.length > 0) {
for (var i = 0; i < that._msSetImmediateIdentifierList.length; i++) {
msClearImmediate(that._msSetImmediateIdentifierList[i]);
}
}
if (that._clusterNavigableItems && that._clusterNavigableItems.length > 0) {
for (var j = 0; j < that._clusterNavigableItems.length; j++) {
that._clusterNavigableItems[j].removeEventListener("keydown", that._sportsItemNavigationCallback, true);
}
}
SportsJS.Utilities.cancelPromiseArray(this._dataPromiseStack);
if (that.submodules) {
var updateStalenessParametersBinding = that._getUpdateStalenessParametersBinding();
for (var k = 0, maxlength = that.submodules.length; k < maxlength; k++) {
var submodule = that.submodules[k];
submodule.element.removeEventListener("datarefreshed", updateStalenessParametersBinding);
submodule.cleanUp(isNavigating);
}
}
if (!isNavigating) {
that.element.innerHTML = "";
}
this._trace('cluster cleanup called');
SportsJS.Utilities.setObjectPropertiesToNull(that);
that._isClusterObjectValid = false;
}
},
_onDataLoadComplete: function _onDataLoadComplete() {
//TODO(chthakur) - implement
},
_onRenderComplete: function _onRenderComplete(isRenderSuccess) {
this._traceMsProfileMarkInfo(SportsJS.UI.ProfilerMarkType.End, null);
if (this.onRenderCompleteCallerCallBack) {
this.onRenderCompleteCallerCallBack(isRenderSuccess);
}
},
//// private functions
_trace: function _trace(text) {
SportsJS.Utilities.trace(this, "SportsJS.UI.SportsCluster:" + this._fragmentPath + ":" + this.title, text);
},
// fn -> is used when profiling a specific function. if function name is not specified, then
// this means the overall cluster loading is being traced
_traceMsProfileMarkInfo: function _traceMsProfileMarkInfo(markType, fn) {
/* TODO(chthakur): verify and fix if sending "none" is not sufficient.
The profile marks on the page will help know the page type.
Getting pageType is not straightforward. Verify with test if this is sufficient */
var info = {
markType: markType ? markType : null,
entityType: SportsJS.UI.ProfilerEntityType.Cluster,
sports: this._leagueType,
page: SportsJS.UI.PageType.None,
cluster: this.clusterType,
func: fn ? fn : null
};
SportsJS.Utilities.sportsMsWriteProfilerMark(info);
},
_clear: function _clear() {
this._domElement.innerHTML = '';
},
/// <summary>
/// This function returns the error module retry callback for clusters
/// </summary>
getClusterRetryCallback: function getClusterRetryCallback() {
var that = this;
var retryCallback = function () {
//// For the clusters which insert modules declaratively,
//// we will need to show them
if (that.submodules.length > 0) {
for (var i = 0; i < that.submodules.length; i++) {
var submoduleElement = that.submodules[i].element;
submoduleElement.style.display = "block";
}
}
that.cleanUpErrorTemplate();
var bypassCache = true;
that.render(bypassCache);
};
return WinJS.Utilities.markSupportedForProcessing(retryCallback);
},
cleanUpErrorTemplate: function cleanUpErrorTemplate() {
var that = this;
var errorModuleTemplate = that.element.querySelector("#platformErrorModule");
if (errorModuleTemplate) {
/// TODO(saarya): we might want to fade this out. Check with sdrolia
that.element.removeChild(errorModuleTemplate);
}
},
// All the promises which we want to cancel on cleanUp should be wrapped in this function
// so that we can cancel them on cleanup
// data promise stack
_promiseStack: function _promiseStack(promise) {
var that = this;
if (!promise) {
return promise;
}
if (that._isClusterObjectValid) {
that._dataPromiseStack = that._dataPromiseStack.concat(SportsJS.Utilities.createPromiseArrayCopy(promise));
} else {
if (Array.isArray(promise)) {
SportsJS.Utilities.cancelPromiseArray(promise);
}
else {
SportsJS.Utilities.cancelPromise(promise);
}
}
return promise;
},
_checkForStaleResponse: function _checkForStaleResponse() {
var that = this;
if (!that.submodules) {
return;
}
that.isStaleResponse = false;
for (var k = 0, maxlength = that.submodules.length; k < maxlength; k++) {
var submodule = that.submodules[k];
if (submodule.providerResponse
&& submodule.providerResponse.isStaleResponse) {
that.isStaleResponse = true;
return;
}
}
},
_setResponseLastUpdateTime: function _setResponseLastUpdateTime() {
var that = this;
if (!that.submodules) {
return;
}
that.lastUpdateTime = new Date();
for (var k = 0, maxlength = that.submodules.length; k < maxlength; k++) {
var submodule = that.submodules[k];
if (submodule.providerResponse
&& submodule.providerResponse.lastUpdateTime
&& submodule.providerResponse.lastUpdateTime < that.lastUpdateTime) {
that.lastUpdateTime = submodule.providerResponse.lastUpdateTime;
}
}
},
// These are options which are calculated from data
_dynamicOptions: null,
onRenderCompleteCallerCallBack: null,
id: null,
_updateStalenessParametersBinding: null,
_getUpdateStalenessParametersBinding: function _getUpdateStalenessParametersBinding() {
var that = this;
if (!that._updateStalenessParametersBinding) {
that._updateStalenessParametersBinding = that._updateStalenessParameters.bind(that);
}
return that._updateStalenessParametersBinding;
},
_updateStalenessParameters: function _updateStalenessParameters(event) {
var that = this;
var wasStaleResponse = that.isStaleResponse;
if (event && event.type === "datarefreshed") {
// submodule generated event
that._checkForStaleResponse();
that._setResponseLastUpdateTime();
} else if (that._clusterDataSource && event && event.isValid && event.lastUpdateTime instanceof Date && typeof event.isStaleResponse !== "undefined") {
// event is actually the newer cluster response
that.lastUpdateTime = event.lastUpdateTime;
that.isStaleResponse = event.isStaleResponse;
} else {
return;
}
if (wasStaleResponse && !that.isStaleResponse) {
var eventObject = document.createEvent("CustomEvent");
eventObject.initCustomEvent("datarefreshed", true, true, null);
this.element.dispatchEvent(eventObject);
}
},
_hasValidData: false,
// Used to reject the new response
// 1. Either the control already has same response. Based on same hashCode
// 2. Or the control already has a valid response and the newer response is invalid
_canRejectCompleteResponse: function _canRejectCompleteResponse(res) {
var that = this;
// if no old respone, just can't reject
if (!that._clusterDataSource || !that._hasValidData || that._clusterDataSource.isValid === false) {
return false;
}
// we are here coz, old response is valid
// check if newer response is invalid then reject
if (!res || res.isValid === false) {
return true;
}
// if has new valid response, verify the required interface
// Throw exception if required and return can't reject
if (!res.etag || !res.lastUpdateTime || !that._clusterDataSource.etag || !that._clusterDataSource.lastUpdateTime) {
SportsJS.Utilities.interfaceException("SportsJS.ClusterControl:_canRejectCompleteResponse", "interface violation in _canRejectCompleteResponse");
return false;
}
var canReject = false;
var currentResponseEtag = that._clusterDataSource.etag;
var newResponseEtag = res.etag;
canReject = (currentResponseEtag === newResponseEtag);
// if has cache
var dataProviderKey = that.dataProviderKey;
if (dataProviderKey) {
// update the cache Expiries in case response is rejected
var tsDiff = res.lastUpdateTime.getTime() - that._clusterDataSource.lastUpdateTime.getTime();
if (canReject && tsDiff > 0) {
$SpMgr.jsCache.updateObjectExpiry(dataProviderKey, res, { storeToDisk: true, storageType: that._cacheDataStorageType });
}
}
return canReject;
},
}),
});
})();
