﻿(function () {
"use strict";
// Keep all common clusters config here in this namespaces
WinJS.Namespace.define("SportsJS.Cluster.Configs.Common",
{
// List cluster 
listCluster: function listCluster(league, notUsed, configParams) {
var config = SportsJS.Cluster.Configs.Common.genericCluster(league, notUsed, configParams);
config.clusterContent.contentOptions.model.modelControlConfig.queryOptions.scenario = AppEx.Sports.Services.TypeDefs.Request.UiScenarioEnum.listCluster;
return config;
},
// mixed list cluster
mixedListCluster: function mixedListCluster(league, notUsed, configParams) {
var config = SportsJS.Cluster.Configs.Common.genericCluster(league, notUsed, configParams);
config.clusterContent.contentOptions.model.modelControlConfig.queryOptions.scenario = AppEx.Sports.Services.TypeDefs.Request.UiScenarioEnum.mixedListCluster;
return config;
},
// Generic cluster with default model and controller and endpoint query
genericCluster: function genericCluster(league, notUsed, configParams) {
var modelConfig = {
modelControl: "SportsJS.Controls.Models.ClusterDataModel",
modelControlConfig: {
query: AppEx.Sports.Services.TypeDefs.Request.EndpointQuery,
queryOptions: {
league: league,
endpoint: configParams.requestEndpoint,
refreshFrequency: configParams.refreshFrequency,
requestParams: configParams.requestParams,
scenario: "",
date: ""
}
}
};
var config = {
clusterKey: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
clusterTitle: SportsJS.Utilities.getClusterTitleFromConfigParams(configParams),
onHeaderSelection: SportsJS.Utilities.getClusterTitleUriHandlerFromConfigParams(configParams),
clusterContent: {
contentControl: "SportsJS.Controls.Cluster.ClusterController",
contentOptions: {
league: league,
fragmentPath: "/SportsCommonControls/core/ClusterController.html",
model: modelConfig,
telemetryId: configParams.id,
telemetryName: SportsJS.Utilities.getClusterTitleFromConfigParams(configParams),
id: SportsJS.Utilities.getClusterIdFromConfigParams(configParams)
}
}
};
return config;
},
myTeams: function myTeams(leagueType, pageType) {
var config = {
//// ClusterKey will be used for positioning clusters. The casing is CamelCase
clusterKey: "Cluster50",
clusterTitle: pageType === SportsJS.UI.PageType.MyTeams ? " " : PlatformJS.Services.resourceLoader.getString("MyTeams"),
onHeaderSelection: pageType === SportsJS.UI.PageType.MyTeams ? null : function () {
var that = this;
PlatformJS.Navigation.navigateToChannel('MyTeams');
},
clusterContent: {
contentControl: "SportsJS.Common.Clusters.MyTeamsClusterControl",
contentOptions: {
id: SportsJS.UI.ClusterType.MyTeams,
leagueType: leagueType,
pageType: pageType,
fragmentPath: "/leagues/common/clusters/MyTeamsCluster/MyTeamsCluster.html",
}
}
};      
return config;
},
myLeagues: function myLeagues(leagueType, pageType) {
var config = {
//// ClusterKey will be used for positioning clusters. The casing is CamelCase
clusterKey: "Cluster51",
clusterTitle: PlatformJS.Services.resourceLoader.getString("FavoriteSportsClusterTitle"),
onHeaderSelection: function onHeaderSelection() {
var that = this;
PlatformJS.Navigation.navigateToChannel(SportsJS.UI.PageType.AllSports);
},
clusterContent:  {
contentControl: "SportsJS.Common.Clusters.PassThroughClusterControl",
contentOptions: {
id: SportsJS.UI.ClusterType.MyLeagues,
league: leagueType,
leagueType: leagueType,
pageType: pageType,
className: "MyLeaguesCluster",
fragmentPath: "/leagues/common/clusters/PassThroughCluster/PassThroughCluster.html",
modulesConfig: ["SportsJS.Modules.Configs.Common.myLeaguesModule"],
}
}
};
return config;
},
//TODO: chthakur - check with salem if we need to ads increment counter here
adsClusterConfig: function adsClusterConfig(league, notUsed, configParams) {
if (!configParams || !configParams.configOptions || !configParams.configOptions.AdUnitId || !configParams.configOptions.AdsType) {
return null;
}
var adUnitId = configParams.configOptions.AdUnitId;
var adType = configParams.configOptions.AdsType;
var adOptions = SportsJS.Utilities.deepCopyJsObject(configParams.configOptions);
var config = {
clusterId: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
clusterKey: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
clusterTitle: PlatformJS.Services.resourceLoader.getString("/platform/advertisement"),
supressTitleInHeader: true,
clusterContent: {
contentControl: "PlatformJS.Ads.AdsWrapperControl",
contentOptions: {
className: adType,
adUnitId: adUnitId,
otherAdOptions: adOptions
}
}
};
return config;
},
allSports: function allSports(leagueType) {
var config = {
//// ClusterKey will be used for positioning clusters. The casing is CamelCase
clusterKey: "Cluster50",
clusterTitle: "",
clusterContent: {
contentControl: "SportsJS.Common.Clusters.PassThroughClusterControl",
contentOptions: {
id: SportsJS.UI.ClusterType.AllSports,
league: leagueType,
leagueType: leagueType,
isEditable: false,
fragmentPath: "/leagues/common/clusters/PassThroughCluster/PassThroughCluster.html",
modulesConfig: ["SportsJS.Modules.Configs.Common.allSportsModule"],
}
}
};
return config;
},
snapSchedule: function snapSchedule(league, currentDate) {
var config = {
clusterKey: "snapScheduleCluster",
clusterTitle: "Not required", /*This doesnn't get displayed, so localization is not required*/
clusterContent: {
contentControl: "SportsJS.Common.Clusters.SnapScheduleClusterControl",
contentOptions: {
league: league,
currentDate: currentDate,
id: SportsJS.UI.ClusterType.TodaySchedule,
className: "snapScheduleCluster"
},
}
};
return config;
},
news: function news(league, queryPromise, totalNews) {
var config = {
clusterKey: "Cluster05",
clusterTitle: PlatformJS.Services.resourceLoader.getString("CategoryNewsClusterTitle"),
clusterContent: {
contentControl: "SportsJS.Common.Clusters.NewsClusterControl",
contentOptions: {
id: SportsJS.UI.ClusterType.News,
league: league,
totalNews: totalNews,
queryPromise: queryPromise,
fragmentPath: "/leagues/common/clusters/NewsCluster/NewsCluster.html",
}
}
};
return config;
},
categoryNewsCluster: function categoryNewsCluster(league, args, configParams, maxnewscolumns, disableClickthrough) {
var todayNewsType = SportsJS.Utilities.getNewsTypeForPage(SportsJS.UI.PageType.Today);
if (!todayNewsType) {
return;
}
var maxcolumns = maxnewscolumns ? maxnewscolumns : 4;
var queryType, queryParams, count;
if (todayNewsType.value === SportsJS.UI.NewsType.rss) {
queryType = $SpMgr.cmsPreviewEnabled ? "RSSNewsNoCache" : "RSSNews";
queryParams = { type: SportsJS.UI.EntityType.Today, league: "today", query: "sports" };
count = 30;
return SportsJS.Cluster.Configs.Common.newsCommonCluster(queryType, league, queryParams, count, maxcolumns, disableClickthrough);
}
else if (todayNewsType.value === SportsJS.UI.NewsType.bingcategory) {
queryType = $SpMgr.cmsPreviewEnabled ? "SportsNewsByCategoryNoCache" : "SportsNewsByCategory";
queryParams = { type: SportsJS.UI.EntityType.Today, league: "today", query: "sports" };
count = 30;
return SportsJS.Cluster.Configs.Common.newsCommonCluster(queryType, league, queryParams, count, maxcolumns, disableClickthrough);
}
else {
return;
}
},
leagueNewsCluster: function leagueNewsCluster(league, args, configParams, maxnewscolumns, disableClickthrough) {
if (!league && configParams && configParams.configOptions && configParams.configOptions.leagueType) {
league = configParams.configOptions.leagueType;
}            
var leagueNewsType = SportsJS.Utilities.getNewsTypeForPage(SportsJS.UI.PageType.League);
if (!leagueNewsType) {
return;
}
var maxcolumns = maxnewscolumns ? maxnewscolumns : 4;
if (configParams && configParams.configOptions && configParams.configOptions.NewsQueryType === SportsJS.UI.NewsType.bingquery) { //only possible value is bingquery or disabled
var query = league;
if (configParams.configOptions.NewsQuery) {
query = configParams.configOptions.NewsQuery;
}
var queryType = $SpMgr.cmsPreviewEnabled ? "SportsNewsByQueryNoCache" : "SportsNewsByQuery";
var queryParams = { type: SportsJS.UI.EntityType.League, league: league, query: query };
var count = 30;
var newsAdConfig = SportsJS.Cluster.Configs.Common.getNewsAdConfig(league, SportsJS.UI.PageType.League);
return SportsJS.Cluster.Configs.Common.newsCommonCluster(queryType, league, queryParams, count, maxcolumns, disableClickthrough, newsAdConfig.adsEnabled, newsAdConfig.adUnitId, configParams);
}
else {
return;
}
},
teamNewsCluster: function teamNewsCluster(league, args, configParams, maxnewscolumns, disableClickthrough) {
if (!league || !configParams) {
return;
}
var maxcolumns = maxnewscolumns ? maxnewscolumns : 4;
if (configParams && configParams.configOptions && configParams.configOptions.NewsQueryType === SportsJS.UI.NewsType.bingquery) {
var queryType = $SpMgr.cmsPreviewEnabled ? "SportsTeamNewsByQueryNoCache" : "SportsTeamNewsByQuery";
// duplicating leagueName to be consistent with c# query
var query = SportsJS.Utilities.sanitizeNewsQuery(configParams.configOptions.NewsQuery);
var queryParams = { type: SportsJS.UI.EntityType.Team, league: league, query: query, leagueName: league };
var count = 30;
var newsAdConfig = SportsJS.Cluster.Configs.Common.getNewsAdConfig(league, SportsJS.UI.PageType.Team);
return SportsJS.Cluster.Configs.Common.newsCommonCluster(queryType, league, queryParams, count, maxcolumns, disableClickthrough, newsAdConfig.adsEnabled, newsAdConfig.adUnitId);
}
else {
return;
}
},
getNewsAdConfig: function getNewsAdConfig(league, pageType) {
var newsAdConfig = PlatformJS.Services.appConfig.getDictionary("NewsAds");
var adsEnabled = false;
var adUnitId = "";
if (pageType === SportsJS.UI.PageType.League) {
newsAdConfig = newsAdConfig ? newsAdConfig.LeagueAdsConfig : null;
}
else if (pageType === SportsJS.UI.PageType.Team) {
newsAdConfig = newsAdConfig ? newsAdConfig.TeamAdsConfig : null;
}
if (newsAdConfig) {
var pageNewsAdsConfig = newsAdConfig[league];
if (pageNewsAdsConfig) {
adsEnabled = pageNewsAdsConfig.LeagueNewsClusterAdEnabled.value ? true : false;
adUnitId = pageNewsAdsConfig.AdUnitID ? pageNewsAdsConfig.AdUnitID.value : "";
}
}
return { adsEnabled: adsEnabled, adUnitId: adUnitId };
},
playerNewsCluster: function playerNewsCluster(league, args, configParams, maxnewscolumns, disableClickthrough) {
if (!league || !configParams) {
return;
}
var maxcolumns = maxnewscolumns ? maxnewscolumns : 3;
if (configParams && configParams.configOptions && configParams.configOptions.NewsQueryType === SportsJS.UI.NewsType.bingquery) {
var queryType = $SpMgr.cmsPreviewEnabled ? "SportsNewsByQueryNoCache" : "SportsNewsByQuery";
var queryParams = { type: SportsJS.UI.EntityType.Player, league: league, query: configParams.configOptions.NewsQuery };
var count = 30;
return SportsJS.Cluster.Configs.Common.newsCommonCluster(queryType, league, queryParams, count, maxcolumns, disableClickthrough);
}
else {
return;
}
},
newsCommonCluster: function newsCommonCluster(queryType, league, queryParams, count, maxcolumns, disableClickthrough, adsEnabled, addUnitId, configParams) {
var lang = AppEx.Sports.Services.Utilities.Globalization.getCurrentMarket().toLowerCase();
var shouldHandleProgress = true;
maxcolumns = maxcolumns ? maxcolumns : 3;
var clusterTitle = null;
if (configParams && configParams.title && configParams.title.text) {
clusterTitle = SportsJS.Utilities.getClusterTitleFromConfigParams(configParams);
}
var clusterKey = "Cluster05";
if (configParams && configParams.id) {
clusterKey = SportsJS.Utilities.getClusterIdFromConfigParams(configParams);
}
clusterTitle = clusterTitle ? clusterTitle : PlatformJS.Services.resourceLoader.getString("CategoryNewsClusterTitle");
var config = {
clusterKey: clusterKey,
clusterTitle: disableClickthrough === true ? "" : clusterTitle,
clusterContent: {
contentControl: "SportsJS.News.NewsCluster",
contentOptions: {
id: SportsJS.UI.ClusterType.News,
mode: CommonJS.News.ClusterMode.dynamic,
provider: new SportsJS.News.NewsProvider(queryType, queryParams, maxcolumns, shouldHandleProgress),
startingAd: adsEnabled,
adUnitId: adsEnabled ? addUnitId : "",
newsQuery: {
query: "",
market: lang,
category: "rt_sports",
count: count ? count : 30,
sortByDate: true
},
onitemclick: SportsJS.News.NewsCluster.itemClickHandler,
onrendercomplete: null,
noResultsMessage: PlatformJS.Services.resourceLoader.getString("NoNewsText"),
maxColumnCount: maxcolumns,
configKey: "EntityClusterDefaultFinanceSportsConfig",
configObject: CommonJS.News.EntityClusterConfig.DefaultFinanceSports,
theme: "sportsAppTheme",
telemetry: {
getCurrentImpression: function getCurrentImpression() {
return PlatformJS.Navigation.mainNavigator.getCurrentImpression();
}
}
}
},
onHeaderSelection: disableClickthrough === true ? null : function () {
PlatformJS.Navigation.navigateToChannel('News', {
type: SportsJS.UI.NewsType.bingcategory,
league: league,
entity: queryParams.type,
id: queryParams.query,
query: queryParams.query
});
}
};
return config;
},
magazineCluster: function magazineCluster(leagueName, entityType, entityId) {
var lang = AppEx.Sports.Services.Utilities.Globalization.getCurrentMarket().toLowerCase();
var shouldHandleProgress = true;
var maxcolumns = null;
var config = {
clusterKey: "Cluster06",
clusterTitle: PlatformJS.Services.resourceLoader.getString("MagazineClusterTitle"),
clusterContent: {
contentControl: "SportsJS.Common.EditorialCollection.EditorialCollectionCluster",
contentOptions: {
id: SportsJS.UI.ClusterType.Magazine,
mode: CommonJS.News.ClusterMode.dynamic,
provider: new SportsJS.Magazine.MagazineClusterProvider(leagueName, entityType, entityId, maxcolumns, shouldHandleProgress),
queryServiceId: $SpMgr.cmsPreviewEnabled ? "MagazinePreviewDataSource" : "MagazineDataSource",
onitemclick: SportsJS.Common.EditorialCollection.EditorialCollectionCluster.itemClickHandler,
maxColumnCount: maxcolumns,
configKey: "EntityClusterDefaultFinanceSportsConfig",
configObject: CommonJS.News.EntityClusterConfig.DefaultFinanceSports,
theme: "sportsAppTheme", // TODO:saurabkh define theme after redlines
telemetry: {
getCurrentImpression: function getCurrentImpression() {
return PlatformJS.Navigation.mainNavigator.getCurrentImpression();
}
}
}
}
};
return config;
},
leagueVideoCluster: function leagueVideoCluster(league, args, configParams) {
if (!league && configParams && configParams.configOptions && configParams.configOptions.leagueType) {
league = configParams.configOptions.leagueType;
}
var isLeagueVideosEnabled = PlatformJS.Services.appConfig.getBool("EnableLeagueVideosCluster");
if (!isLeagueVideosEnabled) {
return null;
}           
return SportsJS.Cluster.Configs.Common.videoCluster(league, SportsJS.UI.EntityType.League, null, configParams);
},
videoCluster: function videoCluster(leagueName, entityType, entityId, configParams) {
var clusterTitle = null;
if (configParams && configParams.title && configParams.title.text) {
clusterTitle = SportsJS.Utilities.getClusterTitleFromConfigParams(configParams);
}
clusterTitle = clusterTitle ? clusterTitle : PlatformJS.Services.resourceLoader.getString("VideoClusterLabel");
var shouldHandleProgress = true;
var maxcolumns = 3;
var clusterKey = "Cluster07";
if (configParams && configParams.id) {
clusterKey = SportsJS.Utilities.getClusterIdFromConfigParams(configParams);
}
var config = {
clusterKey: clusterKey,
clusterTitle: clusterTitle,
clusterContent: {
contentControl: "SportsJS.Common.EditorialCollection.EditorialCollectionCluster",
contentOptions: {
id: SportsJS.UI.ClusterType.Video,
mode: CommonJS.News.ClusterMode.dynamic,
provider: new SportsJS.Video.VideoClusterProvider(leagueName, entityType, entityId, maxcolumns, shouldHandleProgress),
maxColumnCount: maxcolumns,
configKey: "EntityClusterDefaultFinanceSportsConfig",
configObject: CommonJS.News.EntityClusterConfig.DefaultFinanceSports,
theme: "sportsAppTheme",
telemetry: {
getCurrentImpression: function getCurrentImpression() {
return PlatformJS.Navigation.mainNavigator.getCurrentImpression();
}
}
}
},
onHeaderSelection: function onHeaderSelection() {
PlatformJS.Navigation.navigateToChannel('Video', {
leagueName: leagueName,
editorialCollectionType: AppEx.Sports.Services.TypeDefs.EditorialCollectionType.videos,
entityType: entityType,
});
}                
};            
return config;
},
dynamicEditorialCollectionCluster: function dynamicEditorialCollectionCluster(league, notUsed, configParams) {
if (!configParams) {
return;
}
configParams.maxcolumns = typeof configParams.maxcolumns !== 'undefined' ? configParams.maxcolumns : 3;
configParams.shouldHandleProgress = typeof configParams.shouldHandleProgress !== 'undefined' ? configParams.shouldHandleProgress : true;
var config = {
clusterKey: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
clusterTitle: SportsJS.Utilities.getClusterTitleFromConfigParams(configParams),
clusterContent: {
contentControl: "SportsJS.Common.EditorialCollection.EditorialCollectionCluster",
contentOptions: {
id: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
mode: CommonJS.News.ClusterMode.dynamic,
provider: new SportsJS.Common.EditorialCollection.DynamicEditorialCollectionClusterProvider(league, configParams),
onitemclick: SportsJS.Common.EditorialCollection.EditorialCollectionCluster.itemClickHandler,
maxColumnCount: configParams.maxcolumns,
configKey: "EntityClusterDefaultFinanceSportsConfig",
configObject: CommonJS.News.EntityClusterConfig.DefaultFinanceSports,
theme: "sportsAppTheme",
telemetry: {
getCurrentImpression: function getCurrentImpression() {
return PlatformJS.Navigation.mainNavigator.getCurrentImpression();
}
}
}
},
onHeaderSelection: SportsJS.Utilities.getClusterTitleUriHandlerFromConfigParams(configParams)
};
return config;
},
leagueHeadlinesCluster: function leagueHeadlinesCluster(league) {
var isLeagueHeadlinesEnabled = SportsJS.Utilities.IsLeagueHeadlinesEnabled();
if (!isLeagueHeadlinesEnabled) {
return null;
}
return SportsJS.Cluster.Configs.Common.headlinesCluster(league, SportsJS.UI.EntityType.League);
},
headlinesCluster: function headlineCluster(leagueName, entityType) {
var config = {
clusterKey: "Cluster21",
clusterTitle: PlatformJS.Services.resourceLoader.getString("HeadlinesClusterTitle"),
clusterContent: {
contentControl: "SportsJS.Common.Clusters.HeadlinesClusterControl",
contentOptions: {
id: SportsJS.UI.ClusterType.Headlines,
leagueName: leagueName,
entityType: entityType,
fragmentPath: "/leagues/common/clusters/HeadlinesCluster/HeadlinesCluster.html"
},
}
};
return config;
},
cmsHeroClusterToday: function cmsHeroClusterToday() {
var heroSetting = SportsJS.Utilities.getHeroClusterSetting(SportsJS.UI.PageType.Today);
if (heroSetting !== SportsJS.UI.HeroType.disabled) {
return SportsJS.Cluster.Configs.Common.cmsHeroCluster("league", "today", heroSetting);
}
return;
},
cmsHeroClusterHome: function cmsHeroClusterHome(league, sports, configParams) {
var heroSetting = configParams && configParams.heroType;
if (heroSetting !== SportsJS.UI.HeroType.disabled) {
return SportsJS.Cluster.Configs.Common.cmsHeroCluster("league", league, heroSetting);
}
return;
},
cmsHeroClusterTeam: function cmsHeroClusterTeam(league, args, configParams) {
if (!league || !configParams || !configParams.entityId) {
return;
}
var teamId = configParams.entityId;
var heroSetting = configParams && configParams.heroType;
if (heroSetting !== SportsJS.UI.HeroType.disabled) {
var heroCluster = SportsJS.Cluster.Configs.Common.cmsHeroCluster("team", league + "_" + teamId, heroSetting, league, teamId);
//Pull out the hero summary type
heroCluster.clusterContent.contentOptions.heroSummaryType = configParams.requestKvPairs && configParams.requestKvPairs["heroSummaryType"] ? configParams.requestKvPairs["heroSummaryType"] : "";
return heroCluster;
}
return;
},
cmsHeroCluster: function cmsHeroCluster(type, key, heroSetting, league, teamId) {
var that = this;
var config = {
clusterPosition: 1,
clusterKey: "Cluster00",
clusterTitle: "",
titleClass: "headerFontLight",
hideTitle: true,
isSticky: true,
clusterContent: {
contentControl: "SportsJS.Common.SportsHeroControl",
contentOptions: {
id: SportsJS.UI.ClusterType.Hero,
league: league ? league : key,
teamId: teamId ? teamId : "",
className: "sportsHeroClusterCmsLayout",
fragmentPath: "/leagues/common/Hero/heroImageOverlay.html",
imageSize: {
width: 1190,
height: 768
},
showGradient: true,
herotype: type,
herokey: key,
heroSetting: heroSetting,
heroSummaryType: "",
}
},
};
return config;
},
leagueLeadingPlayers: function leagueLeadingPlayers(league, conference, configParams) {
var clusterTitle = SportsJS.Utilities.getClusterTitleFromConfigParams(configParams);
if (configParams) {
league = configParams.leagueType;
conference = configParams.conference;
}
conference = conference || "";
var config = {
clusterKey: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
clusterTitle: clusterTitle,
clusterContent: {
contentControl: "SportsJS.Common.Clusters.PassThroughClusterControl",
contentOptions: {
id: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
league: league,
showPlaceholder: false,
conference: conference,
className: "LeadingPlayersCluster",
fragmentPath: "/leagues/common/clusters/PassThroughCluster/PassThroughCluster.html",
modulesConfig: ["SportsJS.Modules.Configs.Common.leagueLeadingPlayers"],
configParams: configParams
}
},
onHeaderSelection: SportsJS.Utilities.getClusterTitleUriHandlerFromConfigParams(configParams)
};
return config;
},
leagueLeadingTeams: function leagueLeadingTeams(leagueType, conference, configParams) {
var clusterTitle = SportsJS.Utilities.getClusterTitleFromConfigParams(configParams);
if (configParams) {
leagueType = configParams.leagueType;
conference = configParams.conference;
}
conference = conference || "";
var config = {
clusterKey: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
clusterTitle: clusterTitle,
clusterContent: {
contentControl: "SportsJS.Common.Clusters.PassThroughClusterControl",
contentOptions: {
fragmentPath: "/leagues/common/clusters/PassThroughCluster/PassThroughCluster.html",
league: leagueType,
id: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
conference: conference,
showPlaceholder: false,
className: "LeadingTeamsCluster",
modulesConfig: ["SportsJS.Modules.Configs.Common.leagueLeadingTeams"],
configParams: configParams
}
},
onHeaderSelection: SportsJS.Utilities.getClusterTitleUriHandlerFromConfigParams(configParams)
};
return config;
},
leagueSchedule: function leagueSchedule(league, notUsed, configParams) {
var clusterTitle = SportsJS.Utilities.getClusterTitleFromConfigParams(configParams);
if (configParams) {
league = configParams.leagueType;
}
var config = {
clusterKey: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
clusterTitle: clusterTitle,
clusterContent: {
contentControl: "SportsJS.Common.Clusters.LeagueScheduleClusterControl",
contentOptions: {
id: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
className: "sportsMultilineVerticallyStackedCluster",
league: league,
fragmentPath: "/leagues/common/clusters/LeagueScheduleCluster/LeagueScheduleCluster.html",
query: league,
modulesConfig: ["SportsJS.Modules.Configs.Common.leagueSchedule"],
configParams: configParams,
isInteractive: configParams.isInteractive,
}
},
onHeaderSelection: SportsJS.Utilities.getClusterTitleUriHandlerFromConfigParams(configParams)
};
return config;
},
noImageLeagueSchedule: function noImageLeagueSchedule(league, notUsed, configParams) {
configParams.showLogos = false;
return SportsJS.Cluster.Configs.Common.leagueSchedule(league, notUsed, configParams);
},
ResultsOnlyLeagueSchedule: function ResultsOnlyLeagueSchedule(league, notUsed, configParams) {
configParams.scheduleView = Microsoft.AppEx.Sports.Schemas.TypeDefs.ScheduleView.resultsOnly;
var config = SportsJS.Cluster.Configs.Common.leagueSchedule(league, notUsed, configParams);
return config;
},
FixturesOnlyLeagueSchedule: function FixturesOnlyLeagueSchedule(league, notUsed, configParams) {
configParams.scheduleView = Microsoft.AppEx.Sports.Schemas.TypeDefs.ScheduleView.fixturesOnly;
var config = SportsJS.Cluster.Configs.Common.leagueSchedule(league, notUsed, configParams);
return config;
},
teamRoster: function teamRoster(league, args, configParams) {
if (!league || !configParams || !configParams.entityId) {
return;
}
var clusterTitle = SportsJS.Utilities.getClusterTitleFromConfigParams(configParams);
var teamId = configParams.entityId;
var config = {
//// ClusterKey will be used for positioning clusters. The casing is CamelCase
clusterKey: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
clusterTitle: clusterTitle,
clusterContent: {
contentControl: "SportsJS.Common.Clusters.PassThroughClusterControl",
contentOptions: {
teamId: teamId,
league: league,
showPlaceholder: true,
ecvLeagueClass: SportsJS.Utilities.ECV.getLeagueClass(league),
className: "teamRosterWrapper",
id: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
fragmentPath: "/leagues/common/clusters/PassThroughCluster/PassThroughCluster.html",
modulesConfig: ["SportsJS.Modules.Configs.Common.teamRoster"]
}
},
onHeaderSelection: SportsJS.Utilities.getClusterTitleUriHandlerFromConfigParams(configParams)
};
return config;
},
teamStats: function teamStats(league, notUsed, configParams) {
if (!league || !configParams || !configParams.entityId) {
return;
}
var teamId = configParams.entityId;
var clusterTitle = SportsJS.Utilities.getClusterTitleFromConfigParams(configParams);
var config = {
//// ClusterKey will be used for positioning clusters. The casing is CamelCase
clusterKey: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
clusterTitle: clusterTitle,
clusterContent: {
contentControl: "SportsJS.Common.Clusters.PassThroughClusterControl",
contentOptions: {
teamId: teamId,
league: league,
id: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
showPlaceholder: true,
className: "teamStatsCluster",
fragmentPath: "/leagues/common/clusters/PassThroughCluster/PassThroughCluster.html",
modulesConfig: ["SportsJS.Modules.Configs.Common.teamStats"]
}
}
};
return config;
},
matchTeamStats: function matchTeamStats(league, notUsed, configParams) {
//// TODO(saarya) PreGame is not supported right now
if (!configParams || configParams.type === "PreGame") {
return null;
}
var matchTeamStatsModelConfig = {
modelControl: "SportsJS.Controls.Models.ClusterDataModel",
modelControlConfig: {
query: AppEx.Sports.Services.TypeDefs.Request.MatchTeamStatsQuery,
queryOptions: {
leagueName: league,
matchId: configParams.entityId,
}
}
};
var config = {
clusterKey: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
clusterTitle: configParams.title.text,
clusterContent: {
contentControl: "SportsJS.Controls.Cluster.ClusterController",
contentOptions: {
fragmentPath: "/SportsCommonControls/core/ClusterController.html",
model: matchTeamStatsModelConfig,
}
}
};
return config;
},
teamSingleStats: function teamSingleStats(league, notUsed, configParams) {
if (!league || !configParams || !configParams.entityId) {
return;
}
var teamId = configParams.entityId;
var clusterTitle = SportsJS.Utilities.getClusterTitleFromConfigParams(configParams);
var config = {
clusterKey: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
clusterTitle: clusterTitle,
clusterContent: {
contentControl: "SportsJS.Common.Clusters.PassThroughClusterControl",
contentOptions:
{
teamId: teamId,
league: league,
id: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
showPlaceholder: true,
className: "teamSingleStatsCluster",
fragmentPath: "/leagues/common/clusters/PassThroughCluster/PassThroughCluster.html",
modulesConfig: ["SportsJS.Modules.Configs.Common.teamSingleStats"]
}
}
};
return config;
},
teamLeaders: function teamLeaders(league, notUsed, configParams) {
if (!league || !configParams || !configParams.entityId) {
return;
}
var teamId = configParams.entityId;
var leadersType = configParams && configParams.leadersType ? configParams.leadersType : "";
var clusterTitle = SportsJS.Utilities.getClusterTitleFromConfigParams(configParams);
var config = {
//// ClusterKey will be used for positioning clusters. The casing is CamelCase
clusterKey: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
clusterTitle: clusterTitle,
clusterContent: {
contentControl: "SportsJS.Common.Clusters.PassThroughClusterControl",
contentOptions: {
teamId: teamId,
league: league,
leadersType: leadersType,
id: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
showPlaceholder: true,
className: "teamLeadersCluster",
fragmentPath: "/leagues/common/clusters/PassThroughCluster/PassThroughCluster.html",
modulesConfig: ["SportsJS.Modules.Configs.Common.teamLeaders"]
}
}
};
return config;
},
teamSchedule: function teamSchedule(league, notUsed, configParams) {
if (!league || !configParams || !configParams.entityId) {
return;
}
var teamId = configParams.entityId;
var type = configParams && configParams.requestKvPairs ? configParams.requestKvPairs.type : null;
var clusterTitle = SportsJS.Utilities.getClusterTitleFromConfigParams(configParams);
var showLogos = SportsJS.Utilities.checkLogosAvailabilityParam(configParams);
var config = {
clusterKey: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
clusterTitle: clusterTitle,
clusterContent: {
contentControl: "SportsJS.Common.Clusters.PassThroughClusterControl",
contentOptions: {
showLogos: showLogos,
teamId: teamId,
league: league,
showPlaceholder: true,
// TODO - chthakur - requires fix in middle tier - EXTENSIBILITY BUG
gameCount: Microsoft.AppEx.Sports.SportsEnums.League[league] === Microsoft.AppEx.Sports.SportsEnums.League.mlb ? 15 : 0,
type: type,
id: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
className: "teamScheduleCluster",
fragmentPath: "/leagues/common/clusters/PassThroughCluster/PassThroughCluster.html",
modulesConfig: ["SportsJS.Modules.Configs.Common.teamSchedule"],
isInteractive: configParams.isInteractive,
}
}
};
return config;
},
noImageTeamSchedule: function noImageTeamSchedule(league, notUsed, configParams) {
if (!league || !configParams || !configParams.entityId) {
return null;
}
var teamId = configParams.entityId;
configParams.showLogos = false;
return SportsJS.Cluster.Configs.Common.teamSchedule(league, notUsed, configParams);
},
playerBio: function playerBio(league, args, configParams) {
if (!league || !configParams || !configParams.entityId) {
return;
}
var playerId = configParams.entityId;
var config = {
clusterKey: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
clusterTitle: SportsJS.Utilities.getClusterTitleFromConfigParams(configParams),
clusterContent: {
contentControl: "SportsJS.Common.Clusters.PlayerBioClusterControl",
contentOptions: {
playerId: playerId,
league: league,
className: "sportsClusterVerticallyStackedLayout sportsNoTheme",
id: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
fragmentPath: "/leagues/common/clusters/PlayerBioCluster/PlayerBioCluster.html",
}
}
};
return config;
},
playerComparison: function playerComparison(league, notUsed, configParams) {
if (!league || !configParams || !configParams.entityId) {
return;
}
var playerId = configParams.entityId;
var config = {
clusterKey: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
clusterTitle: SportsJS.Utilities.getClusterTitleFromConfigParams(configParams),
clusterContent: {
contentControl: "SportsJS.Common.Clusters.PlayerComparisonClusterControl",
contentOptions: {
playerId: playerId,
league: league,
className: "playerComparisonClusterWrapper sportsNoTheme",
id: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
fragmentPath: "/leagues/common/clusters/PlayerComparisonCluster/PlayerComparisonCluster.html",
}
}
};
return config;
},
noImageLeagueLeadingPlayers: function noImageLeagueLeadingPlayers(league, notUsed, configParams) {
return SportsJS.Cluster.Configs.Common.noImageLeadingPlayers(league, null, configParams);
},
noImageNoECVLeagueLeadingPlayers: function noImageNoECVLeagueLeadingPlayers(league, notUsed, configParams) {
configParams.isItemClickEnabled = false;
return SportsJS.Cluster.Configs.Common.noImageLeadingPlayers(league, null, configParams);
},
noImageTeamLeadingPlayers: function noImageTeamLeadingPlayers(league, notUsed, configParams) {
if (!league || !configParams || !configParams.entityId) {
return;
}
var teamId = configParams.entityId;
return SportsJS.Cluster.Configs.Common.noImageLeadingPlayers(league, teamId, configParams);
},
noImageLeadingPlayers: function noImageLeadingPlayers(league, teamId, configParams) {
var entityType;
var conference;
if (teamId !== null) {
entityType = SportsJS.UI.EntityType.Team;
}
else {
entityType = SportsJS.UI.EntityType.League;
}
if (configParams) {
conference = configParams.conference;
}
var config;
config = {
clusterKey: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
clusterTitle: SportsJS.Utilities.getClusterTitleFromConfigParams(configParams),
clusterContent: {
contentControl: "SportsJS.Common.Clusters.PassThroughClusterControl",
contentOptions: {
fragmentPath: "/leagues/common/clusters/PassThroughCluster/PassThroughCluster.html",
league: league,
teamId: teamId,
entityType: entityType,
conference: conference,
showPlaceholder: true,
isItemClickEnabled: configParams.isItemClickEnabled,
ecvLeagueClass: SportsJS.Utilities.ECV.getLeagueClass(league),
id: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
className: "LeadingTeamsCluster",
modulesConfig: ["SportsJS.Modules.Configs.Common.noImageLeadingEntities"]
}
},
onHeaderSelection: SportsJS.Utilities.getClusterTitleUriHandlerFromConfigParams(configParams)
};
return config;
},
RaceResultTable: function RaceResultTable(league, notUsed, configParams) {
var config = {
clusterKey: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
clusterTitle: SportsJS.Utilities.getClusterTitleFromConfigParams(configParams),
clusterContent: {
contentControl: "SportsJS.Common.Clusters.PassThroughClusterControl",
contentOptions: {
fragmentPath: "/leagues/common/clusters/PassThroughCluster/PassThroughCluster.html",
league: league,
id: league + SportsJS.UI.ClusterType.RaceResultTable,
className: "RaceResultTableCluster",
modulesConfig: ["SportsJS.Modules.Configs.Common.sportsTable"],
usesItemsContainer: true,
showPlaceholder: true,
tableSize: SportsJS.UI.TableSize.Medium
}
},
};
return config;
},
LeagueScheduleTable: function LeagueScheduleTable(league, notUsed, configParams) {
var year = configParams && configParams.year ? configParams.year : "";
var config = {
clusterKey: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
clusterTitle: SportsJS.Utilities.getClusterTitleFromConfigParams(configParams),
clusterContent: {
contentControl: "SportsJS.Common.Clusters.PassThroughClusterControl",
contentOptions: {
fragmentPath: "/leagues/common/clusters/PassThroughCluster/PassThroughCluster.html",
league: league,
id: league + SportsJS.UI.ClusterType.LeagueScheduleTable,
className: "SportsTableLeagueScheduleCluster",
modulesConfig: ["SportsJS.Modules.Configs.Common.sportsTable"],
usesItemsContainer: true,
showPlaceholder: true,
tableSize: SportsJS.UI.TableSize.Medium
}
},
};
return config;
},
DriverStandingsTable: function DriverStandingsTable(league, notUsed, configParams) {
var year = configParams && configParams.year ? configParams.year : "";
var config = {
clusterKey: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
clusterTitle: SportsJS.Utilities.getClusterTitleFromConfigParams(configParams),
clusterContent: {
contentControl: "SportsJS.Common.Clusters.PassThroughClusterControl",
contentOptions: {
fragmentPath: "/leagues/common/clusters/PassThroughCluster/PassThroughCluster.html",
league: league,
id: league + SportsJS.UI.ClusterType.DriverStandingsTable,
className: "SportsTableDriverStandingCluster",
modulesConfig: ["SportsJS.Modules.Configs.Common.sportsTable"],
usesItemsContainer: true,
showPlaceholder: true,
tableSize: SportsJS.UI.TableSize.Medium,
hasImage: true
}
},
};
return config;
},
TableRoster: function TableRoster(league, args, configParams) {
if (!league || !configParams || !configParams.entityId) {
return;
}
var teamId = configParams.entityId;
var config = {
clusterKey: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
clusterTitle: SportsJS.Utilities.getClusterTitleFromConfigParams(configParams),
clusterContent: {
contentControl: "SportsJS.Common.Clusters.PassThroughClusterControl",
contentOptions: {
fragmentPath: "/leagues/common/clusters/PassThroughCluster/PassThroughCluster.html",
league: league,
teamId: teamId,
id: league + SportsJS.UI.ClusterType.TableRoster,
className: "SportsTableRosterCluster",
modulesConfig: ["SportsJS.Modules.Configs.Common.sportsTable"],
usesItemsContainer: true,
showPlaceholder: true,
tableSize: SportsJS.UI.TableSize.Medium
}
},
};
return config;
},
TeamStandingsTable: function TeamStandingsTable(league, notUsed, configParams) {
var year = configParams && configParams.year ? configParams.year : "";
var division = configParams && configParams.division ? configParams.division : null;
var isItemClickEnabled = false;
var tableSize = SportsJS.UI.TableSize.Medium;
var usesItemsContainer = true;
var hasImage = SportsJS.Utilities.checkLogosAvailabilityParam(configParams);
if (SportsJS.Utilities.isLeagueSoccerType(league)) {
isItemClickEnabled = true;
usesItemsContainer = true;
tableSize = SportsJS.UI.TableSize.Large;
}
var config = {
clusterKey: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
clusterTitle: SportsJS.Utilities.getClusterTitleFromConfigParams(configParams),
clusterContent: {
contentControl: "SportsJS.Common.Clusters.PassThroughClusterControl",
contentOptions: {
fragmentPath: "/leagues/common/clusters/PassThroughCluster/PassThroughCluster.html",
league: league,
id: league + SportsJS.UI.ClusterType.TeamStandingsTable,
className: "SportsTableTeamStandingsCluster",
modulesConfig: ["SportsJS.Modules.Configs.Common.sportsTable"],
isItemClickEnabled: isItemClickEnabled,
usesItemsContainer: usesItemsContainer,
conference: division,
hasImage: hasImage,
showPlaceholder: true,
tableSize: tableSize
}
},
};
return config;
},
noImageTeamStandingsTable: function noImageTeamStandingsTable(league, notUsed, configParams) {
configParams.showLogos = false;
return SportsJS.Cluster.Configs.Common.TeamStandingsTable(league, notUsed, configParams);
},
noImageLeagueLeadingTeams: function noImageLeagueLeadingTeams(league, conference, configParams) {
if (configParams) {
league = configParams.leagueType;
conference = configParams.conference;
}
conference = conference || "";
var config = {
clusterKey: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
clusterTitle: SportsJS.Utilities.getClusterTitleFromConfigParams(configParams),
clusterContent: {
contentControl: "SportsJS.Common.Clusters.PassThroughClusterControl",
contentOptions: {
fragmentPath: "/leagues/common/clusters/PassThroughCluster/PassThroughCluster.html",
league: league,
id: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
showPlaceholder: true,
className: "noImageLeadingTeamsCluster",
entityType: "teams",
modulesConfig: ["SportsJS.Modules.Configs.Common.noImageLeadingEntities"]
}
},
onHeaderSelection: SportsJS.Utilities.getClusterTitleUriHandlerFromConfigParams(configParams),
};
return config;
},
ScrollableStandingsList: function ScrollableStandingsList(league, notUsed, configParams) {
var year = configParams && configParams.year ? configParams.year : "";
var config = {
clusterKey: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
clusterTitle: SportsJS.Utilities.getClusterTitleFromConfigParams(configParams),
clusterContent: {
contentControl: "SportsJS.Common.Clusters.PassThroughClusterControl",
contentOptions: {
fragmentPath: "/leagues/common/clusters/PassThroughCluster/PassThroughCluster.html",
league: league,
id: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
className: "ScrollableStandingsListCluster",
modulesConfig: ["SportsJS.Modules.Configs.Common.ScrollableStandingsList"]
}
},
};
return config;
},
leaderBoard: function leaderBoard(league, unUsed, configParams) {
var config = {
clusterKey: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
clusterTitle: SportsJS.Utilities.getClusterTitleFromConfigParams(configParams),
clusterContent: {
contentControl: "SportsJS.Common.Clusters.LeaderBoardClusterControl",
contentOptions: {
league: league,
id: league + SportsJS.UI.ClusterType.LeaderBoardCluster,
className: "leaderBoardMultilineVerticallyStacked",
fragmentPath: "/leagues/common/clusters/LeaderBoardCluster/LeaderBoardCluster.html",
usesItemsContainer: true,
}
}
};
return config;
},
teamDivisionStandings: function teamDivisionStandings(league, notUsed, configParams) {
var teamDivisionStandingsModelConfig = {
modelControl: "SportsJS.Controls.Models.ClusterDataModel",
modelControlConfig: {
query: AppEx.Sports.Services.TypeDefs.Request.DivisionStandingsQuery,
queryOptions: {
leagueName: league,
teamId: configParams.entityId
}
}
};
var config = {
clusterKey: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
clusterTitle: SportsJS.Utilities.getClusterTitleFromConfigParams(configParams),
onHeaderSelection: SportsJS.Utilities.getClusterTitleUriHandlerFromConfigParams(configParams),
clusterContent: {
contentControl: "SportsJS.Controls.Cluster.ClusterController",
contentOptions: {
league: league,
fragmentPath: "/SportsCommonControls/core/ClusterController.html",
model: teamDivisionStandingsModelConfig,
}
}
};
return config;
},
leagueStandings: function leagueStandings(league, notUsed, configParams) {
var config = {
clusterKey: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
clusterTitle: SportsJS.Utilities.getClusterTitleFromConfigParams(configParams),
onHeaderSelection: SportsJS.Utilities.getClusterTitleUriHandlerFromConfigParams(configParams),
clusterContent: {
contentControl: "SportsJS.Common.Clusters.StandingsClusterControl",
contentOptions: {
league: league,
id: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
showPlaceholder: true,
conference1: PlatformJS.Services.resourceLoader.getString(SportsJS.Utilities.stringProperCase(league) + "FirstConference"),
subtitle1: PlatformJS.Services.resourceLoader.getString(SportsJS.Utilities.stringProperCase(league) + "FirstFullConference"),
conference2: PlatformJS.Services.resourceLoader.getString(SportsJS.Utilities.stringProperCase(league) + "SecondConference"),
subtitle2: PlatformJS.Services.resourceLoader.getString(SportsJS.Utilities.stringProperCase(league) + "SecondFullConference"),
fragmentPath: "/leagues/common/clusters/StandingsCluster/StandingsCluster.html",
templateId: "clusterTemplate",
className: "StandingsCommonCluster"
}
}
};
return config;
},
leagueStandingsSingleDivision: function leagueStandingsSingleDivision(league, notUsed, configParams) {
var config = {
clusterKey: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
clusterTitle: SportsJS.Utilities.getClusterTitleFromConfigParams(configParams),
onHeaderSelection: SportsJS.Utilities.getClusterTitleUriHandlerFromConfigParams(configParams),
clusterContent: {
contentControl: "SportsJS.Common.Clusters.StandingsClusterControl",
contentOptions: {
league: league,
id: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
showPlaceholder: true,
conference1: PlatformJS.Services.resourceLoader.getString(SportsJS.Utilities.stringProperCase(league) + "FirstConference"),
subtitle1: PlatformJS.Services.resourceLoader.getString(SportsJS.Utilities.stringProperCase(league) + "FirstFullConference"),
conference2: PlatformJS.Services.resourceLoader.getString(SportsJS.Utilities.stringProperCase(league) + "SecondConference"),
subtitle2: PlatformJS.Services.resourceLoader.getString(SportsJS.Utilities.stringProperCase(league) + "SecondFullConference"),
fragmentPath: "/leagues/common/clusters/StandingsCluster/StandingsCluster.html",
templateId: "clusterTemplate",
className: "StandingsSingleDivisionCluster"
}
}
};
return config;
},
editorialCollectionPageCluster: function editorialCollectionPageCluster(cluster, clusterIndex, editorialCollectionType, leagueName, entityType) {
if (!cluster || typeof cluster.clusterTitle === 'undefined' || !cluster.dataSet || typeof clusterIndex === 'undefined') {
return null;
}
var isPreviewRecap = editorialCollectionType === AppEx.Sports.Services.TypeDefs.EditorialCollectionType.preview || editorialCollectionType === AppEx.Sports.Services.TypeDefs.EditorialCollectionType.recap;
clusterIndex = clusterIndex.toString();
clusterIndex = clusterIndex.length === 1 ? "0" + clusterIndex : clusterIndex;
var config = {
clusterKey: "Cluster" + clusterIndex,
clusterTitle: cluster.clusterTitle,
clusterContent: {
contentControl: "CommonJS.News.EntityCluster",
contentOptions: {
id: SportsJS.UI.ClusterType.News,
mode: CommonJS.News.ClusterMode.static,
dataSet: cluster.dataSet,
onitemclick: SportsJS.Common.EditorialCollection.EditorialCollectionPage.itemClickHandler,
onrendercomplete: null,
configObject: isPreviewRecap ? CommonJS.News.EntityClusterConfig.PreviewRecap : CommonJS.News.EntityClusterConfig.DefaultFinanceSports,
theme: "sportsAppTheme",
telemetry: {
getCurrentImpression: function getCurrentImpression() {
return PlatformJS.Navigation.mainNavigator.getCurrentImpression();
}
}
}
},
};
var entityClusterAdFrequency = PlatformJS.Services.appConfig.getInt32("EntityClusterAdFrequency");
var adClusterId = entityType && entityType !== SportsJS.UI.EntityType.Today && leagueName ? (entityType + leagueName).toLowerCase() : null;
var currentPageAdConfig = PlatformJS.Ads.getAdsConfig(adClusterId);
if (entityClusterAdFrequency && currentPageAdConfig) {
var contentOptions = config.clusterContent.contentOptions;
contentOptions.subclusterAdFrequency = 1;
contentOptions.adUnitId = currentPageAdConfig.adUnitId;
contentOptions.marginDistance = entityClusterAdFrequency;
contentOptions.marginWidth = 5;
}
return config;
},
leagueRankings: function leagueRankings(league, notUsed, configParams) {
var leagueRankingsModelConfig = {
modelControl: "SportsJS.Controls.Models.ClusterDataModel",
modelControlConfig: {
query: AppEx.Sports.Services.TypeDefs.Request.LeagueRankingsQuery,
queryOptions: {
leagueName: league
}
}
};
var config = {
clusterKey: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
clusterTitle: SportsJS.Utilities.getClusterTitleFromConfigParams(configParams),
clusterContent: {
contentControl: "SportsJS.Controls.Cluster.ClusterController",
contentOptions: {
fragmentPath: "/SportsCommonControls/core/ClusterController.html",
model: leagueRankingsModelConfig,
}
}
};
return config;
},
leagueDetailedResults: function leagueDetailedResults(league, notUsed, configParams) {
var modelConfig = {
modelControl: "SportsJS.Controls.Models.ClusterDataModel",
modelControlConfig: {
query: AppEx.Sports.Services.TypeDefs.Request.LeagueResultsQuery,
queryOptions: {
leagueName: league
}
}
};
var config = {
//// ClusterKey will be used for positioning clusters. The casing is CamelCase
clusterKey: "Cluster30",
clusterTitle: SportsJS.Utilities.getClusterTitleFromConfigParams(configParams),
clusterContent: {
contentControl: "SportsJS.Controls.Cluster.ClusterController",
contentOptions: {
fragmentPath: "/SportsCommonControls/core/ClusterController.html",
model: modelConfig,
}
}
};
return config;
},
matchBoxScore: function matchBoxScore(league, notUsed, configParams) {
//// TODO(saarya) PreGame is not supported right now
if (!configParams || configParams.type === "PreGame") {
return null;
}
var matchBoxScoreModelConfig = {
modelControl: "SportsJS.Controls.Models.ClusterDataModel",
modelControlConfig: {
query: AppEx.Sports.Services.TypeDefs.Request.MatchBoxScoreQuery,
queryOptions: {
leagueName: league,
matchId: configParams.entityId,
teamType: configParams.teamType,
}
}
};
var config = {
clusterKey: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
clusterTitle: SportsJS.Utilities.getClusterTitleFromConfigParams(configParams),
clusterContent: {
contentControl: "SportsJS.Controls.Cluster.ClusterController",
contentOptions: {
fragmentPath: "/SportsCommonControls/core/ClusterController.html",
model: matchBoxScoreModelConfig,
}
}
};
return config;
},
matchOverview: function matchOverview(league, notUsed, configParams) {
if (!configParams) {
return null;
}
var matchOverviewModelConfig = {
modelControl: "SportsJS.Controls.Models.ClusterDataModel",
modelControlConfig: {
query: AppEx.Sports.Services.TypeDefs.Request.MatchOverviewQuery,
queryOptions: {
leagueName: league,
matchId: configParams.entityId,
}
}
};
var config = {
clusterKey: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
clusterTitle: configParams.title.text,
clusterContent: {
contentControl: "SportsJS.Controls.Cluster.ClusterController",
contentOptions: {
fragmentPath: "/SportsCommonControls/core/ClusterController.html",
model: matchOverviewModelConfig,
}
}
};
return config;
},
////TODO(chthakur): Get rid of this once we have the listCluster
matchOverviewPreGame: function matchOverviewPreGame(league, notUsed, configParams) {
if (!configParams) {
return null;
}
var matchOverviewModelConfig = {
modelControl: "SportsJS.Controls.Models.ClusterDataModel",
modelControlConfig: {
query: AppEx.Sports.Services.TypeDefs.Request.MatchOverviewPreGameQuery,
queryOptions: {
leagueName: league,
matchId: configParams.entityId,
homeTeamId: configParams.homeTeamId,
visitingTeamId: configParams.visitingTeamId,
}
}
};
var config = {
clusterKey: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
clusterTitle: configParams.title.text,
clusterContent: {
contentControl: "SportsJS.Controls.Cluster.ClusterController",
contentOptions: {
fragmentPath: "/SportsCommonControls/core/ClusterController.html",
model: matchOverviewModelConfig,
}
}
};
return config;
},
teamConferenceStandings: function teamConferenceStandings(league, notUsed, configParams) {
var teamConferenceStandingsModelConfig = {
modelControl: "SportsJS.Controls.Models.ClusterDataModel",
modelControlConfig: {
query: AppEx.Sports.Services.TypeDefs.Request.TeamConferenceStandingsQuery,
queryOptions: {
leagueName: league,
teamId: configParams.entityId
}
}
};
var config = {
clusterKey: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
clusterTitle: SportsJS.Utilities.getClusterTitleFromConfigParams(configParams),
clusterContent: {
contentControl: "SportsJS.Controls.Cluster.ClusterController",
contentOptions: {
fragmentPath: "/SportsCommonControls/core/ClusterController.html",
model: teamConferenceStandingsModelConfig,
}
}
};
return config;
},
groupStandings: function groupStandings(league, notUsed, configParams) {
var gameType = "";
if (configParams && configParams.gametype) {
gameType = configParams.gametype;
}
var teamId = "";
if (configParams && configParams.entityType === "Team") {
teamId = configParams.entityId;
}
var modelConfig = {
modelControl: "SportsJS.Controls.Models.ClusterDataModel",
modelControlConfig: {
query: AppEx.Sports.Services.TypeDefs.Request.GroupStandingsQuery,
queryOptions: {
leagueName: league,
gameType: gameType,
teamId: teamId
}
}
};
var config = {
clusterKey: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
clusterTitle: SportsJS.Utilities.getClusterTitleFromConfigParams(configParams),
onHeaderSelection: SportsJS.Utilities.getClusterTitleUriHandlerFromConfigParams(configParams),
clusterContent: {
contentControl: "SportsJS.Controls.Cluster.ClusterController",
contentOptions: {
fragmentPath: "/SportsCommonControls/core/ClusterController.html",
model: modelConfig,
}
}
};
return config;
},
tournamentSchedule: function tournamentSchedule(league, unUsed, configParams) {
var modelConfig = {
modelControl: "SportsJS.Controls.Models.ClusterDataModel",
modelControlConfig: {
query: AppEx.Sports.Services.TypeDefs.Request.TournamentScheduleQuery,
queryOptions: {
leagueName: league
}
}
};
var config = {
clusterKey: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
clusterTitle: SportsJS.Utilities.getClusterTitleFromConfigParams(configParams),
clusterContent: {
contentControl: "SportsJS.Controls.Cluster.ClusterController",
contentOptions: {
fragmentPath: "/SportsCommonControls/core/ClusterController.html",
model: modelConfig,
}
}
};
return config;
},
leadingPlayersTable: function leadingPlayersTable(league, notUsed, configParams) {
var modelConfig = {
modelControl: "SportsJS.Controls.Models.ClusterDataModel",
modelControlConfig: {
query: AppEx.Sports.Services.TypeDefs.Request.LeadingPlayersQuery,
queryOptions: {
leagueName: league,
organization: configParams.organization
}
}
};
var config = {
clusterKey: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
clusterTitle: SportsJS.Utilities.getClusterTitleFromConfigParams(configParams),
clusterContent: {
contentControl: "SportsJS.Controls.Cluster.ClusterController",
contentOptions: {
fragmentPath: "/SportsCommonControls/core/ClusterController.html",
model: modelConfig,
}
}
};
return config;
},
liveScoresTable: function liveScoresTable(league, notUsed, configParams) {
var modelConfig = {
modelControl: "SportsJS.Controls.Models.ClusterDataModel",
modelControlConfig: {
query: AppEx.Sports.Services.TypeDefs.Request.LiveScoresTableQuery,
queryOptions: {
leagueName: league,
eventType: configParams.eventType,
eventId: configParams.eventId
}
}
};
var config = {
clusterKey: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
clusterTitle: SportsJS.Utilities.getClusterTitleFromConfigParams(configParams),
clusterContent: {
contentControl: "SportsJS.Controls.Cluster.ClusterController",
contentOptions: {
fragmentPath: "/SportsCommonControls/core/ClusterController.html",
model: modelConfig,
}
}
};
return config;
},
allSportsV2: function allSportsV2(league) {
var isFreOffline = SportsJS.Utilities.isFirstRunOfflineExperience();
var modelConfig = {
modelControl: "SportsJS.Controls.Models.ClusterDataModel",
modelControlConfig: {
query: AppEx.Sports.Services.TypeDefs.Request.AllSportsQuery,
queryOptions: {
leagueName: league,
isFreOffline: isFreOffline
}
}
};
var config = {
clusterKey: "Cluster20",
clusterTitle: PlatformJS.Services.resourceLoader.getString("AllSportsClusterTitle"),
clusterContent: {
contentControl: "SportsJS.Controls.Cluster.ClusterController",
contentOptions: {
fragmentPath: "/SportsCommonControls/core/ClusterController.html",
model: modelConfig,
clusterType: "allSportsV2"
}
}
};
return config;
},
topLeagues: function topLeagues(league) {
var modelConfig = {
modelControl: "SportsJS.Controls.Models.ClusterDataModel",
modelControlConfig: {
query: AppEx.Sports.Services.TypeDefs.Request.TopLeaguesQuery,
queryOptions: {
leagueName: league,
}
}
};
var config = {
clusterKey: "Cluster10",
clusterTitle: PlatformJS.Services.resourceLoader.getString("TopLeaguesClusterTitle"),
clusterContent: {
contentControl: "SportsJS.Controls.Cluster.ClusterController",
contentOptions: {
fragmentPath: "/SportsCommonControls/core/ClusterController.html",
model: modelConfig,
clusterType: "topLeagues"
}
}
};
return config;
},
matchPreviewRecapCluster: function matchPreviewRecapCluster(league, notused, configParams) {
if (!league || !configParams) {
return;
}
configParams.maxcolumns = typeof configParams.maxcolumns !== 'undefined' ? configParams.maxcolumns : 3;
configParams.shouldHandleProgress = typeof configParams.shouldHandleProgress !== 'undefined' ? configParams.shouldHandleProgress : true;
configParams.editorialCollectionType = AppEx.Sports.Services.Utils.getEditorialCollectionType(configParams.editorialCollectionType);
var config = {
clusterKey: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
clusterTitle: SportsJS.Utilities.getClusterTitleFromConfigParams(configParams),
clusterContent: {
contentControl: "SportsJS.Common.EditorialCollection.EditorialCollectionCluster",
contentOptions: {
id: SportsJS.UI.ClusterType.MatchPreviewRecap,
mode: CommonJS.News.ClusterMode.dynamic,
provider: new SportsJS.MatchPreviewRecap.MatchPreviewRecapClusterProvider(league, configParams),
configObject: CommonJS.News.EntityClusterConfig.PreviewRecap,
onitemclick: SportsJS.Common.EditorialCollection.EditorialCollectionCluster.itemClickHandler,
theme: "sportsAppTheme",
}
},
};
return config;
},
leagueCalendar: function leagueCalendar(league, notUsed, configParams) {
var modelConfig = {
modelControl: "SportsJS.Controls.Models.ClusterDataModel",
modelControlConfig: {
query: AppEx.Sports.Services.TypeDefs.Request.LeagueCalendarQuery,
queryOptions: {
leagueName: league
}
}
};
var config = {
clusterKey: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
clusterTitle: SportsJS.Utilities.getClusterTitleFromConfigParams(configParams),
clusterContent: {
contentControl: "SportsJS.Controls.Cluster.ClusterController",
contentOptions: {
fragmentPath: "/SportsCommonControls/core/ClusterController.html",
model: modelConfig,
}
}
};
return config;
},
currentTours: function currentTours(league, notUsed, configParams) {
var modelConfig = {
modelControl: "SportsJS.Controls.Models.ClusterDataModel",
modelControlConfig: {
query: AppEx.Sports.Services.TypeDefs.Request.TournamentDataQuery,
queryOptions: {
leagueName: league,
tourId: configParams.tourId
}
}
};
var config = {
clusterKey: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
clusterTitle: SportsJS.Utilities.getClusterTitleFromConfigParams(configParams),
clusterContent: {
contentControl: "SportsJS.Controls.Cluster.ClusterController",
contentOptions: {
fragmentPath: "/SportsCommonControls/core/ClusterController.html",
model: modelConfig,
}
}
};
return config;
},
cricketMatchBoxScore: function cricketMatchBoxScore(league, notUsed, configParams) {
var circketMatchBoxScoreModelConfig = {
modelControl: "SportsJS.Controls.Models.ClusterDataModel",
modelControlConfig: {
query: AppEx.Sports.Services.TypeDefs.Request.CricketMatchBoxScoreQuery,
queryOptions: {
leagueName: league,
matchId: configParams.entityId,
battingInning: configParams.battingInning,
}
}
};
var config = {
clusterKey: SportsJS.Utilities.getClusterIdFromConfigParams(configParams),
clusterTitle: SportsJS.Utilities.getClusterTitleFromConfigParams(configParams),
clusterContent: {
contentControl: "SportsJS.Controls.Cluster.ClusterController",
contentOptions: {
fragmentPath: "/SportsCommonControls/core/ClusterController.html",
model: circketMatchBoxScoreModelConfig,
}
}
};
return config;
},
});
// Keep all Today page related configs here
WinJS.Namespace.define("SportsJS.Cluster.Configs.Today",
{
todaySchedule: function todaySchedule(leagueType, currentDate) {
var config = {
clusterKey: "Cluster40",
clusterTitle: PlatformJS.Services.resourceLoader.getString("TodaySchedule"),
clusterContent: {
contentControl: "SportsJS.Today.Clusters.TodayScheduleClusterControl",
contentOptions: {
leagueType: leagueType,
currentDate: currentDate,
id: SportsJS.UI.ClusterType.TodaySchedule,
className: "sportsMultilineVerticallyStackedCluster"
},
}
};
return config;
},
sportsNavigation: function sportsNavigation(leagueType) {
var config = {
clusterKey: "Cluster03",
clusterTitle: PlatformJS.Services.resourceLoader.getString("Leagues"),
clusterContent: {
contentControl: "SportsJS.Today.Clusters.SportsNavigationClusterControl",
contentOptions: {
id: SportsJS.UI.ClusterType.SportsNavigation,
leagueType: leagueType
},
}
};
return config;
},
todayHeadlineCluster: function todayHeadlineCluster() {
var isTodayHeadlineClusterEnabled = PlatformJS.Services.appConfig.getBool("EnableTodayHeadlinesCluster");
if (isTodayHeadlineClusterEnabled) {
return SportsJS.Cluster.Configs.Common.headlinesCluster(SportsJS.UI.LeagueType.today, SportsJS.UI.EntityType.Today);
}
return null;
},
todaySlideShow: function todaySlideShow() {
var isTodaySlideshowEnabled = PlatformJS.Services.appConfig.getBool("EnableSlideshowCluster");
if (isTodaySlideshowEnabled) {
var config = {
clusterKey: "Cluster17",
clusterTitle: PlatformJS.Services.resourceLoader.getString("TodaySlideshow"),
clusterContent: {
contentControl: "SportsJS.Common.Slideshow.SlideshowClusterControl",
contentOptions: {
id: SportsJS.UI.ClusterType.TodaySlideshow,
leagueName: SportsJS.UI.LeagueType.today,
entityType: SportsJS.UI.EntityType.Today
},
}
};
return config;
}
return null;
},
todayMagazineCluster: function todayMagazineCluster() {
var isTodayMagazineEnabled = PlatformJS.Services.appConfig.getBool("EnableMagazineCluster");
if (!isTodayMagazineEnabled) {
return null;
}
return SportsJS.Cluster.Configs.Common.magazineCluster(SportsJS.UI.LeagueType.today, SportsJS.UI.EntityType.Today);
},
todayVideoCluster: function todayVideoCluster(league, args, configParams) {
var isTodayVideosEnabled = PlatformJS.Services.appConfig.getBool("EnableTodayHubVideosCluster");
if (!isTodayVideosEnabled) {
return null;
}
return SportsJS.Cluster.Configs.Common.videoCluster(SportsJS.UI.LeagueType.today, SportsJS.UI.EntityType.Today, null, configParams);
},
gettingStartedCluster: function gettingStartedCluster() {
var isGettingStartedEnabled = $SpMgr.customKeyValueConfig["IsGettingStartedEnabled"];
if (isGettingStartedEnabled !== "true") {
return null;
}
// This value is set by CUX when getting started cluster is dismissed by the user. 
if (Windows.Storage.ApplicationData.current.localSettings.values["showGettingStartedCluster"] === false) {
return null;
}
var modelConfig = {
modelControl: "SportsJS.Controls.Models.TempClusterDataModel",
modelControlConfig: {
query: AppEx.Sports.Services.TypeDefs.Request.GettingStartedClusterQuery,
queryOptions: { storageType: SportsJS.Consts.storageType.IE },
}
};
var clusterKey = "GettingStartedCluster01";
var config = {
clusterTitle: PlatformJS.Services.resourceLoader.getString("GettingStartedClusterTitle"),
clusterKey: clusterKey,
clusterContent: {
contentControl: "SportsJS.Controls.Cluster.TempClusterController",
contentOptions: {
fragmentPath: "/SportsCommonControls/TempClusterControl/TempClusterControl.html",
model: modelConfig,
clusterKey: clusterKey,
}
},
isTempCluster: true
};
return config;
},
nextStepsCluster: function nextStepsCluster() {
var isNextStepsEnabled = PlatformJS.Services.appConfig.getBool("EnableNextStepsCluster");
if (!isNextStepsEnabled) {
return null;
}
var modelConfig = {
modelControl: "SportsJS.Controls.Models.TempClusterDataModel",
modelControlConfig: {
query: AppEx.Sports.Services.TypeDefs.Request.NextStepsClusterQuery,
queryOptions: {},
}
};
var clusterKey = "NextStepsCluster01";
var config = {
clusterTitle: PlatformJS.Services.resourceLoader.getString("NextStepsClusterTitle"),
clusterKey: clusterKey,
clusterContent: {
contentControl: "SportsJS.Controls.Cluster.TempClusterController",
contentOptions: {
fragmentPath: "/SportsCommonControls/TempClusterControl/TempClusterControl.html",
model: modelConfig,
clusterKey: clusterKey,
clusterClass: "nextStepsCluster",
enableCompactPano: true
},
},
};
return config;
},
});
WinJS.Namespace.define("SportsJS.PageData.Configs.Common",
{
playerBio: function playerBio(league, playerId) {
var config = {
league: league,
playerId: playerId,
scenarioName: "GetPlayerBio",
dataSourceName: "PlayerBioDataSource",
uiScenarioName: "GenericPlayerBio",
};
return config;
}
});
// keep all common modules config here in this namespaces
WinJS.Namespace.define("SportsJS.Modules.Configs.Common",
{
myTeamsModule: function myTeamsModule(leagueType, pageType) {
var config = {
leagueType: leagueType,
pageType: pageType,
moduleInfo: {
fragmentPath: "/leagues/common/modules/MyTeamsModule/MyTeamsModule.html",
control: "SportsJS.Common.Modules.MyTeamsModuleControl",
}
};
return config;
},
myLeaguesModule: function myLeaguesModule(leagueType, pageType) {
var config = {
leagueType: leagueType,
pageType: pageType,
moduleInfo: {
fragmentPath: "/leagues/common/modules/MyLeaguesModule/MyLeaguesModule.html",
control: "SportsJS.Common.Modules.MyLeaguesModuleControl",
}
};
return config;
},
allSportsModule: function allSportsModule(leagueType) {
var config = {
leagueType: leagueType,
isEditable: true,
isInteractive: false,
moduleInfo: {
fragmentPath: "/leagues/common/modules/AllSportsModule/AllSportsModule.html",
control: "SportsJS.Common.Modules.AllSportsModuleControl",
}
};
return config;
},
SnapScheduleModule: function SnapScheduleModule(league, currentDate) {
var config = {
currentDate: currentDate,
league: league,
usesItemsContainer: true,
moduleInfo: {
fragmentPath: "/leagues/common/modules/LeagueScheduleModule/LeagueScheduleModule.html",
control: "SportsJS.Common.Modules.SnapScheduleModuleControl"
}
};
return config;
},
leagueScheduleDaily: function leagueScheduleDaily(configParams) {
if (!configParams || !configParams.league) { return null; }
//// Assuming isInteractive true by default
var isInteractive = configParams.isInteractive === "false" ? false : true;
var league = configParams.league;
var showLogos = SportsJS.Utilities.checkLogosAvailabilityParam(configParams);
var config = {
scheduleDate: configParams.scheduleDate,
league: league,
showLogos: showLogos,
isInteractive: isInteractive,
usesItemsContainer: true,
headerDate: configParams.headerDate,
moduleInfo: {
fragmentPath: "/leagues/common/modules/LeagueScheduleDailyModule/LeagueScheduleDailyModule.html",
control: "SportsJS.Common.Modules.LeagueScheduleDailyModuleControl"
}
};
return config;
},
leagueScheduleWeekly: function leagueScheduleWeekly(configParams) {
if (!configParams || !configParams.league) { return null; }
//// Assuming isInteractive true by default
var isInteractive = configParams.isInteractive === "false" ? false : true;
var league = configParams.league;
// bad here, clashing type in request params and cluster type.
var type = configParams && configParams.requestKvPairs ? configParams.requestKvPairs.type : null;
var showLogos = SportsJS.Utilities.checkLogosAvailabilityParam(configParams);
var config = {
scheduleDate: configParams.scheduleDate,
league: league,
type: type,
showLogos: showLogos,
isInteractive: isInteractive,
usesItemsContainer: true,
moduleInfo: {
fragmentPath: "/leagues/common/modules/LeagueScheduleWeeklyModule/LeagueScheduleWeeklyModule.html",
control: "SportsJS.Common.Modules.LeagueScheduleWeeklyModuleControl"
}
};
config.stageId = configParams.gametype;
config.scheduleView = configParams.scheduleView;
return config;
},
leagueLeadingPlayers: function leagueLeadingPlayers(configParams) {
if (!configParams || !configParams.league) { return null; }
var league = configParams.league;
var conference = configParams.conference;
var config = {
league: league,
conference: conference,
showPlaceholder: false,
isBindingBasedRefreshDisabled: true,
telemetryId: configParams.id,
uiScenarioName: SportsJS.Utilities.stringProperCase(league) + 'LeagueLeadingPlayers',
moduleInfo: {
fragmentPath: "/leagues/common/modules/LeadingEntitiesModule/LeadingEntitiesModule.html",
control: "SportsJS.Common.Modules.LeadingEntitiesModuleControl"
}
};
return config;
},
divisionStandings: function divisionStandings(configParams) {
if (!configParams || !configParams.league || !configParams.dataId) {
return null;
}
var config = {
dataId: configParams.dataId,
division: configParams.division,
divisionTitle: configParams.divisionTitle,
className: configParams.className,
league: configParams.league,
showPlaceholder: true,
isBindingBasedRefreshDisabled: true,
telemetryId: configParams.telemetryId,
moduleInfo: {
fragmentPath: "/leagues/common/modules/StandingsModule/StandingsModule.html",
control: "SportsJS.Common.Modules.StandingsModuleControl"
}
};
return config;
},
teamSeasonSummary: function teamSeasonSummary(configParams) {
if (!configParams || !configParams.league || !configParams.teamId) { return null; };
var league = configParams.league;
var teamId = configParams.teamId;
var config = {
league: league,
teamId: teamId,
moduleInfo: {
fragmentPath: "/leagues/common/modules/TeamSeasonSummaryModule/TeamSeasonSummaryModule.html",
control: "SportsJS.Common.Modules.TeamSeasonSummaryModuleControl"
}
};
return config;
},
news: function news(league, queryPromise, totalNews) {
var config = {
league: league,
totalNews: totalNews,
queryPromise: queryPromise,
moduleInfo: {
fragmentPath: "/leagues/common/modules/NewsModule/NewsModule.html",
className: "newsModule",
control: "SportsJS.Common.Modules.NewsModuleControl"
}
};
return config;
},
headlines: function headlines(leagueName, entityType) {
var config = {
moduleInfo: {
fragmentPath: "/leagues/common/modules/HeadlinesModule/HeadlinesModule.html",
className: "headlinesModule",
control: "SportsJS.Common.Modules.HeadlinesModuleControl"
},
leagueName: leagueName,
entityType: entityType
};
return config;
},
leagueLeadingTeams: function leagueLeadingTeams(configParams) {
if (!configParams || !configParams.league) {
return null;
}
var league = configParams.league;
var conference = configParams.conference;
var config = {
league: league,
conference: conference,
showPlaceholder: false,
telemetryId: configParams.id,
isBindingBasedRefreshDisabled: true,
uiScenarioName: SportsJS.Utilities.stringProperCase(league) + 'LeagueLeadingTeamStats',
moduleInfo: {
fragmentPath: "/leagues/common/modules/LeadingEntitiesModule/LeadingEntitiesModule.html",
control: "SportsJS.Common.Modules.LeadingEntitiesModuleControl"
}
};
return config;
},
teamLeaders: function teamLeaders(configParams) {
if (!configParams || !configParams.league || !configParams.teamId) { return null; }
var league = configParams.league;
var teamId = configParams.teamId;
var leadersType = configParams.leadersType || "";
var config = {
league: league,
leadersType: leadersType,
teamid: teamId,
showPlaceholder: true,
telemetryId: configParams.clusterId,
isBindingBasedRefreshDisabled: true,
moduleInfo: {
fragmentPath: "/leagues/common/modules/TeamLeadersModule/TeamLeadersModule.html",
control: "SportsJS.Common.Modules.TeamLeadersModuleControl"
}
};
return config;
},
teamRoster: function teamRoster(configParams) {
if (!configParams || !configParams.league || !configParams.teamId) { return null; }
var league = configParams.league;
var teamId = configParams.teamId;
var config = {
league: league,
teamId: teamId,
showPlaceholder: true,
isBindingBasedRefreshDisabled: true,
telemetryId: configParams.clusterId,
moduleInfo: {
fragmentPath: "/leagues/common/modules/TeamRosterModule/TeamRosterModule.html",
control: "SportsJS.Common.Modules.TeamRosterModuleControl"
}
};
return config;
},
teamSchedule: function teamSchedule(configParams) {
if (!configParams || !configParams.league || !configParams.teamId) { return null; }
//// Assuming isInteractive true by default
var isInteractive = configParams.isInteractive === "false" ? false : true;
var showLogos = SportsJS.Utilities.checkLogosAvailabilityParam(configParams);
var league = configParams.league;
var teamId = configParams.teamId;
var gameCount = configParams.gameCount;
var type = configParams.type;
var config = {
showLogos: showLogos,
league: league,
teamId: teamId,
gamecount: gameCount,
type: type,
usesItemsContainer: true,
showPlaceholder: true,
isInteractive: isInteractive,
moduleInfo: {
fragmentPath: "/leagues/common/modules/TeamScheduleModule/TeamScheduleModule.html",
control: "SportsJS.Common.Modules.TeamScheduleModuleControl"
}
};
return config;
},
teamStats: function teamStats(configParams) {
if (!configParams || !configParams.league || !configParams.teamId) { return null; }
var league = configParams.league;
var teamId = configParams.teamId;
var config = {
league: league,
teamId: teamId,
showPlaceholder: true,
isBindingBasedRefreshDisabled: true,
moduleInfo: {
fragmentPath: "/leagues/common/modules/TeamStatsModule/TeamStatsModule.html",
control: "SportsJS.Common.Modules.TeamStatsModuleControl"
}
};
return config;
},
teamSingleStats: function teamSingleStats(configParams) {
if (!configParams || !configParams.league || !configParams.teamId) { return null; }
var league = configParams.league;
var teamId = configParams.teamId;
var config = {
league: league,
teamId: teamId,
showPlaceholder: true,
moduleInfo: {
fragmentPath: "/leagues/common/modules/TeamSingleStatsModule/TeamSingleStatsModule.html",
control: "SportsJS.Common.Modules.TeamSingleStatsModuleControl"
}
};
return config;
},
playerBio: function playerBio(league, playerId) {
var pageCfgs = SportsJS.PageData.Configs.Common;
var bioCfg = pageCfgs.playerBio(league, playerId);
var config = {
league: league,
playerId: playerId,
isBindingBasedRefreshDisabled: true,
moduleInfo: {
fragmentPath: "/leagues/common/modules/PlayerBioModule/PlayerBioModule.html",
control: "SportsJS.Common.Modules.PlayerBioModuleControl"
}
};
return config;
},
playerStats: function playerStats(league, playerId) {
var config = {
league: league,
playerId: playerId,
isBindingBasedRefreshDisabled: true,
moduleInfo: {
fragmentPath: "/leagues/common/modules/PlayerStatsModule/PlayerStatsModule.html",
control: "SportsJS.Common.Modules.PlayerStatsModuleControl"
}
};
return config;
},
playerGameLog: function playerGameLog(league, playerId) {
var config = {
league: league,
playerId: playerId,
/// TODO Cleanup data sources and update here
urlParams: [{ scenarioName: league + "GetPlayerGameLogs", dataSourceName: "NflDataSource" },
{ scenarioName: league + "GetPlayerInGameStatistics", dataSourceName: "PlayerInGameStats" }],
uiScenarioName: "GenericPlayerGameLogs",
isBindingBasedRefreshDisabled: true,
moduleInfo: {
fragmentPath: "/leagues/common/modules/PlayerGameLogModule/PlayerGameLogModule.html",
control: "SportsJS.Common.Modules.PlayerGameLogModuleControl"
}
};
return config;
},
playerComparison: function playerComparison(league, playerId) {
var config = {
league: league,
playerId: playerId,
isBindingBasedRefreshDisabled: true,
moduleInfo: {
fragmentPath: "/leagues/common/modules/PlayerComparisonModule/PlayerComparisonModule.html",
control: "SportsJS.Common.Modules.PlayerComparisonModuleControl"
}
};
return config;
},
noImageLeadingEntities: function noImageLeadingEntities(configParams) {
if (!configParams || !configParams.league) { return null; }
var league = configParams.league;
var teamId = configParams.teamId;
var entityType = configParams.entityType;
var conference = configParams.conference;
var itemClickEnabled = configParams.isItemClickEnabled;
var config = {
league: league,
teamId: teamId,
conference: conference,
entityType: entityType,
isItemClickEnabled: itemClickEnabled,
showPlaceholder: true,
telemetryId: configParams.clusterId,
moduleInfo: {
fragmentPath: "/leagues/common/modules/NoImageLeadingEntitiesModule/NoImageLeadingEntitiesModule.html",
control: "SportsJS.Common.Modules.NoImageLeadingEntitiesModuleControl"
}
};
return config;
},
sportsTable: function sportsTable(configParams) {
if (!configParams || !configParams.league) { return null; }
var showLogos = SportsJS.Utilities.checkLogosAvailabilityParam(configParams);
var fragmentPath = "/leagues/common/modules/SportsTableModule/SportsTableModule.html";
var league = configParams.league;
var tournamentId = configParams.tournamentId;
var teamId = configParams.teamId;
var requireListViewIncrementalFetching = configParams.requireListViewIncrementalFetching;
var config = {
showLogos: showLogos,
league: league,
teamId: teamId,
clusterId: configParams.clusterId,
tournamentId: tournamentId,
division: configParams.conference,
requireListViewIncrementalFetching: requireListViewIncrementalFetching,
hasChrome: true,
isItemClickEnabled: configParams.isItemClickEnabled,
usesItemsContainer: configParams.usesItemsContainer,
hasImage: configParams.hasImage,
tableSize: configParams.tableSize,
showPlaceholder: configParams.showPlaceholder,
moduleInfo: {
fragmentPath: fragmentPath,
control: "SportsJS.Common.Modules.SportsTableModuleControl"
}
};
return config;
},
ScrollableStandingsList: function ScrollableStandingsList(configParams) {
if (!configParams || !configParams.league) { return null; }
var league = configParams.league;
var config = {
league: league,
moduleInfo: {
fragmentPath: "/leagues/common/modules/ScrollableStandingsListModule/ScrollableStandingsListModule.html",
control: "SportsJS.Common.Modules.ScrollableStandingsListModuleControl"
}
};
return config;
},
liveScoreHeader: function liveScoreHeader(configParams) {
if (!configParams || !configParams.league) { return null; }
var league = configParams.league;
var clusterId = configParams.clusterId;
var tournamentId = configParams.tournamentId;
var config = {
league: league,
clusterId: clusterId,
tournamentId: tournamentId,
moduleInfo: {
fragmentPath: "/leagues/common/modules/LiveScoreHeaderModule/LiveScoreHeaderModule.html",
control: "SportsJS.Common.Modules.LiveScoreHeaderModuleControl"
}
};
return config;
},
});
// Keep all TodayPage related configs here
WinJS.Namespace.define("SportsJS.Modules.Configs.Today",
{
TodaySchedule: function TodaySchedule(configParams) {
if (!configParams || !configParams.league) { return null; }
var league = configParams.league;
var isValidLeague = SportsJS.Utilities.isValidLeagueTypeStrict(league);
var config = {
league: league,
dataId: league,
leagueHeader: isValidLeague ? SportsJS.Utilities.getLocLeagueDisplayText(league) : "",
headerClass: isValidLeague ? "commonScheduleHeader sportsModuleHeader" : "hideHeader",
usesItemsContainer: true,
moduleInfo: {
fragmentPath: "/leagues/today/HomePage/TodayScheduleCluster/TodayScheduleModule/TodayScheduleModule.html",
control: "SportsJS.Today.Modules.TodayScheduleModuleControl"
}
};
return config;
},
sportsNavigation: function sportsNavigation(leagueType) {
var config = {
leagueType: leagueType,
moduleInfo: {
fragmentPath: "/leagues/today/HomePage/SportsNavigationCluster/SportsNavigationModule/SportsNavigationModule.html",
control: "SportsJS.Today.Modules.SportsNavigationModuleControl"
}
};
return config;
},
TodaySlideshow: function TodaySlideshow(leagueName, entityType) {
var config = {
moduleInfo: {
fragmentPath: "/leagues/common/modules/SlideshowModule/SlideshowModule.html",
control: "SportsJS.Common.Slideshow.SlideshowModuleControl"
},
leagueName: leagueName,
entityType: entityType
};
return config;
},
});
})();
