﻿(function () {
'use strict';
WinJS.Namespace.define('SportsJS.ECV', {
BaseCollection: WinJS.Class.derive(CommonJS.EntityCollection.Collection, function (options) {
CommonJS.EntityCollection.Collection.call(this, options);
this.options = options || {};           
if (this._league) {
SportsJS.mainProcessManager.snappedSport = this._league;
var backgroundContainer = document.querySelector(".sportsBackgroundContainer");
if (backgroundContainer) {
backgroundContainer.style.backgroundImage = 'url("' + SportsJS.Utilities.getSportsBackgroundUrl(this._league) + '")';
}
SportsJS.Page.setSportsPageRootElement(".sportsECVPageFragment", this._league);
//// Add Glossary button.
SportsJS.Utilities.ECV.addLegendButtonToBottomEdgy(options);
SportsJS.Utilities.ECV.addHelpButtonToBottomEdgy(options);
}
this._data = [];
}, {
// Entity collection provider object, to be set by the derived class
_providerConfig: null,
Initialize: function Initialize(config) {
config = config || {};
var that = this;
//TODO:saurabkh add feedback control to the page here
//load sportsECV templates fragment
var fragmentLoadPromise = WinJS.UI.Fragments.render("/leagues/common/ECV/ECVTemplates.html");
var initAsyncpromise = that.Provider.initializeAsync(that._providerConfig);
var p = new WinJS.Promise(function (complete, error) {
var promiseArray = [];
promiseArray.push(fragmentLoadPromise);
promiseArray.push(initAsyncpromise);
WinJS.Promise.join(promiseArray).then(function (resArray) {
if (resArray && resArray.length > 1 && resArray[1]) {
//set the UIconfig object template value
if (that.UIConfig) {
that.UIConfig.fragmentObj = resArray[0];
}
complete(resArray[1]);                   
}
else {
var isInternetAvailable = SportsJS.Networking.isInternetAvailable;
var errorType = isInternetAvailable ? CommonJS.Error.STANDARD_ERROR : CommonJS.Error.NO_INTERNET;
CommonJS.Error.showError(errorType,
function () {
that._refreshPage();
});
}
});
if (that.UIConfig) {
that.UIConfig.promiseArray = promiseArray;
}
});
return p;
},
_refreshPage: function _refreshPage() {                
CommonJS.Error.removeError();
CommonJS.forceRefresh();
},
}),
UIConfig: WinJS.Class.derive(CommonJS.EntityCollection.UIConfig, function (options) {
CommonJS.EntityCollection.UIConfig.call(this, options);
WinJS.UI.setOptions(this, options);
}, {
promiseArray: null,
/// <summary>
/// This function is invoked by the UX Framework when the layout has changed
/// </summary>
/// <param name="layoutState">
/// The current layout state
/// </param>
/// <returns>
/// pageinfo of snap page to be navigated
/// </returns>
onLayoutChange: function onLayoutChange(layoutState) {
var that = this;
if (typeof layoutState !== 'undefined' && layoutState === Windows.UI.ViewManagement.ApplicationViewState.snapped) {
var snapPageInfo = {
pageInfo: {
fragment: "/leagues/common/SnapView/SnapViewPage.html",
page: "SportsJS.SnapViewHome"
},
resetHistory: true,
state: null
};
return snapPageInfo;
}
},
onNavigateAway: function onNavigateAway() {
var that = this;
SportsJS.Utilities.cancelPromiseArray(that.promiseArray);
},
GetSupportedViews: function GetSupportedViews() {
return {
list: [CommonJS.EntityCollection.Views.List],
defaultView: CommonJS.EntityCollection.Views.List
};
},
GetViewOptions: function GetViewOptions(view) {
var options = {};
options.disableSemanticZoom = true;
switch (view) {
case CommonJS.EntityCollection.Views.List:
options.selectionMode = 'none';
break;
}
return options;
},
SetFilterType: function SetFilterType(filter) {
filter.type = 'DropDown';
filter.selectionMode = 'SingleToggleFilter';   //V-krpr:  changed for removing showall from filter by list
},
GetTableDefinition: function GetTableDefinition(entities) {
var td = new CommonJS.Table.TableDefinition();
//item spacing to avoid gap before scroll bar in large resolutions.
td.itemSpacing = {
min:25,
max: 250
};                         
//item spacing to avoid gap before scroll bar in large resolutions for Golf and Soccer leagues as they have very less columns .
if ((Microsoft.AppEx.Sports.SportsEnums.League[this._league] === Microsoft.AppEx.Sports.SportsEnums.League.pga) ||
(SportsJS.Utilities.isLeagueSoccerType(this._league))) {
td.itemSpacing = {
min: 25,
max: 500
};
}
var columnDefinitions = this.providerObj.getColumnDefinitions();
for (var i = 0, len = columnDefinitions.length; i < len; i++) {
var colDefinition = new CommonJS.Table.ColumnDefinition();
//TODO:saurabkh use constants
if (this.fragmentObj) {
switch (columnDefinitions[i].displayType) {
case SportsJS.UI.ecvDisplayType.Image:
colDefinition.fieldTemplate = this.fragmentObj.querySelector(".imageFieldTemplate");
colDefinition.hideHeader = true;
break;
case SportsJS.UI.ecvDisplayType.Number:
colDefinition.fieldTemplate = this.fragmentObj.querySelector(".numberFieldTemplateRoster");
break;
case SportsJS.UI.ecvDisplayType.Text:
colDefinition.fieldTemplate = this.fragmentObj.querySelector(".textFieldTemplateRoster");
break;
case SportsJS.UI.ecvDisplayType.Title:
colDefinition.fieldTemplate = this.fragmentObj.querySelector(".titleFieldTemplateRoster");
break;
case SportsJS.UI.ecvDisplayType.SortTitle:
colDefinition.fieldTemplate = this.fragmentObj.querySelector(".sortTitleFieldTemplateRoster");
break;
case SportsJS.UI.ecvDisplayType.NoDisplay:
continue;
break;
}
if (columnDefinitions[i].sortId) {
colDefinition.sortIdentifier = columnDefinitions[i].sortId;
colDefinition.headerTemplate = this.fragmentObj.querySelector(".columnHeaderTemplate");
}
else {
colDefinition.headerTemplate = this.fragmentObj.querySelector(".columnHeaderTemplateNoSort");
}
}
colDefinition.headerText = columnDefinitions[i].headerText;
colDefinition.priority = columnDefinitions[i].priority;
colDefinition.boundField = columnDefinitions[i].id;
colDefinition.ID = columnDefinitions[i].id;
td.columns.push(colDefinition);
}
td.GroupPosition = 'top';
td.showColumnHeaders = true;
td.showGroupHeaders = false;
td.cssWhiteList = ["sports.css", "sportsECV.css", "sportsLang.css", "LeaguePlayersECV.css", "LeagueSchedulesECV.css", "LeagueTeamsECV.css", "StandingsECV.css", "TeamRosterECV.css"];
return td;
},
})
});
})();
