﻿(function () {
'use strict';
WinJS.Namespace.define("SportsJS", {
//// Helper class for Quick Search control. Has only static functions
SportsEntitySearchUI: WinJS.Class.define(function (entityType, moduleControl) {
this._entityType = entityType;
this._module = moduleControl;
},
{
_searchDialog: null,
_entityType: null,
_module: null,
//// Called from myTeams edgy and add tile both
showQuickSearch: function showQuickSearch() {
var that = this;
this._searchDialog = CommonJS.SearchDialog.show({
onSearchTextEntered: function onSearchTextEntered(event) {
that._module.addEntityToCollection(event);
},
onSearchSuggestionsRequested: function onSearchSuggestionsRequested(event, src) {
that._module.showEntitySearchSuggestions(event, src);
},
autoSuggestOptions: {
selectionMode: CommonJS.AutoSuggest.forceSelection,
},
searchPlaceholderText: PlatformJS.Services.resourceLoader.getString("MyTeamsQuickSearchPlaceholderText"),
promptText: PlatformJS.Services.resourceLoader.getString("MyTeamsQuickSearchPrompt"),
onHide: function onHide() {
that._searchDialog = null;
}
});
CommonJS.dismissAllEdgies();
},
hideQuickSearch: function hideQuickSearch() {
this.hideProgress();
this.hideMessage();
if (this._searchDialog) {
this._searchDialog.searchVisible = false;
}
},
setQuickSearchBoxText: function setQuickSearchBoxText(message) {
if (this._searchDialog) {
this._searchDialog.searchBoxText = message;
}
CommonJS.dismissAllEdgies();
},
//// Message for the user. Used to indicate success or failure
showMessage: function showMessage(success, msg) {
var that = this;
var msgContainer = document.querySelector(".platformSearchDialogMessage");
if (msgContainer) {
//// TODO(saarya): Should apply a css class
if (success) {
msgContainer.style.color = "#339900";
}
else {
msgContainer.style.color = "#C00000";
}
}
if (this._searchDialog) {
this._searchDialog.message = msg;
}
CommonJS.dismissAllEdgies();
that.hideProgress();
that.setQuickSearchBoxText("");
},
//// Should be called when next search starts
hideMessage: function hideMessage() {
if (this._searchDialog) {
this._searchDialog.message = "";
}
CommonJS.dismissAllEdgies();
},
//// Need to be called to show and hide the progress in quick search
showProgress: function showProgress() {
if (this._searchDialog) {
this._searchDialog.showSearchProgress();
}
CommonJS.dismissAllEdgies();
},
hideProgress: function hideProgress() {
if (this._searchDialog) {
this._searchDialog.hideSearchProgress();
}
CommonJS.dismissAllEdgies();
},
disableAddButton: function disableAddButton() {
//// TODO(saarya): Hack to disable add button
//// Avoid using this. This is resulting in navigation to previous page because it causes the Search dialog to loose focus.
if (this._searchDialog && this._searchDialog._addButton) {
this._searchDialog._addButton.disabled = true;
}
},
})
});
})();
