﻿(function () {
"use strict";
var cancel = false;
var backgroundTaskInstance = Windows.UI.WebUI.WebUIBackgroundTaskInstance.current;
function onCanceled(cancelSender, cancelReason) {
cancel = true;
}
backgroundTaskInstance.addEventListener("canceled", onCanceled);
function updateAppTile() {
if (!cancel) {
backgroundTaskInstance.succeeded = true;
try {
try {
var market = Platform.Utilities.Globalization.getMarketString();
market = market.toLowerCase();
var serviceName = "NewsV1";
var editorialEnabled = false;
var urlTemplate = null;
//check availability of editorial news
switch (market) {
case "en-gb":
case "fr-fr":
case "de-de":
case "es-es":
case "it-it":
case "en-ca":
case "fr-ca":
case "pt-br":
case "zh-cn":
case "ja-jp":
case "en-au":
case "en-in":
case "en-us":
editorialEnabled = true;
break;
}
urlTemplate = "http://{middleTierServer}/{serviceName}.svc/RSSTileNews/{market}/20?index={index}&brand=logo";
if (editorialEnabled) {
urlTemplate = urlTemplate + "&pageid=Today.js";
}
switch (market) {
case "en-us":
case "en-au":
case "zh-cn":
case "fr-fr":
case "ja-jp":
case "en-gb":
case "de-de":
urlTemplate = "http://{middleTierServer}/{serviceName}.svc/TileNewsByCategory/1?mkt={market}&index={index}&brand=logo";
if (editorialEnabled) {
urlTemplate = urlTemplate + "&pageid=Today.js";
}
break;
}
var urisToPoll = [];
if (urlTemplate) {
for (var i = 0; i < 3; i++) {
var urlStr = urlTemplate;
urlStr = urlStr.replace("\{middleTierServer\}", "sports.services.appex.bing.com");
urlStr = urlStr.replace("\{market\}", market);
urlStr = urlStr.replace("\{index\}", i);
urlStr = urlStr.replace("\{serviceName\}", serviceName);
urisToPoll.push(new Windows.Foundation.Uri(urlStr));
}
}
var cmsNotificationEnabled = false;
// the market corresponds to market where today hero is enabled.
switch (market) {
case "en-us":
case "pt-br":
case "en-au":
case "en-ca":
case "zh-cn":
case "fr-fr":
case "en-in":
case "it-it":
case "jp-jp":
case "es-es":
case "en-gb":
case "de-de":
case "fr-ca":
cmsNotificationEnabled = true;
break;
}
if (cmsNotificationEnabled) {
var cmsUrl = "http://{market}.appex-rf.msn.com/cgtile/v1/{market}/Sports/Today.xml";
cmsUrl = cmsUrl.replace(/\{market\}/g, market);
urisToPoll.push(new Windows.Foundation.Uri(cmsUrl));
}
var recurrence = Windows.UI.Notifications.PeriodicUpdateRecurrence.halfHour;
var notifications = Windows.UI.Notifications;
notifications.TileUpdateManager.createTileUpdaterForApplication().enableNotificationQueue(true);
if (urisToPoll && urisToPoll.length > 0) {
notifications.TileUpdateManager.createTileUpdaterForApplication().startPeriodicUpdateBatch(urisToPoll, recurrence);
}
} catch (ex) {
//TODO: arengak: check with PM what should be the behaviour in this case.
}
} catch (ex) {
}
close();
} else {
backgroundTaskInstance.succeeded = false;
close();
}
}
updateAppTile();
})();
