﻿/********************************************************
*                                                        *
*   © Microsoft. All rights reserved.                    *
*                                                        *
*********************************************************/
(function () {
'use strict';
WinJS.Namespace.define("SportsJS.SecondaryTile", {
maxNotificationCount: 5,
isAlreadyPinned: function isAlreadyPinned(tileId) {
var isPinned;
try {
isPinned = Windows.UI.StartScreen.SecondaryTile.exists(tileId);
} catch (e) {
isPinned = false;
}
return isPinned;
},
_updateParameters: function _updateParameters(urlStr, args, index) {
if (urlStr) {
urlStr = urlStr.replace("\{middleTierServer\}", SportsJS.SettingsManager.getMiddleTierTileServer());
urlStr = urlStr.replace("\{market\}", AppEx.Sports.Services.Utilities.Globalization.getCurrentMarket().toLowerCase());
urlStr = urlStr.replace("\{language\}", Platform.Globalization.Marketization.getQualifiedLanguageString());
urlStr = urlStr.replace("\{serviceName\}", SportsJS.Utilities.getNewsServiceName());
var clientTz = AppEx.Sports.Services.Utilities.DateTimeStringConstructor.getTimeZoneName();
if (clientTz) {
urlStr = urlStr.replace("\{clientTz\}", clientTz);
}
else {
urlStr = urlStr.replace("\{clientTz\}", "");
}
if (args.leagueType) {
urlStr = urlStr.replace("\{leagueName\}", args.leagueType);
} else {
urlStr = urlStr.replace("\{leagueName\}", "");
}
if (args.teamId) {
urlStr = urlStr.replace("\{teamId\}", args.teamId);
} else {
urlStr = urlStr.replace("\{teamId\}", "");
}
if (index) {
urlStr = urlStr.replace("\{index\}", index);
} else {
urlStr = urlStr.replace("\{index\}", "0");
}
if (args.queryText) {
urlStr = urlStr.replace("\{query\}", args.queryText);
} else {
urlStr = urlStr.replace("\{query\}", "todays sports");
}
var editorialNewsEnabled = PlatformJS.Services.appConfig.getBool("EditorialNewsEnabled");
if (args.leagueType && editorialNewsEnabled) {
if (!args.teamId) {
//get league page cms id
urlStr = urlStr.replace("\{pageid\}", "&pageid=" + SportsJS.Utilities.getLeagueCmsMappings(args.leagueType));
}
} else {
urlStr = urlStr.replace("\{pageid\}", "");
}
// Windows 8 bug #814678. Windows does not encode double quote
// Workaround: encode double quote in the url
urlStr = urlStr.replace(/\"/g, "%22");
}
return urlStr;
},
_constructSecondaryTileTeamStandingUrl: function _constructSecondaryTileTeamStandingUrl(args) {
var urlStr = null;
if (args.teamId) {
urlStr = PlatformJS.Services.appConfig.getString("AzureSecondaryTileTeamStandingUrl");
urlStr = this._updateParameters(urlStr, args, null);
}
return urlStr;
},
_constructSecondaryTileTeamScheduleUrl: function _constructSecondaryTileTeamScheduleUrl(args) {
var urlStr = null;
if (args.teamId) {
urlStr = PlatformJS.Services.appConfig.getString("AzureSecondaryTileTeamScheduleUrl");
urlStr = this._updateParameters(urlStr, args, null);
}
return urlStr;
},
_constructSecondaryTileNewsNotificationUrl: function _constructSecondaryTileNewsNotificationUrl(args, index) {
var urlStr = null;
if (args.newsType === SportsJS.UI.NewsType.bingquery) {
if (args.teamId) {
// using different datasource keeps it cleaner
urlStr = PlatformJS.Services.appConfig.getString("AzureSecondaryTileTeamNewsUrl");
}
else {
urlStr = PlatformJS.Services.appConfig.getString("AzureSecondaryTileNewsUrl");
}
urlStr = this._updateParameters(urlStr, args, index);
}
return urlStr;
},
_constructSecondaryTileCMSLeagueUrl: function _constructSecondaryTileCMSLeagueUrl(args) {
var urlStr = null;
// only for league
if (args.leagueType && args.heroSetting && !args.teamId) {
var heroSetting = args.heroSetting;
if (heroSetting === SportsJS.UI.HeroType.enabled) {
var pageName = SportsJS.Utilities.getLeagueTileCmsMappings(args.leagueType);
urlStr = PlatformJS.Services.appConfig.getString("CMSSecondaryTileLeagueNotificationUrl");
if (urlStr && pageName) {
urlStr = urlStr.replace("\{LeagueTilePage\}", pageName);
urlStr = urlStr.replace(/\{market\}/g, AppEx.Sports.Services.Utilities.Globalization.getCurrentMarket().toLowerCase());
} else {
urlStr = null;
}
}
}
return urlStr;
},
_constructSecondaryTileBatchURLAsync: function _constructSecondaryTileBatchURLAsync(args) {
var that = this;
var urisToPoll = [];
var scheduleUrlStr = that._constructSecondaryTileTeamScheduleUrl(args);
if (scheduleUrlStr) {
urisToPoll.push(new Windows.Foundation.Uri(scheduleUrlStr));
}
var standingUrlStr = that._constructSecondaryTileTeamStandingUrl(args);
if (standingUrlStr) {
urisToPoll.push(new Windows.Foundation.Uri(standingUrlStr));
}
return SportsJS.Utilities.getSecondaryTileDataAsync(args.leagueType).then(function (tileData) {
if (tileData && tileData.heroSetting) {                    
args.heroSetting = tileData.heroSetting;
var heroUrl = that._constructSecondaryTileCMSLeagueUrl(args);
if (heroUrl) {
urisToPoll.push(new Windows.Foundation.Uri(heroUrl));
}
}
if (tileData && tileData.newsQueryType) {
args.NewsType = tileData.newsQueryType;
for (var i = 0; i < args.newsCount; i++) {
var urlStr = that._constructSecondaryTileNewsNotificationUrl(args, i);
if (urlStr) {
urisToPoll.push(new Windows.Foundation.Uri(urlStr));
}
}
}
return urisToPoll;
}, function (error) {
return urisToPoll;
});
},
_constructSecondaryTileBatchURL: function _constructSecondaryTileBatchURL(args) {
var urisToPoll = [];
var heroUrl = this._constructSecondaryTileCMSLeagueUrl(args);
if (heroUrl) {
urisToPoll.push(new Windows.Foundation.Uri(heroUrl));
}
for (var i = 0; i < args.newsCount; i++) {
var urlStr = this._constructSecondaryTileNewsNotificationUrl(args, i);
if (urlStr) {
urisToPoll.push(new Windows.Foundation.Uri(urlStr));
}
}
var scheduleUrlStr = this._constructSecondaryTileTeamScheduleUrl(args);
if (scheduleUrlStr) {
urisToPoll.push(new Windows.Foundation.Uri(scheduleUrlStr));
}
var standingUrlStr = this._constructSecondaryTileTeamStandingUrl(args);
if (standingUrlStr) {
urisToPoll.push(new Windows.Foundation.Uri(standingUrlStr));
}
return urisToPoll;
},
startPeriodicUpdateForTile: function startPeriodicUpdateForTile(tileId, args) {
try {
var urisToPoll = this._constructSecondaryTileBatchURL(args);
var recurrence = PlatformJS.Services.appConfig.getString("TileNotificationRecurrence");
var notifications = Windows.UI.Notifications;
if (urisToPoll && urisToPoll.length > 0) {
notifications.TileUpdateManager.createTileUpdaterForSecondaryTile(tileId).enableNotificationQueue(true);
notifications.TileUpdateManager.createTileUpdaterForSecondaryTile(tileId).startPeriodicUpdateBatch(urisToPoll, recurrence);
}                
} catch (ex) {
}
},
startPeriodicUpdateForTileAsync: function startPeriodicUpdateForTileAsync(tileId, args) {
try {
this._constructSecondaryTileBatchURLAsync(args).then(function (urisToPoll) {
var recurrence = PlatformJS.Services.appConfig.getString("TileNotificationRecurrence");
var notifications = Windows.UI.Notifications;
if (urisToPoll && urisToPoll.length > 0) {
notifications.TileUpdateManager.createTileUpdaterForSecondaryTile(tileId).enableNotificationQueue(true);
notifications.TileUpdateManager.createTileUpdaterForSecondaryTile(tileId).startPeriodicUpdateBatch(urisToPoll, recurrence);
}
});
} catch (ex) {
}
},
_getImageForSquareTile: function _getImageForSquareTile(league) {
var leagueType = AppEx.Sports.Services.Utils.getSportsFromLeague(league);
return "ms-appx:///assets/" + leagueType + "/" + "squareTile.png";
},
_getImageForWideTile: function _getImageForWideTile(league) {
var leagueType = AppEx.Sports.Services.Utils.getSportsFromLeague(league);
return "ms-appx:///assets/" + leagueType + "/" + "wideTile.png";
},
createTile: function createTile(tileId, args, pinElement, completeCallback, instrumentationID) {
var that = this;
var uriLogo = new Windows.Foundation.Uri(that._getImageForSquareTile(args.leagueType));
var uriWideLogo = new Windows.Foundation.Uri(that._getImageForWideTile(args.leagueType));
// TODO [sanch]: Follow up with PM why we are not using sports specific small logo here.
var uriSmallLogo = new Windows.Foundation.Uri("ms-appx:///images/sports_logo_small.png");
var argString = SportsJS.Utilities.jsonStringify(args);
var tile = new Windows.UI.StartScreen.SecondaryTile(tileId,
args.displayName,
args.displayName,
argString,
Windows.UI.StartScreen.TileOptions.showNameOnWideLogo | Windows.UI.StartScreen.TileOptions.showNameOnLogo | Windows.UI.StartScreen.TileOptions.copyOnDeployment,
uriLogo,
uriWideLogo);
tile.smallLogo = uriSmallLogo;
if (pinElement) {
var selectionRect = pinElement.getBoundingClientRect();
if (selectionRect) {
var position = { x: selectionRect.left, y: selectionRect.top - 5 };
tile.requestCreateAsync(position).then(function (isCreated) {
if (completeCallback && typeof completeCallback === "function") {                            
completeCallback();                           
}
if (isCreated) {
that.startPeriodicUpdateForTile(tileId, args);
SportsJS.Telemetry.logTilePin(tileId, SportsJS.Telemetry.ActionType.pin);
}
});
}
} else {
tile.requestCreateAsync().then(function (isCreated) {
if (completeCallback && typeof completeCallback === "function") {
completeCallback();
}
if (isCreated) {
that.startPeriodicUpdateForTile(tileId, args);
}
});
}
},
removeTile: function removeTile(tileId, unpinElement, completeCallback, instrumentationID) {
var tile = Windows.UI.StartScreen.SecondaryTile(tileId);
if (unpinElement) {
var selectionRect = unpinElement.getBoundingClientRect();
if (selectionRect) {
var position = { x: selectionRect.left, y: selectionRect.top - 5 };
tile.requestDeleteAsync(position).then(function (isDeleted) {
if (completeCallback && typeof completeCallback === "function") {                           
completeCallback();                            
}
if (isDeleted) {
SportsJS.Telemetry.logTilePin(tileId, SportsJS.Telemetry.ActionType.unpin);
}
});
}
} else {
tile.requestDeleteAsync().then(function (isDeleted) {
if (completeCallback && typeof completeCallback === "function") {
completeCallback();
}
});
}
},
getPinnedLeagues: function getPinnedLeagues() {
var that = this;
var p = new WinJS.Promise(function (complete) {
var leagues = [];
Windows.UI.StartScreen.SecondaryTile.findAllAsync().then(function (tiles) {
if (tiles) {
tiles.forEach(function (tile) {
try {
var args = JSON.parse(tile.arguments);
if (args && args.leagueType) {
var index = leagues.indexOf(args.leagueType);
if (index === -1) {
leagues.push(args.leagueType);
}
}
} catch (ex) {
// Problem in parsing tile arguments. Ignore this tile.
}
});
}
complete(leagues);
}, function (error) {
// Unable to get list of pinned tiles data. 
complete(leagues);
});
});
return p;
},
_constructAppTileNewsNotificationUrl: function _constructAppTileNewsNotificationUrl(newsType, index) {
var urlStr = null;
if (newsType === SportsJS.UI.NewsType.rss) {
urlStr = PlatformJS.Services.appConfig.getString("AzureAppTileRSSNewsUrl");
}
else if (newsType === SportsJS.UI.NewsType.bingcategory) {
urlStr = PlatformJS.Services.appConfig.getString("AzureAppTileNewsUrl");
}
if (urlStr) {
urlStr = urlStr.replace("\{middleTierServer\}", SportsJS.SettingsManager.getMiddleTierTileServer());
urlStr = urlStr.replace("\{market\}", AppEx.Sports.Services.Utilities.Globalization.getCurrentMarket().toLowerCase());
urlStr = urlStr.replace("\{index\}", index);
if (PlatformJS.Services.appConfig.getBool("EditorialNewsEnabled")) {
urlStr = urlStr.replace("\{pageid\}", "&pageid=" + SportsJS.Utilities.getLeagueCmsMappings(SportsJS.UI.LeagueType.today));
}
else {
urlStr = urlStr.replace("\{pageid\}", "");
}
urlStr = urlStr.replace("\{serviceName\}", SportsJS.Utilities.getNewsServiceName());
}
return urlStr;
},
_constructAppTileBatchURL: function _constructAppTileBatchURL() {
var urisToPoll = [];
var newsType = SportsJS.Utilities.getNewsTypeForPage(SportsJS.UI.PageType.Today);
var newsCount = SportsJS.Consts.AppTileNewsCount;
for (var i = 0; i < newsCount; i++) {
if (newsType && newsType.value) {
var urlStr = this._constructAppTileNewsNotificationUrl(newsType.value, i);
if (urlStr) {
urisToPoll.push(new Windows.Foundation.Uri(urlStr));
}
}
}
var cmsSetting = SportsJS.Utilities.getHeroClusterSetting(SportsJS.UI.PageType.Today);
if (cmsSetting === SportsJS.UI.HeroType.enabled) {
var market = AppEx.Sports.Services.Utilities.Globalization.getCurrentMarket().toLowerCase();
market = market.toLowerCase();
var cmsUrl = PlatformJS.Services.appConfig.getString("CMSAppTileNotificationUrl");
if (cmsUrl) {
cmsUrl = cmsUrl.replace(/\{market\}/g, market);
urisToPoll.push(new Windows.Foundation.Uri(cmsUrl));
}
}
return urisToPoll;
},
updateAppTile: function updateAppTile() {
try {
var urisToPoll = this._constructAppTileBatchURL();
var recurrence = PlatformJS.Services.appConfig.getString("TileNotificationRecurrence");
var tileUpdater = Windows.UI.Notifications.TileUpdateManager.createTileUpdaterForApplication();
tileUpdater.clear();
tileUpdater.stopPeriodicUpdate();
if (urisToPoll && urisToPoll.length > 0) {
tileUpdater.enableNotificationQueue(true);
tileUpdater.startPeriodicUpdateBatch(urisToPoll, recurrence);
}
} catch (ex) {
}
},
updateAllTiles: function updateAllTiles() {
var that = this;
that.updateAppTile();
var notifications = Windows.UI.Notifications;
Windows.UI.StartScreen.SecondaryTile.findAllAsync().then(function (tiles) {
if (tiles) {
tiles.forEach(function (tile) {
try {
var args = JSON.parse(tile.arguments);
var tileUpdater = notifications.TileUpdateManager.createTileUpdaterForSecondaryTile(tile.tileId);
if (tileUpdater) {
// dynamic pano, we dont want to clear the tile. bug#402238
if (!args || args.target !== "DynamicPano.DynamicCategoryPano") {
tileUpdater.clear();
}
tileUpdater.stopPeriodicUpdate();
}
// Update the uris of logos. This takes care of cases where paths to logos have changed
// e.g. in an app upgrade, logo files have been moved around.
// TODO [sanch]: Ideally, we should do this only for the first time when app loads after an
// upgrade. Right now we are doing this blindly everytime secondary tiles are updated. 
// Make this optimization.
tile.logo = new Windows.Foundation.Uri(that._getImageForSquareTile(args.leagueType));
tile.wideLogo = new Windows.Foundation.Uri(that._getImageForWideTile(args.leagueType));
tile.smallLogo = new Windows.Foundation.Uri("ms-appx:///images/sports_logo_small.png");
that.startPeriodicUpdateForTileAsync(tile.tileId, args);
} catch (ex) {
// Problem in parsing tile arguments. Ignore this tile.check pa
}
});
}
}, function (e) {
//error condition, not doing anything right now.
});
},
disableNotification: function disableNotification() {
// diable notification on app tile 
var tileUpdater = Windows.UI.Notifications.TileUpdateManager.createTileUpdaterForApplication();
tileUpdater.clear();
tileUpdater.stopPeriodicUpdate();
// diable notification on all secondary tile
var notifications = Windows.UI.Notifications;
Windows.UI.StartScreen.SecondaryTile.findAllAsync().then(function (tiles) {
if (tiles) {
tiles.forEach(function (tile) {
try {
notifications.TileUpdateManager.createTileUpdaterForSecondaryTile(tile.tileId).clear();
notifications.TileUpdateManager.createTileUpdaterForSecondaryTile(tile.tileId).stopPeriodicUpdate();
} catch (ex) {
// Problem in parsing tile arguments. Ignore this tile.check pa
}
});
}
}, function (e) {
// error condition, right now not doing anything.
});
},
_isInitialized: null,
initializeSecondaryTiles: function initializeSecondaryTiles() {
if (!this._isInitialized) {
this.updateAllTiles();
this._isInitialized = true;
}
},
});
})();
