﻿(function () {
"use strict";
WinJS.Namespace.define("SportsJS.Services",
{
/* Sports app manager */
AppManager: WinJS.Class.define(function () {
window.$AppMgr = window.$AppMgr || this;
try {
var localSettings = Windows.Storage.ApplicationData.current.localSettings;
if (localSettings.values["isFirstTimeLaunch"] !== false) {
localSettings.values["isFirstTimeLaunch"] = false;
window.$AppMgr.isFirstTimeLaunch = true;
}
} catch (e) { }
}, {
_jsCache: null,
jsCache: {
get: function get() {
if (!$AppMgr._jsCache) {
$AppMgr._jsCache = new SportsJS.Utilities.JsResponseCache(100);
}
return $AppMgr._jsCache;
}
},
_jsController: null,
jsController: {
get: function get() {
if (!$AppMgr._jsController) {
$AppMgr._jsController = new SportsJS.JsController();
}
return $AppMgr._jsController;
}
},
_modelInstance: null,
model: {
get: function get() {
if (!$AppMgr._modelInstance) {
$AppMgr._modelInstance = new SportsJS.Services.AppModel({});
}
return $AppMgr._modelInstance;
}
},
}),
/* Sports singleton */
mainProcessManager: null,
ProcessManager: WinJS.Class.define(function (element, options) {
var that = this;
window.$SpMgr = this;
this._customKeyValueConfig = {};
this.navController = new SportsJS.NavController();
this.channelManager = new SportsJS.Navigation.ChannelManager();
// Initialize networking services
SportsJS.Networking.initialize();
that._setUpEnumStrings();
that._setupLazyProperties();
// not - network init here, should be done only once
that._init();
that._isImmediateLoad = options && typeof options.isImmediateLoad !== 'undefined' ? options.isImmediateLoad : false;
},
{
/*handle to all the static data */
_staticDataAsync: null,
_currentPage: null,
_snappedSport: null,
_cmsPreviewEnabled: false,
_search: null,
_isFirstPageLoad: true,
_isFirstPerceivedPageLoad: true,
_isImmediateLoad: false,
// keep handle to search object. This is singleton and will provide
// search and suggestion to sports app
search: {
get: function get() {
if (this._search === null) {
this._search = new SportsJS.Search();
}
return this._search;
}
},
currentPage: {
get: function get() {
return this._currentPage;
},
set: function set(value) {
this._currentPage = value;
}
},
snappedSport: {
get: function get() {
return this._snappedSport;
},
set: function set(value) {
this._snappedSport = value;
}
},
cmsPreviewEnabled: {
get: function get() {
return this._cmsPreviewEnabled;
},
set: function set(value) {
this._cmsPreviewEnabled = value;
}
},
staticData: {
get: function get() {
return this._staticData;
}
},
_processListener: null,
processListener: {
get: function get() {
//should always be initialized
if (this._processListener) {
return this._processListener;
}
throw new Error("_processListener is not initialized");
},
},
_heroLocalCache: null,
heroLocalCache: {
get: function get() {
if (!this._heroLocalCache) {
var heroLocalCacheSize = 20;
// we can afford larger size as these are just boolean values
this._heroLocalCache = new SportsJS.Utilities.LocalCache("HeroCacheContainer", heroLocalCacheSize);
}
return this._heroLocalCache;
}
},
_uiThreadTimer: null,
uiThreadTimer: {
get: function get() {
if (!this._uiThreadTimer) {
this._uiThreadTimer = new SportsJS.Utilities.UiThreadTimer();
}
return this._uiThreadTimer;
}
},
_recyclableTemplatePool: null,
recyclableTemplatePool: {
get: function get() {
if (!this._recyclableTemplatePool) {
// cache to save meta data of sports module layout. 100 => max no of entries in cache
var recyclableTemplatePoolSize = 200;
this._recyclableTemplatePool = new SportsJS.Utilities.RecylableTemplatePool(recyclableTemplatePoolSize);
}
return this._recyclableTemplatePool;
}
},
_moduleLayoutCache: null,
moduleLayoutCache: {
get: function get() {
if (!this._moduleLayoutCache) {
// cache to save meta data of sports module layout. 100 => max no of entries in cache
var moduleLayoutCacheSize = 100;
this._moduleLayoutCache = new SportsJS.Utilities.LocalCache("ModuleLayoutCacheContainer", moduleLayoutCacheSize);
}
return this._moduleLayoutCache;
}
},
_lkgScheduleDatesContainer: null,
lkgScheduleDatesContainer: {
get: function get() {
if (!this._lkgScheduleDatesContainer) {
var containerKey = "LKGScheduleDates";
var containers = Windows.Storage.ApplicationData.current.localSettings.containers;
if (containers.hasKey(containerKey)) {
this._lkgScheduleDatesContainer = containers.lookup(containerKey);
} else {
this._lkgScheduleDatesContainer = Windows.Storage.ApplicationData.current.localSettings.createContainer(containerKey, Windows.Storage.ApplicationDataCreateDisposition.always);
}
}
return this._lkgScheduleDatesContainer;
}
},
_pageVisitedStatusContainer: null,
pageVisitedStatusContainer: {
get: function get() {
if (!this._pageVisitedStatusContainer) {
var containerKey = "PageVisitedStatus";
var containers = Windows.Storage.ApplicationData.current.localSettings.containers;
if (containers.hasKey(containerKey)) {
this._pageVisitedStatusContainer = containers.lookup(containerKey);
} else {
this._pageVisitedStatusContainer = Windows.Storage.ApplicationData.current.localSettings.createContainer(containerKey, Windows.Storage.ApplicationDataCreateDisposition.always);
}
}
return this._pageVisitedStatusContainer;
}
},
// control matchup page enable or disable
_isMatchupEnabled: false,
_appInitAsyncPromise: null,
appInitAsyncPromise: {
get: function get() {
return this._appInitAsyncPromise;
}
},
// do not use this private variable ever, only for init
_userLeagues: null,
userLeagues: {
get: function get() {
var leagues = SportsJS.Services.RoamingData.getUserLeagueNames();
leagues = SportsJS.Utilities.nativeArrayToJsArray(leagues);
return leagues;
}
},
reorderUserLeagues: function reorderUserLeagues(leagueOrder) {
SportsJS.Services.RoamingData.reorderLeagueNames(leagueOrder);
},
// Property determining whether we should enable the environment drop-down
_enableEnvDropDown: null,
enableEnvDropDown: {
get: function get() {
if (this._enableEnvDropDown === null) {
this._enableEnvDropDown = AppEx.Sports.Services.Utils.enableEnvDropDown();
}
return this._enableEnvDropDown;
}
},
//return true if league is a valid user leagues
isValidUserLeague: function isValidUserLeague(league) {
if (league && this.userLeagues && this.userLeagues.length > 0 && this.userLeagues.indexOf(league) !== -1) {
return true;
}
return false;
},
sportsJsController: {
get: function get() {                    
return $AppMgr.jsController;
}
},
jsCache: {
get: function get() {                    
return $AppMgr.jsCache;
}
},
isFirstPageLoad: {
get: function get() {
return this._isFirstPageLoad;
}
},
_isFREPage: null,
isFREPage: {
get: function get() {
if (this._isFREPage !== null) {
return this._isFREPage;
}
var localSettings = Windows.Storage.ApplicationData.current.localSettings;
var value = localSettings.values["isFREPage"];
this._isFREPage = true;
if (typeof value === "string" && value === "false") {
this._isFREPage = false;
}
return this._isFREPage;
},
set: function set(value) {
if (value !== false) {
SportsJS.Utilities.interfaceException("SpMgr", "Invalid value. Could not set FRE page setting");
return;
}
var localSettings = Windows.Storage.ApplicationData.current.localSettings;
localSettings.values["isFREPage"] = "false";
this._isFREPage = false;
}
},
_scheduleController: null,
scheduleController: {
get: function get() {
if (!this._scheduleController) {
this._scheduleController = AppEx.Sports.Services.TodayScheduleSportsController();
}
return this._scheduleController;
}
},
// Placeholder introduces lot of tricky situations
// Disabled required until further decision
isPlaceholderFeatureEnabled: {
get: function get() {
return false;
}
},
_allSupportedLeagues: [],
allSupportedLeagues: {
get: function get() {
var supportedLeaguesList = SportsJS.Services.ConfigData.getAllLeagueNames();
supportedLeaguesList = SportsJS.Utilities.nativeArrayToJsArray(supportedLeaguesList);
return supportedLeaguesList;
}
},
_allSupportedSports: [],
allSupportedSports: {
get: function get() {
var supportedSportsList = SportsJS.Services.ConfigData.getAllSportsNames();
supportedSportsList = SportsJS.Utilities.nativeArrayToJsArray(supportedSportsList);
return supportedSportsList;
}
},
_processorSpeedFactor: null, //requires setting atleast once
processorSpeedFactor: {
get: function get() {
// lazy
if (this._processorSpeedFactor === null) {
this._processorSpeedFactor = SportsJS.Utilities.getProcessorSpeedFactor();
}
return this._processorSpeedFactor;
}
},
model: {
get: function get() {                    
return $AppMgr.model;
}
},
_customKeyValueConfig: null,
customKeyValueConfig: {
get: function get() {
return this._customKeyValueConfig;
},
set: function set(kvConfig) {
if (!kvConfig || kvConfig.length < 1) {
return;
}
for (var kk = 0; kk < kvConfig.length; kk++) {
this._customKeyValueConfig[kvConfig[kk].Key] = kvConfig[kk].Value;
}
}
},
// AppData, holds leagueInfo, Sportsinfo, NavLinks used at Applevel
appData: null,
_leagueInfoTable: null,
// this table has extra information as compared to c# counter part
leagueInfoTable: {
get: function get() {
if(!this._leagueInfoTable) {
var leaguesInfo = this.appData;
if (!this.appData || !this.appData.LeaguesInfo) {
return {};
}
this._leagueInfoTable = {};
for(var kk = 0, maxLength = this.appData.LeaguesInfo.length; kk < maxLength; kk++) {
var info = this.appData.LeaguesInfo[kk];
this._leagueInfoTable[info.LeagueName] = info;
}
}
return this._leagueInfoTable;
}
},
appInitAsync: function appInitAsync() {
return WinJS.Promise.wrap(true);
},
_setUpEnumStrings: function _setUpEnumStrings() {
$SpMgr.enumStrings = {};
$SpMgr.enumStrings.ClusterType = SportsJS.Utilities.getEnumStringsHashFromManagedEnums(Microsoft.AppEx.Sports.SportsEnums.ClusterType);
$SpMgr.enumStrings.LeagueType = SportsJS.Utilities.getEnumStringsHashFromManagedEnums(Microsoft.AppEx.Sports.SportsEnums.League);
$SpMgr.enumStrings.SportsType = SportsJS.Utilities.getEnumStringsHashFromManagedEnums(Microsoft.AppEx.Sports.SportsEnums.Sport);
$SpMgr.enumStrings.EditorialCollectionType = SportsJS.Utilities.getEnumStringsHashFromManagedEnums(AppEx.Sports.Services.TypeDefs.EditorialCollectionType);
$SpMgr.enumStrings.UiScenario = SportsJS.Utilities.getEnumStringsHashFromManagedEnums(AppEx.Sports.Services.TypeDefs.Request.UiScenarioEnum);
$SpMgr.enumStrings.PageStatus = SportsJS.Utilities.getEnumStringsHashFromManagedEnums(Microsoft.AppEx.Sports.SportsEnums.PageStatus);
$SpMgr.enumStrings.GameState = SportsJS.Utilities.getEnumStringsHashFromManagedEnums(Microsoft.AppEx.Sports.SportsEnums.GameState);
},
_setupLazyProperties: function _setupLazyProperties() {
SportsJS.Services.Roaming = {};
Object.defineProperty(SportsJS.Services.Roaming, "RoamingDataManager", {
get: function get() {
if (!SportsJS.Services.Roaming._roamingDataManager) {
SportsJS.Services.Roaming._roamingDataManager = AppEx.Sports.Services.Storage.RoamingDataManager.instance;
}
return SportsJS.Services.Roaming._roamingDataManager;
}
});                
Object.defineProperty(SportsJS.Services, "RoamingData", {
get: function get() {
if (!SportsJS.Services._roamingData) {
SportsJS.Services._roamingData = AppEx.Sports.Services.Storage.RoamingData;
}
return SportsJS.Services._roamingData;
}
});
Object.defineProperty(SportsJS.Services, "ConfigData", {
get: function get() {
if (!SportsJS.Services._configData) {
SportsJS.Services._configData = AppEx.Sports.Services.SportsConfigurationManager;
}
return SportsJS.Services._configData;
}
});
Object.defineProperty(SportsJS.UI, "SportsEntityCollectionType", {
get: function get() {
if (!SportsJS.UI._sportsEntityCollectionType) {
SportsJS.UI._sportsEntityCollectionType = Object.freeze({
MyTeams: {
name: "MyTeams",
entityFlavor: AppEx.Sports.Services.AppSearchProvider.entityTypeTeam,
entityType: AppEx.Sports.Services.TypeDefs.SportsEntityType.team,
detailPageChannel: "MyTeams",
},
MyPlayers: {
name: "MyPlayers",
entityFlavor: AppEx.Sports.Services.AppSearchProvider.entityTypePlayer,
entityType: AppEx.Sports.Services.TypeDefs.SportsEntityType.player,
detailPageChannel: "MyPlayers",
},
MyLeagues: {
name: "MyLeagues",
entityFlavor: null,
entityType: AppEx.Sports.Services.TypeDefs.SportsEntityType.league,
detailPageChannel: null,
}
});
}
return SportsJS.UI._sportsEntityCollectionType;
}
});
Object.defineProperty(SportsJS, "SettingsManager", {
get: function get() {
if (!SportsJS._settingsManager) {
SportsJS._settingsManager = AppEx.Sports.Services.Storage.SettingsManager.instance;
}
return SportsJS._settingsManager;
}
});
Object.defineProperty(SportsJS, "SettingsType", {
get: function get() {
if (!SportsJS._settingsType) {
SportsJS._settingsType = AppEx.Sports.Services.Storage.SettingsType;
}
return SportsJS._settingsType;
}
});
},
getLeagueString: function getLeagueString(league) {
return $SpMgr.enumStrings.LeagueType[league];
},
getGameStateString: function getGameStateString(gameState) {
return $SpMgr.enumStrings.GameState[gameState];
},
getClusterString: function getClusterString(league) {
return $SpMgr.enumStrings.ClusterType[league];
},
hasSuccessfullyInitialzed: false,
// handle to pending promise
_initializeAsyncPromise: null,
_isValidInitializeAsyncPromise: false,
initializeAsyncPromise: {
get: function get() {
return this._initializeAsyncPromise;
},
set: function set(value) {
this._initializeAsyncPromise = value;
}
},
isAppInitialized: false,
// we do not copy all the fields into the app data singleton in C#
// for performance resons. Many of the fields are not actually required
_isAppDataOptimized: true,
_constructAllAppData: function _constructAllAppData(res) {
if (!res || !res.isValid) {
return null;
}
var profileMark = "Sports:Services:_constructAllAppData";
SportsJS.Utilities.sportsMsWriteProfilerMark(profileMark + ":s");                
var sdiResponse = SportsJS.Utilities.jsonParse(res.dataString);
if (!sdiResponse || !sdiResponse.Results || sdiResponse.Results.length < 1 || !sdiResponse.Results[0].Response) {
SportsJS.Utilities.sportsMsWriteProfilerMark(profileMark + ":e");
return null;
}
var coreData = sdiResponse.Results[0].Response;
var sportsData = new Microsoft.AppEx.Sports.Schemas.App.AppAllSportsInfoSchema();
for (var rr = 0, maxDefaultLeaguesLength = coreData.DefaultLeagues.length; rr < maxDefaultLeaguesLength; rr++) {
sportsData.defaultLeagues.append(coreData.DefaultLeagues[rr]);
}
// LeagueInfo copying into CS object from JS Object 
for (var kk = 0, maxLeaguesLength = coreData.LeaguesInfo.length; kk < maxLeaguesLength; kk++) {
var csLeagueInfo = new Microsoft.AppEx.Sports.Schemas.App.LeagueMetaInfoSchema();
var jsLeagueInfo = coreData.LeaguesInfo[kk];
csLeagueInfo.leagueName = jsLeagueInfo.LeagueName;
csLeagueInfo.leagueDisplayName = jsLeagueInfo.LeagueDisplayName;
csLeagueInfo.leagueGroupName = jsLeagueInfo.LeagueGroupName;
csLeagueInfo.sportsType = jsLeagueInfo.SportsType;
if(!this._isAppDataOptimized) {
// this is not required in C#, I do not see any requirement coming too,
// keeping the code
csLeagueInfo.isNewLeague = jsLeagueInfo.IsNewLeague;
csLeagueInfo.isDefaultLeague = jsLeagueInfo.IsDefaultLeague;
csLeagueInfo.marketWeight = jsLeagueInfo.MarketWeight;
// navLinks are always non-null
for (var mm = 0; mm < jsLeagueInfo.NavLinks.length; mm++) {
var csNavLink = new Microsoft.AppEx.Sports.Schemas.App.NavLinkSchema();
var jsNavLink = jsLeagueInfo.NavLinks[mm];
csNavLink.id = jsNavLink.Id;
csNavLink.title = jsNavLink.Title;
csNavLink.link.instId = jsNavLink.Link.InstId;
csNavLink.link.text = jsNavLink.Link.Text;
csNavLink.link.uri = jsNavLink.Link.Uri;
csLeagueInfo.navLinks.append(csNavLink);
}
}
sportsData.leaguesInfo.append(csLeagueInfo);
}
// SportsInfo copying into CS object from JS Object
for (var tt = 0, maxSports = coreData.SportsInfo.length; tt < maxSports; tt++) {
var jsSportInfo = coreData.SportsInfo[tt];
var csSportsInfo = new Microsoft.AppEx.Sports.Schemas.App.SportMetaInfoSchema();
csSportsInfo.sportName = jsSportInfo.SportName;
csSportsInfo.sportDisplayName = jsSportInfo.SportDisplayName;
sportsData.sportsInfo.append(csSportsInfo);
}
SportsJS.Services.ConfigData.initializeAllSportsInfo(sportsData);
this.customKeyValueConfig = coreData.CustomKeyValueConfig;
SportsJS.Utilities.sportsMsWriteProfilerMark(profileMark + ":e");
return coreData;
},
// This function fetches app model data and initializes the components which need to wait for successful network complete 
_networkDependentInitialize: function _networkDependentInitialize(isRefresh) {
var that = this;
// return the already executed operation promise if it has already succeeded
if (that.initializeAsyncPromise && that._isValidInitializeAsyncPromise) {
return this.initializeAsyncPromise;
}
that._isValidInitializeAsyncPromise = true;
that.initializeAsyncPromise = this.model.getData(!!isRefresh).then(function (res) {
that.appData = that._constructAllAppData(res);  
if (!that.appData) {
that.initializeAsyncPromise = null;
that._isValidInitializeAsyncPromise = false;
return WinJS.Promise.wrapError(false);
}
var timeout = that._isImmediateLoad ? 0 : 10000;
setTimeout(function () {
CommonJS.Progress.canDestroySplash(true);
CommonJS.Progress.destroySplash(true);
SportsJS.mainProcessManager.processListener.onFirstPageLoad();
SportsJS.mainProcessManager.processListener.onFirstPerceivedPageLoad();
}, timeout);
// Perf optimization: at startup we consume the cached data though it is stale. 
// So scheduling a task to run after 10s (minimum) or whenever the data expires 
// to update the cache with fresh data so that we consume it in next app start.
if (res) {
var appDataFetchTimeout = (res.maxAge && res.maxAge > 10 ? res.maxAge : 10) * 1000;
setTimeout(function () {
// no tracking/error handling required for this.
that.model.getData(true);
}, appDataFetchTimeout);
}
that.isAppInitialized = true;
return true;
}, function () {
that._isValidInitializeAsyncPromise = false;
that.initializeAsyncPromise = null;
return WinJS.Promise.wrapError(false);
});
return that.initializeAsyncPromise;
},
// public exposed init method
initializeAsync: function initializeAsync(isRefresh) {
var that = this;
return that._networkDependentInitialize(isRefresh);
},
// reference to current size of the screen
_screenSize: null,
// get current size of screen
screenSize:  {
get: function get() {
var that = this;
if(!that._screenSize) {
var updateScreenSize = function () {
that._screenSize = {};
that._screenSize.width = document.body.clientWidth;
that._screenSize.height = document.body.clientHeight;
};
updateScreenSize();
window.removeEventListener("resize", updateScreenSize);
window.addEventListener("resize", updateScreenSize);
}
return that._screenSize;
}                
},
//// flush all sports specific caches
_flushCache: function _flushCache() {
$SpMgr.heroLocalCache.flushCache();
$SpMgr.jsCache.flushCache();
},
// function to initialize sports specific caches
_initSportsCache: function _initSportsCache() {
try {                    
// check we have to flush our caches
var localSettings = Windows.Storage.ApplicationData.current.localSettings;
var value = localSettings.values["Sports_DeleteAllCache"];
if (value === true) {
this._flushCache();
}
localSettings.values["Sports_DeleteAllCache"] = false;
} catch (e) {
// we should not be reaching here. Can do resetApp??
}
},
// internal method
_init: function _init() {
var that = this;
var profileMark = "Sports:Services:Init";
SportsJS.Utilities.sportsMsWriteProfilerMark(profileMark + ":s");
var processListeners = PlatformJS.mainProcessManager._processListeners;
for (var kk = 0; kk < processListeners.length; kk++) {
if (processListeners[kk] instanceof SportsJS.ProcessListener) {
that._processListener = processListeners[kk];
break;
}
}
// Search object construction alone happens here. Actual initialization will happen after appInitAsync.
// Initialize nav controller
SportsJS.Utilities.initCloudPano();
PlatformJS.Navigation.addCommonEntityViews();
WinJS.UI.disableAnimations();
that._initSportsCache();
SportsJS.Utilities.sportsMsWriteProfilerMark(profileMark + ":e");
}
}),
/// <summary>
/// Do initialization of app
/// </summary>
/// <returns>
/// Nothing
/// </returns>
initializeAync: function initializeAync(isImmediateLoad) {
if (!SportsJS.mainProcessManager) {
SportsJS.mainProcessManager = new SportsJS.Services.ProcessManager(null, { isImmediateLoad: isImmediateLoad });
}
return SportsJS.mainProcessManager.initializeAsync();
},
// App Model . Fetches data for app
AppModel: WinJS.Class.define(function () {
}, {
_isValidDataPromise: false,
_dataPromise: null,
getData: function getData(isRefresh) {
if (isRefresh === false && this._dataPromise && this._isValidDataPromise) {
return this._dataPromise;
}
var that = this;
// create instance of query  (uiQuery in C# SportsService)
var constructQuery = function (params) {
var query = new AppEx.Sports.Services.TypeDefs.Request.AllSportsInfoQuery();
if (!query || !query.isValid) {
return null;
}
if (params && typeof params.canConsumeStaleResponse !== "undefined" && typeof params.bypassCache !== "undefined") {
query.canConsumeStaleResponse = params.canConsumeStaleResponse;
query.bypassCache = params.bypassCache;
}
// TODO: arengak/chthakur - set the type in CS constructor itself.
query.storageType = SportsJS.Consts.storageType.IE;
return query;
};
//chthakur -> always consume stale?? is that fine
var requestQuery = constructQuery({ canConsumeStaleResponse: !isRefresh, bypassCache: isRefresh });
// we need to bypass JS controller here, need to populate sports info in configuration manager.
// this info can be used both in C# and JS, so forcing to skip JSCache is required
this._isValidDataPromise = true;
this._dataPromise = $AppMgr.jsController.requestV2(requestQuery, null).then(function (completeRes) {
return WinJS.Promise.wrap(completeRes);
}, function (errRes) {
this._isValidDataPromise = false;
return WinJS.Promise.wrapError(errRes);
});
return this._dataPromise;
},
prefetchGetStartedData: function prefetchGetStartedData() {
var query = new AppEx.Sports.Services.TypeDefs.Request.GettingStartedClusterQuery(null);
if (!query || !query.isValid) {
return null;
}
query.canConsumeStaleResponse = true;
query.storageType = SportsJS.Consts.storageType.IE;
var transformer = function (data) {
var result = null;
try {
result = data && SportsJS.Utilities.jsonParse(data.dataString);
} catch (exp) {
return null;
}
if (!result) {
return null;
}
var tempClusterProvider = new CommonJS.TempClusterDataProvider();
var messageData = tempClusterProvider.parseData(result);
return { type: "TempClusterViewControl", messageData: messageData, isValid: true, etag: data.etag, templateName: "gsTemplate" };
};
return $AppMgr.jsController.requestV2(query, transformer).then(function () { }, function () { });
},
prefetchTodayHeroData: function prefetchTodayHeroData(heroSetting) {
var market = SportsJS.Utilities.getCMSHeroMarketString(heroSetting);
var pageId = SportsJS.Utilities.getLeagueCmsMappings("today");
var uiQuery = new AppEx.Sports.Services.TypeDefs.Request.CMSHeroQuery(pageId, false, market);
return AppEx.Sports.Services.SportsController().request(uiQuery).then(function () { }, function () { });
}
})
});
})();
