﻿(function () {
'use strict';
//// function to set cache flush setting. We flush sports specific caches during app initialization if the setting is set to true.
//// Note: Platform sets "Platform_DeleteAllCache" setting when it needs to flush the cache. eg: versions.xml update.
//// We want to flush Sports's caches when Platform flushes its caches in order to be in sync
//// But currently, we dont get any event/signal from platform when it is flushing its caches.
//// Hence using "Platform_DeleteAllCache" setting to decide whether we need to flush the caches.
//// Reference: CreateRootCacheFolderAsync function in Platform's CacheManager.cs and OnInitialize in Process.cs
var setCacheFlushFlag = function () {
try {
var flag = false;
var localSettings = Windows.Storage.ApplicationData.current.localSettings;
// TODO: arengak - consider dirtyShutdownCount???
if (localSettings.values["Platform_DeleteAllCache"] === true || localSettings.values["Platform_FlushCaches"] === 1) {
flag = true;
}
localSettings.values["Sports_DeleteAllCache"] = flag;
} catch (e) {
}
};
var initAppManager = function () {
return new SportsJS.Services.AppManager();
};
setCacheFlushFlag();
initAppManager();
PlatformJS.initialize();
WinJS.Application.start();
})();