﻿/********************************************************
*                                                        *
*   © Microsoft. All rights reserved.                    *
*                                                        *
*********************************************************/
(function () {
"use strict";
WinJS.Namespace.define("SportsJS",
{
/// <disable>JS3058</disable>
ArticleReaderPage: WinJS.Class.derive(DynamicPanoJS.DynamicArticleReaderPage, function (state) {
DynamicPanoJS.DynamicArticleReaderPage.call(this, state);
this._state = state;
},
{
_state: null,
isDeeplinkSharable: true,
_sharingUrl: null,
pageUri: {
get: function get() {
if (!this._state || !this._state.initialArticleId) {
return null;
}
var initialArticleId = this._state.initialArticleId;
var idSplit = initialArticleId.split('/');
var pageId = idSplit[0];
var contentId;
if (idSplit.length >= 2) {
contentId = idSplit[1];
}
var uriBuilder = new Platform.Utilities.AppExUriBuilder();
uriBuilder.controllerId = SportsJS.NavControllers.application;
uriBuilder.commandId = SportsJS.NavCommand.view;
uriBuilder.queryParameters.insert("entitytype", SportsJS.NavEntityType.article);
uriBuilder.queryParameters.insert("pageId", pageId);
if (contentId) {
uriBuilder.queryParameters.insert("contentId", contentId);
}
if (this._state.market) {
uriBuilder.queryParameters.insert("market", this._state.market);
}
return uriBuilder.toString();
},
},
sharingUrl: {
get: function get() {
return this._sharingUrl;
}
},
pageTitle: {
get: function get() {
if (this._shareData && this._shareData.title) {
return this._shareData.title;
}
return null;
}
},
shareDescription: {
get: function get() {
if (this._shareData && this._shareData.description) {
return this._shareData.description;
}
return null;
}
},
shareText: {
get: function get() {
if (!this._shareData) {
return null;
}
var text = this.pageTitle;
if (this._shareData.author) {
text = text + "\n" + this._shareData.author;
}
if (this._shareData.description) {
text = text + "\n" + this._shareData.description;
}
if (this._shareData.content) {
text = text + "\n" + this._shareData.content;
}
text = text + "\n" + this.pageUri;
return text;
}
},
// specifies the memory leak factor
countWeight: {
get: function get() {
var that = this;
return SportsJS.Utilities.getMemoryContributionWeightFactorForPage();
}
},
_shareData: null,
_handleShareRequestImpl: function _handleShareRequestImpl(request, shareData) {
var title = "";
var author = "";
var description = "";
var content = "";
if (shareData.articleHeader.headline) {
title = shareData.articleHeader.headline;
}
if (shareData.articleHeader.author) {
author = shareData.articleHeader.author;
}
if (shareData.articleHeader.publisherName) {
description = shareData.articleHeader.publisherName;
}
if (shareData.articleHeader.date) {
if (description) {
description += " - ";
}
description += shareData.articleHeader.date;
}
if (shareData.articleHeader.snippet) {
content = shareData.articleHeader.snippet;
}
if (shareData.articleHeader.sharingUrl) {
this._sharingUrl = shareData.articleHeader.sharingUrl;
if (typeof this._sharingUrl === "string" && this._sharingUrl.length > 0) {
this._sharingUrl += "?a=1&m=" + Windows.Foundation.Uri.escapeComponent(shareData.pageState.market);
}
}
this._shareData = {
title: title,
author: author,
description: description,
descriptionDisplayStyle: description ? "" : "none",
content: content,
contentDisplayStyle: content ? "" : "none"
};
},
})
});
})();
