﻿(function () {
'use strict';
////TODO: v-yokuma write ETW events are missing.
WinJS.Namespace.define('SportsJS.Common.ECV', {
LeaguePlayersCollection: WinJS.Class.derive(SportsJS.ECV.BaseCollection, function (options) {
var that = this;
that.options = options || {};
that._data = [];
that._league = options.league;
SportsJS.Utilities.ECV.addLeagueClass(options.leagueClass);
SportsJS.ECV.BaseCollection.call(that, options);
}, {
/*CommonJS.EntityCollection.Collection Members*/
_league: null,
impressionContext: {
get: function get() {
return SportsJS.Utilities.stringFormat("/{0}", SportsJS.UI.ecvType.LeaguePlayers);
}
},
Initialize: function Initialize(config) {
if (!config) {
/* we need to show error message here as ECV can not initialize */
return;
}
var that = this;
SportsJS.Telemetry.logECVContentView(SportsJS.UI.ecvType.LeaguePlayers, that._league);
//create the provider object
var parameterDictionary = PlatformJS.Collections.createStringDictionary();
parameterDictionary.insert('league', config.league);
parameterDictionary.insert('statType', config.statType);
/// if conference is there, send conference also
if (config.conference) {
parameterDictionary.insert('conference', config.conference);
}
that.Provider = new AppEx.Sports.Services.DataServies.ECVProvider("LeaguePlayers", config.league, parameterDictionary);
//create the UIConfig object
that.UIConfig = config.UIConfig || new SportsJS.Common.ECV.LeaguePlayersUIConfig(that._league, { providerObj: that.Provider });
that.DataConfig = config.DataConfig || new CommonJS.EntityCollection.DataConfig();
//initialize and call the base
that._providerConfig = PlatformJS.Collections.createStringDictionary();
that._providerConfig.insert('league', config.playerid);
that._providerConfig.insert('statType', config.statType);
return SportsJS.ECV.BaseCollection.prototype.Initialize.call(that, config);
}
}),
LeaguePlayersUIConfig: WinJS.Class.derive(SportsJS.ECV.UIConfig, function (league, options) {
var that = this;
that._league = league;
SportsJS.ECV.UIConfig.call(that, options);
WinJS.UI.setOptions(that, options);
}, {
_league: null,
SetFilterType: function SetFilterType(filter) {
filter.type = 'DropDown';
filter.selectionMode = 'SingleToggleFilter';
},
OnItemClicked: function OnItemClicked(entity) {
var that = this;
if (entity && entity.PlayerId && entity.PlayerName) {
if ((Microsoft.AppEx.Sports.SportsEnums.League[that._league] !== Microsoft.AppEx.Sports.SportsEnums.League.pga) &&
(!SportsJS.Utilities.isLeagueSoccerType(that._league))) {
PlatformJS.Navigation.navigateToChannel(SportsJS.UI.PageType.Player, { leagueType: that._league, teamId: entity.TeamId, playerId: entity.PlayerId, playerFullName: entity.PlayerName });
return true;
}
}
return false;
},
})
});
})();
