﻿(function () {
"use strict";
WinJS.Namespace.define("SportsJS.Common.ECV", {
SchedulesECVCollection: WinJS.Class.derive(SportsJS.ECV.BaseCollection, function (options) {
SportsJS.ECV.BaseCollection.call(this, options);
var that = this;
this.options = options || {};
this._data = [];
that._league = options.league;
that._secondtime = 0;
SportsJS.Utilities.ECV.addLeagueClass(options.leagueClass);
SportsJS.ECV.BaseCollection.call(that, options);
}, {
/*PlatformJS.UI.EntityCollection.Collection Members*/
_league: null,
impressionContext: {
get: function get() {
return SportsJS.Utilities.stringFormat("/{0}", SportsJS.UI.ecvType.LeagueSchedule);
}
},
Initialize: function Initialize(state) {
if (!state) {
return;
}
var that = this;
that._league = state.league;
SportsJS.Telemetry.logECVContentView(SportsJS.UI.ecvType.LeagueSchedule, that._league);
//create the provider object
var parameterDictionary = PlatformJS.Collections.createStringDictionary();
parameterDictionary.insert('league', state.league);
that.Provider = new AppEx.Sports.Services.DataServies.ECVProvider("LeagueSchedule", state.league, parameterDictionary);
//create the UIConfig object
that.UIConfig = state.UIConfig || new SportsJS.Common.ECV.SchedulesUIConfig(that._league, { providerObj: that.Provider });
that.DataConfig = state.DataConfig || new CommonJS.EntityCollection.DataConfig();
//initialize and call the base
that._providerConfig = PlatformJS.Collections.createStringDictionary();
that._providerConfig.insert('league', state.league); 
return SportsJS.ECV.BaseCollection.prototype.Initialize.call(that, state);
}
}),
SchedulesUIConfig: WinJS.Class.derive(SportsJS.ECV.UIConfig, function (league, options) {
var that = this;
that._league = league;
SportsJS.ECV.UIConfig.call(this, options);
WinJS.UI.setOptions(this, options);
},
{
GetTableDefinition: function GetTableDefinition(entities) {
var that = this;
var scheduleFilters = document.querySelectorAll(".immersiveDropDownFilterContainer");
var isPostSeasonSelected = false;
var itr = 0;
if (that.providerObj && that.providerObj.filterMetadata) {
for (itr = 0; itr < that.providerObj.filterMetadata.length; itr++) {
if (that.providerObj.filterMetadata[itr].attribute === "Filter-Seasons" && that.providerObj.filterMetadata[itr].items) {
for (var ik = 0; ik < that.providerObj.filterMetadata[itr].items.length; ik++) {
if (that.providerObj.filterMetadata[itr].items[ik].selected === true && that.providerObj.filterMetadata[itr].items[ik].value === "PostSeason-Filter") {
isPostSeasonSelected = true;
break;
}
}
break;
}
}
}
var groupKey = "";
var movesFilter = null;
if (scheduleFilters) {
if (isPostSeasonSelected) {
for (itr = 0 ; itr < scheduleFilters.length; itr++) {
groupKey = scheduleFilters[itr].getAttribute("groupKey");
if (groupKey && groupKey !== "Filter-Seasons") {
scheduleFilters[itr].style.display = "none";
}
}
}
else {
for (itr = 0 ; itr < scheduleFilters.length; itr++) {
scheduleFilters[itr].style.display = "";
}
}
for (itr = 0 ; !isPostSeasonSelected && itr < scheduleFilters.length; itr++) {
groupKey = scheduleFilters[itr].getAttribute("groupKey");
if (groupKey && groupKey === "Filter-Moves") {
scheduleFilters[itr].style.display = "none";
movesFilter = scheduleFilters[itr];
break;
}
}
}
if (movesFilter) {
var nextPrevContainer = document.getElementById("NextPreviousButton");
if (nextPrevContainer === null) {
var parentContainer = document.getElementById("filterBar");
nextPrevContainer = document.createElement("div");
nextPrevContainer.className = "nextPrevButtonContainer";
nextPrevContainer.id = "NextPreviousButton";
var prevIndicator = document.createElement("span");
prevIndicator.className = "ecvSchedulePrevIcon";
prevIndicator.id = "PrevIcon";
var prevButton = document.createElement("div");
prevButton.innerText = PlatformJS.Services.resourceLoader.getString("SchedulePrevFilterKeyLabel");
prevButton.id = "PreviousButton";
prevButton.className = "movePreviousButton";
var nextButton = document.createElement("div");
nextButton.innerText = PlatformJS.Services.resourceLoader.getString("ScheduleNextFilterKeyLabel");
nextButton.id = "NextButton";
nextButton.className = "moveNextButton";
var nextIndicator = document.createElement("span");
nextIndicator.className = "ecvScheduleNextIcon";
nextIndicator.id = "NextIcon";
var filterElement = movesFilter.querySelector(".immersiveFilterDrawerContainer");
if (filterElement && filterElement.winControl) {
var filterControl = filterElement.winControl;
prevButton.onclick = function (e) {
var filterItem = { displayText: prevButton.innerText, index: 1, isSelected: false, key: "Move-Prev" };
var event = { item: filterItem, selected: true };
filterControl.onSelectionChanged(event);
};
nextButton.onclick = function (e) {
var filterItem = { displayText: nextButton.innerText, index: 0, isSelected: false, key: "Move-Next" };
var event = { item: filterItem, selected: true };
filterControl.onSelectionChanged(event);
};
}
nextPrevContainer.appendChild(prevIndicator);
nextPrevContainer.appendChild(prevButton);
nextPrevContainer.appendChild(nextButton);
nextPrevContainer.appendChild(nextIndicator);
parentContainer.appendChild(nextPrevContainer);
}
}
var nextPrevContainerCheck = document.getElementById("NextPreviousButton");
if (nextPrevContainerCheck) {
if (isPostSeasonSelected) {
nextPrevContainerCheck.style.display = "none";
}
else {
nextPrevContainerCheck.style.display = "";
var nextButtonHandle = document.getElementById("NextButton");
var nextIconHandle = document.getElementById("NextIcon");
if (nextButtonHandle && nextIconHandle) {
if (this.providerObj && this.providerObj.isAtLastDisplayWindow()) {
nextButtonHandle.disabled = true;
nextButtonHandle.style.color = "#c0c0c0";
nextIconHandle.disabled = true;
nextIconHandle.style.color = "#c0c0c0";
}
else {
nextButtonHandle.disabled = false;
nextButtonHandle.style.color = "#ffffff";
nextIconHandle.disabled = false;
nextIconHandle.style.color = "#ffffff";
}
}
var prevButtonHandle = document.getElementById("PreviousButton");
var prevIconHandle = document.getElementById("PrevIcon");
if (prevButtonHandle && prevIconHandle) {
if (this.providerObj && this.providerObj.isAtFirstDisplayWindow()) {
prevButtonHandle.disabled = true;
prevButtonHandle.style.color = "#c0c0c0";
prevIconHandle.disabled = true;
prevIconHandle.style.color = "#c0c0c0";
}
else {
prevButtonHandle.disabled = false;
prevButtonHandle.style.color = "#ffffff";
prevIconHandle.disabled = false;
prevIconHandle.style.color = "#ffffff";
}
}
}
}
/* call base class table definition to change the properties for group definition */
var table = SportsJS.ECV.UIConfig.prototype.GetTableDefinition.apply(that, [entities]);
var title = document.querySelector("#filterBar_title");
if (title !== null) {
title.innerHTML = that._league + " " + PlatformJS.Services.resourceLoader.getString("LeagueScheduleECVLabel");
}
//// change the table properties for the group header.
table.GroupPosition = 'inline';
table.showGroupHeaders = true;
return table;
},
SetFilterType: function SetFilterType(filter) {
filter.type = 'DropDown';
switch (filter.attribute) {
case "Filter-Teams":
filter.selectionMode = 'Multiple';
break;
case "Filter-Moves":
case "Filter-Seasons":
filter.selectionMode = 'SingleToggleFilter';
break;
}
},
// invoke the Team  details when clicked on the team.
OnItemClicked: function OnItemClicked(entity) {
if (entity.ClickTarget) {
//// we need only this line to navigate
msSetImmediate(function () {
SportsJS.Utilities.navigateTo(entity.ClickTarget);
});
}
}
})
});
})();
