﻿(function () {
'use strict';
WinJS.Namespace.define('SportsJS.Common.ECV', {
StandingsECVCollection: WinJS.Class.derive(SportsJS.ECV.BaseCollection, function (options) {
SportsJS.ECV.BaseCollection.call(this, options);
var that = this;
this.options = options || {};
this._data = [];
that._league = options.league;
that._secondtime = 0;
SportsJS.Utilities.ECV.addLeagueClass(options.leagueClass);
SportsJS.ECV.BaseCollection.call(that, options);
}, {
/*CommonJS.EntityCollection.Collection Members*/
_league: null,
impressionContext: {
get: function get() {
return SportsJS.Utilities.stringFormat("/{0}", SportsJS.UI.ecvType.LeagueStandings);
}
},
Initialize: function Initialize(state) {
if (!state) {
/* we need to show error message here as ECV can not initialize */
return;
}
var that = this;
that._league = state.league;
SportsJS.Telemetry.logECVContentView(SportsJS.UI.ecvType.LeagueStandings, that._league);
//create the provider object
var parameterDictionary = PlatformJS.Collections.createStringDictionary();
parameterDictionary.insert('league', state.league);
that.Provider = new AppEx.Sports.Services.DataServies.ECVProvider("LeagueStandings", state.league, parameterDictionary);
//create the UIConfig object
that.UIConfig = state.UIConfig || new SportsJS.Common.ECV.StandingsUIConfig(that._league, { providerObj : that.Provider });
that.DataConfig = state.DataConfig || new CommonJS.EntityCollection.DataConfig();
//initialize and call the base
that._providerConfig = PlatformJS.Collections.createStringDictionary();
that._providerConfig.insert('league', state.league); //TODO:constants
return SportsJS.ECV.BaseCollection.prototype.Initialize.call(that, state);
},
}),
StandingsUIConfig: WinJS.Class.derive(SportsJS.ECV.UIConfig, function (league, options) {
var that = this;
that._league = league;
SportsJS.ECV.UIConfig.call(this, options);
WinJS.UI.setOptions(this, options);            
},
{
GetTableDefinition: function GetTableDefinition(entities) {
var that = this;
/* call base class table definition to change the properties for group definition */
var table = SportsJS.ECV.UIConfig.prototype.GetTableDefinition.apply(that, [entities]);
var child1, child2, child3, child4;
var parentItem = document.querySelector(".standingsLegend");
if (Microsoft.AppEx.Sports.SportsEnums.League[that._league] === Microsoft.AppEx.Sports.SportsEnums.League.mlb) {
if (parentItem !== null) {
child1 = parentItem.querySelector(".legendEntry1");
child2 = parentItem.querySelector(".legendEntry2");
if (child1 !== null) {
child1.innerHTML = PlatformJS.Services.resourceLoader.getString("ClinchedPlayoffMarker");
}
if (child2 !== null) {
child2.innerHTML = PlatformJS.Services.resourceLoader.getString("ClinchedDivisionMarker");
}
}
} else if ((Microsoft.AppEx.Sports.SportsEnums.League[that._league] !== Microsoft.AppEx.Sports.SportsEnums.League.soccer_chlg)
&& (Microsoft.AppEx.Sports.SportsEnums.League[that._league] !== Microsoft.AppEx.Sports.SportsEnums.League.soccer_wcq_afc)
&& (Microsoft.AppEx.Sports.SportsEnums.League[that._league] !== Microsoft.AppEx.Sports.SportsEnums.League.soccer_wcq_caf)
&& (Microsoft.AppEx.Sports.SportsEnums.League[that._league] !== Microsoft.AppEx.Sports.SportsEnums.League.soccer_wcq_concacaf)
&& (Microsoft.AppEx.Sports.SportsEnums.League[that._league] !== Microsoft.AppEx.Sports.SportsEnums.League.soccer_wcq_conmebol)
&& (Microsoft.AppEx.Sports.SportsEnums.League[that._league] !== Microsoft.AppEx.Sports.SportsEnums.League.soccer_wcq_ofc)
&& (Microsoft.AppEx.Sports.SportsEnums.League[that._league] !== Microsoft.AppEx.Sports.SportsEnums.League.soccer_wcq_uefa)) {
if (parentItem !== null) {
child1 = parentItem.querySelector(".legendEntry1");
child2 = parentItem.querySelector(".legendEntry2");
child3 = parentItem.querySelector(".legendEntry3");
if (child1 !== null) {
child1.innerHTML = PlatformJS.Services.resourceLoader.getString("ConferenceFirstMarker");
}
if (child2 !== null) {
child2.innerHTML = PlatformJS.Services.resourceLoader.getString("ClinchedPlayoffMarker");
}
if (child3 !== null) {
child3.innerHTML = PlatformJS.Services.resourceLoader.getString("ClinchedDivisionMarker");
}
}
}
if (Microsoft.AppEx.Sports.SportsEnums.League[that._league] === Microsoft.AppEx.Sports.SportsEnums.League.nfl) {
if (parentItem !== null) {
child4 = parentItem.querySelector(".legendEntry4");
if (child4 !== null) {
child4.innerHTML = PlatformJS.Services.resourceLoader.getString(that._league + "ClinchedDivisionAndHomeField");
}
}
}
//// change the table properties for the group header.
table.GroupPosition = 'inline';
table.showGroupHeaders = true;
return table;
},
// invoke the Team  details when clicked on the team.
OnItemClicked: function OnItemClicked(entity) {
var that = this;
if (entity && entity.Localid) {
PlatformJS.Navigation.navigateToChannel("Team", {leagueType: that._league, teamId: entity.Localid });
return true;
}
return false;
}
})
});
})();
