﻿(function () {
'use strict';
WinJS.Namespace.define('SportsJS.Common.ECV', {
TeamRosterCollection: WinJS.Class.derive(SportsJS.ECV.BaseCollection, function (options) {
var that = this;
that.options = options || {};
that._data = [];
that._league = options.league;
SportsJS.Utilities.ECV.addLeagueClass(options.leagueClass);
SportsJS.ECV.BaseCollection.call(that, options);
}, {
/*CommonJS.EntityCollection.Collection Members*/
_league: null,
impressionContext: {
get: function get() {
return SportsJS.Utilities.stringFormat("/{0}", SportsJS.UI.ecvType.TeamRoster);
}
},
Initialize: function Initialize(config) {
if (!config || !config.league || !config.teamid) {
/* we need to show error message here as ECV can not initialize */
return;
}
var that = this;
SportsJS.Telemetry.logECVContentView(SportsJS.UI.ecvType.TeamRoster, that._league);
SportsJS.Shared.Promises.Team.teamBio(config.league, config.teamid).then(function (teamInfo) {
var title = teamInfo && teamInfo.fullteamname ? SportsJS.Utilities.stringFormat(PlatformJS.Services.resourceLoader.getString("TeamRosterTitle"), teamInfo.fullteamname) : null;
var immersiveHeaderTitle = document.querySelector(".immersiveHeaderTitle");
if (immersiveHeaderTitle !== null && title) {
immersiveHeaderTitle.innerText = title;
}
});
//create the provider object
var parameterDictionary = PlatformJS.Collections.createStringDictionary();
parameterDictionary.insert('teamId', config.teamid);
that.Provider = new AppEx.Sports.Services.DataServies.ECVProvider("TeamRoster", config.league, parameterDictionary);
//create the UIConfig object
that.UIConfig = config.UIConfig || new SportsJS.Common.ECV.TeamRosterUIConfig(that._league, { providerObj : that.Provider });
that.DataConfig = config.DataConfig || new CommonJS.EntityCollection.DataConfig();
//initialize and call the base
that._providerConfig = PlatformJS.Collections.createStringDictionary();
that._providerConfig.insert('teamid', config.teamid);
return SportsJS.ECV.BaseCollection.prototype.Initialize.call(that, config);
}
}),
TeamRosterUIConfig: WinJS.Class.derive(SportsJS.ECV.UIConfig, function (league, options) {
var that = this;
that._league = league;
SportsJS.ECV.UIConfig.call(that, options);
WinJS.UI.setOptions(that, options);
}, {
_league: null,
OnItemClicked: function OnItemClicked(entity) {
var that = this;
if (entity && entity.TeamLocalId && entity.LocalId && entity.Name) {
var league = SportsJS.Utilities.stringProperCase(that._league);
PlatformJS.Navigation.navigateToChannel("Player", { leagueType: that._league, teamId: entity.TeamLocalId, playerId: entity.LocalId, playerFullName: entity.Name });
return true;
}
return false;
},
})
});
})();
