﻿(function () {
'use strict';
WinJS.Namespace.define('SportsJS.Common.EditorialCollection', {
EditorialCollectionCluster: WinJS.Class.derive(CommonJS.News.EntityCluster, function (element, options) {
var that = this;
that._traceMsProfileMarkInfo(SportsJS.UI.ProfilerMarkType.Start);
CommonJS.News.EntityCluster.call(that, element, options);
that.onRenderInit = options.onClusterRenderInit;
that.onRenderCompleteCallerCallBack = options.onRenderComplete;
}, {
_fetchPromise: null,
_renderPromise: null,
onRenderCompleteCallerCallBack: null,
render: function render() {
var that = this;
var p = new WinJS.Promise(function (c, e) {
that.onRenderInit(that, c);
});
return p;
},
fetchProxy: function fetchProxy() {
var that = this;
// this is required as fetchProxy is public API, We can't assume caller to cancel this after cleanup
if (that.cleanedUp) {
return WinJS.Promise.wrap(true);
}
that._traceMsProfileMarkInfo(SportsJS.UI.ProfilerMarkType.Start, SportsJS.UI.ProfilerTagType.DataFetch);
that._fetchPromise = new WinJS.Promise(function (complete, error) {
var query = PlatformJS.Collections.createStringDictionary();
for (var key in that.newsQuery) {
query.insert(key, that.newsQuery[key] + "");
}
that.provider.initializeAsync().then(function () {
that.provider.queryAsyncProxy(query);
that._traceMsProfileMarkInfo(SportsJS.UI.ProfilerMarkType.End, SportsJS.UI.ProfilerTagType.DataFetch);
complete(true);
});
});
return that._fetchPromise;
},
renderProxy: function renderProxy() {
var that = this;
// this is required as renderProxy is public API, We can't assume caller to cancel this after cleanup
if (that.cleanedUp) {
return WinJS.Promise.wrap(true);
}
that._traceMsProfileMarkInfo(SportsJS.UI.ProfilerMarkType.Start, SportsJS.UI.ProfilerTagType.Render);
// news cluster is not a good citizen, hence timeout
that._renderPromise = new WinJS.Promise(function (complete, error) {
if (that.cleanedUp === true) {
return;
}
CommonJS.News.EntityCluster.prototype.render.call(that).then(function () {
that._traceMsProfileMarkInfo(SportsJS.UI.ProfilerMarkType.End, SportsJS.UI.ProfilerTagType.Render);
that._traceMsProfileMarkInfo(SportsJS.UI.ProfilerMarkType.End, null);
that._onRenderComplete(true);
complete();
},
function () {
that._traceMsProfileMarkInfo(SportsJS.UI.ProfilerMarkType.End, SportsJS.UI.ProfilerTagType.Render);
that._traceMsProfileMarkInfo(SportsJS.UI.ProfilerMarkType.End, null);
that._onRenderComplete(false);
error();
});
});
return that._renderPromise;
},
cleanUp: function cleanUp() {
var that = this;
that.cleanedUp = true;
if (that._fetchPromise && that._fetchPromise.cancel && typeof that._fetchPromise.cancel === 'function') {
that._fetchPromise.cancel();
}
if (that._renderPromise && that._renderPromise.cancel && typeof that._renderPromise.cancel === 'function') {
that._renderPromise.cancel();
}
},
// fn -> is used when profiling a specific function. if function name is not specified, then
// this means the overall cluster loading is being traced
_traceMsProfileMarkInfo: function _traceMsProfileMarkInfo(markType, fn) {
var info = {
markType: markType ? markType : null,
entityType: SportsJS.UI.ProfilerEntityType.Cluster,
sports: SportsJS.UI.LeagueType.None,
page: SportsJS.UI.PageType.None,
cluster: SportsJS.UI.ClusterType.News,
func: fn ? fn : null
};
SportsJS.Utilities.sportsMsWriteProfilerMark(info);
},
_onRenderComplete: function _onRenderComplete(isRenderSuccess) {
if (this.onRenderCompleteCallerCallBack) {
this.onRenderCompleteCallerCallBack(isRenderSuccess);
}
},
},
{
//// TODO(saarya): Currently, we handle only article type. Append as needed
itemClickHandler: function itemClickHandler(event) {
var that = this;
if (!event || !event.item) {
return;
}
if (event.item.type === SportsJS.UI.EditorialEntity.article) {
var articleId = (event.item.articleid && event.item.articleid.length > 0) ? event.item.articleid : null;
var contentId = (event.item.contentid && event.item.contentid.length > 0) ? event.item.contentid : null;
var editorialCollectionType = typeof event.item.editorialCollectionType !== 'undefined' ? event.item.editorialCollectionType : AppEx.Sports.Services.TypeDefs.EditorialCollectionType.unknown;
var market = AppEx.Sports.Services.Utils.getEditorialCollectionMarket(editorialCollectionType);
SportsJS.Utilities.launchArticle(articleId, contentId, Platform.Instrumentation.InstrumentationEditorialSourceId.cluster, null, event.item.clusterArticles, market);
}
},
}),
});
WinJS.Namespace.define('SportsJS.News', {
NewsCluster: WinJS.Class.derive(SportsJS.Common.EditorialCollection.EditorialCollectionCluster, function (element, options) {
SportsJS.Common.EditorialCollection.EditorialCollectionCluster.call(this, element, options);
}, {
}, {
itemClickHandler: function itemClickHandler(event) {
if (!event || !event.item) {
return;
}
var item = event.item;
// If this is editorial news
if (item.newsSource && item.newsSource.toLowerCase() === SportsJS.UI.NewsSource.editorial) {
var appUri = AppEx.Sports.Services.Utilities.SportsAppExUriManager.instance.createAppUri(item.articleUrl);
//handling article
if (appUri) {
if (appUri.entitytype === SportsJS.UI.EditorialEntity.article) {
var articleid = appUri.pageId && appUri.pageId.length > 0 ? appUri.pageId : null;
var contentid = appUri.contentId && appUri.contentId.length > 0 ? appUri.contentId : null;
item.clusterArticles = SportsJS.Utilities.decorateEditorialInfoWithAdsInfo(item.clusterArticles);
SportsJS.Utilities.launchArticle(articleid, contentid, Platform.Instrumentation.InstrumentationEditorialSourceId.cluster, null, item.clusterArticles, null);
}
else if (appUri.entitytype === SportsJS.UI.EditorialEntity.slideshow) {
var state = {};
state.slideshowId = item.contentId;
PlatformJS.Navigation.navigateToChannel(SportsJS.UI.PageType.Slideshow, state);
return true;
}
}
}
else { // RSS or bing news //TODO:saurabkh use the default template selector
if (item.articleUrl) {
var newsFramePageEnabled = PlatformJS.Services.appConfig.getBool("ShowNewsFramePage");
if (newsFramePageEnabled) {
var sportsType = SportsJS.UI.LeagueType.all;
if (PlatformJS.Navigation && PlatformJS.Navigation.currentIPage && PlatformJS.Navigation.currentIPage._sportsType) {
sportsType = PlatformJS.Navigation.currentIPage._sportsType;
}
msSetImmediate(function () {
PlatformJS.Navigation.navigateToChannel("SportsFrame", { sourceUrl: item.articleUrl, sportsType: sportsType });
});
} else {
var uri = new Windows.Foundation.Uri(item.articleUrl);
Windows.System.Launcher.launchUriAsync(uri).then();
}
}
}
},
})
});
WinJS.Namespace.define('SportsJS.Common.EditorialCollection', {
EditorialCollectionClusterProvider: WinJS.Class.define(function (leagueName, editorialCollectionType, entityType, entityId, maxcolumns, shouldHandleProgress) {
var that = this;
if (!SportsJS.Utilities.isValidLeague(leagueName)
|| !AppEx.Sports.Services.Utils.isValidEditorialCollectionType(editorialCollectionType)
|| !SportsJS.Utilities.isValidSportsEntityType(entityType)) {
throw new Error("Invalid parameters passed to EditorialCollectionClusterProvider");
}
that._leagueName = leagueName;
that._editorialCollectionType = editorialCollectionType;
that._entityType = entityType;
that._entityId = entityId;
var maxItemsPerColumn = 5;
var maxColumnsForMaxItemsFilter = 5; // chthakur - do not generalize, columns less than five will do for us right now
that._maxItemsToProcess = maxcolumns && (maxcolumns < maxColumnsForMaxItemsFilter) ? maxcolumns * maxItemsPerColumn : null;
that._shouldHandleProgress = shouldHandleProgress;
}, {
_endpointId: null,
_queryServiceIdentifier: {
get: function get() {
this._error("required _queryServiceIdentifier is missing");
}
},
_isUniqueEndpoint: {
get: function get() {
this._error("required _isUniqueEndpoint is missing");
}
},
_collectionId: {
get: function get() {
this._error("required _collectionId is missing");
}
},
//// This is used to uniquify multiple clusters powered by same response for entity cluster layout cache
_clusterId: {
get: function get() {
this._error("required _clusterId is missing");
}
},
_errorTag: {
get: function get() {
return "SportsJS.Common.EditorialCollection.EditorialCollectionClusterProvider";
}
},
_leagueName: null,
_editorialCollectionType: null,
_entityType: null,
_entityId: null,
_cacheId: null,
_cacheKey: null,
_maxItemsToProcess: null,
_queryAsyncProxyPromise: null,
initializeAsync: function initializeAsync() {
return WinJS.Promise.wrap(true);
},
queryAsyncProxy: function queryAsyncProxy(query) {
var that = this;
that._queryAsyncProxyPromise = that._constructQueryParamsAsync(query).then(function (queryParams) {
var queryService = new Platform.QueryService(that._queryServiceIdentifier);
that._cacheId = queryService.getCacheID();
that._cacheKey = queryService.getUrl(queryParams);
return that._downloadDataAsyncWrapper(queryService, queryParams);
});
var resetQueryAyncProxyPromise = function () {
that._queryAyncProxyPromise = null;
};
that._queryAsyncProxyPromise.then(resetQueryAyncProxyPromise, resetQueryAyncProxyPromise);
},
queryAsync: function queryAsync(query) {
var that = this;
if (that._queryAyncProxyPromise) {
return that._queryAyncProxyPromise;
}
return that._constructQueryParamsAsync(query).then(function (queryParams) {
var queryService = new Platform.QueryService(that._queryServiceIdentifier);
that._cacheId = queryService.getCacheID();
that._cacheKey = queryService.getUrl(queryParams);
return that._downloadDataAsyncWrapper(queryService, queryParams);
});
},
_addToJSCache: function _addToJSCache(key, response) {
var that = this;
$SpMgr.jsCache.addObject(key, response, { storeToDisk: true });
},
_readFromJSCacheAsync: function _readFromJSCacheAsync(key) {
var that = this;
return $SpMgr.jsCache.getObjectAsync(key);
},
_downloadDataAsyncWrapper: function _downloadDataAsyncWrapper(queryService, queryParams) {
var that = this;
var hasValidData = false;
var jsCacheKey = that._getJsCacheKey(queryService, queryParams);
var promise = new WinJS.Promise(function (complete, error, progress) {
that._readFromJSCacheAsync(jsCacheKey).then(function getObjectAsyncCompleteHandler(cachedResponseObject) {
if (cachedResponseObject && cachedResponseObject.isStaleResponse === false) {
complete(cachedResponseObject);
return;
}
that._downloadDataAsync(queryService, queryParams).then(function _downloadDataAsyncCompleteHandler(res) {
that._updateClusterStalenessParameters(res);
if (res
&& (res.isCachedResponse || res.serverResponseNotModified)
&& hasValidData) {
return promise.cancel();
}
var response = that._processResponse(res);
if (response) {
hasValidData = true;
that._addToJSCache(jsCacheKey, response);
// if we have already received a progress reponse, we should delay
// complete for perf reasons. chthakur -> revisit. Maintaining status quo
return complete(response);
}
else if (!hasValidData) {
return error();
}
else {
//// Do nothing. We have already rendered using progress data.
}
}, function _downloadDataAsyncErrorHandler(e) {
if (PlatformJS.Utilities.isPromiseCanceled(e)) {
return;
}
error(e);
},
function _downloadDataAsyncProgressHandler(progressData) {
if (that._shouldHandleProgress === false) {
return;
}
if (progressData.statusCode === Platform.DataServices.QueryServiceStatusCode.cachedEntryFound && progressData.cachedResponse) {
var response = that._processResponse(progressData.cachedResponse);
if (!response) {
return;
}
hasValidData = true;
that._updateClusterStalenessParameters(progressData.cachedResponse);
that._addToJSCache(jsCacheKey, response);
return progress(response);
}
});
});
});
return promise;
},
_constructQueryParamsAsync: function _constructQueryParamsAsync(query) {
var that = this;
var endpointId = that._endpointId ? that._endpointId : SportsJS.Utilities.getEditorialCollectionId(that._leagueName, that._editorialCollectionType, that._entityType, that._entityId, that._isUniqueEndpoint);
if (!endpointId) {
return WinJS.Promise.wrapError(null);
}
var queryParams = PlatformJS.Collections.createStringDictionary();
queryParams.insert("collectionId", endpointId);
var market = AppEx.Sports.Services.Utils.getEditorialCollectionMarket(that._editorialCollectionType);
queryParams.insert("market", market);
return WinJS.Promise.wrap(queryParams);
},
_downloadDataAsync: function _downloadDataAsync(queryService, queryParams) {
var that = this;
var options = new Platform.DataServices.QueryServiceOptions();
return queryService.downloadDataAsync(queryParams, null, null, options);
},
//// TODO(saarya): Ideally this should be done at the NewsCluster. But the current design doesn't permit it.
//// There is no way to notify the cluster that data is refreshed and staleness parameters should be updated.
//// There is no element associated with the provider on which events can be fired. 
//// Completing the promise again would result in re-render. 
_updateClusterStalenessParameters: function _updateClusterStalenessParameters(newResponse) {
var that = this;
var panoClusters = SportsJS.Utilities.getClusterControlsInsidePagePano();
if (!panoClusters) {
return;
}
//// Get current cluster
var currentCluster = null;
for (var kk = 0; kk < panoClusters.length; kk++) {
var cluster = panoClusters[kk];
if (cluster && cluster.id === that._clusterId) {
currentCluster = cluster;
break;
}
}
if (!currentCluster) {
return;
}
//// This is set only after cluster render. So we wont fire the event unless cluster was rendered with stale data
var wasStaleResponse = currentCluster.isStaleResponse;
//// update staleness parameters
if (newResponse
&& typeof newResponse.isStaleResponse !== 'undefined'
&& typeof newResponse.lastUpdateTime !== 'undefined') {
currentCluster.isStaleResponse = newResponse.isStaleResponse;
currentCluster.lastUpdateTime = newResponse.lastUpdateTime;
}
//// fire data refresh if data became fresh
if (wasStaleResponse && !currentCluster.isStaleResponse) {
var eventObject = document.createEvent("CustomEvent");
eventObject.initCustomEvent("datarefreshed", true, true, null);
currentCluster._domElement.dispatchEvent(eventObject);
}
},
_processResponse: function _processResponse(response) {
var that = this;
var jsonResponse = SportsJS.Utilities.jsonParse(response.dataString);
var processedResponse = that._parseResponse(jsonResponse, response.responseId);
if (!processedResponse) {
return null;
}
processedResponse.isValid = true;
processedResponse.isCachedResponse = response.isCachedResponse;
processedResponse.serverResponseNotModified = response.serverResponseNotModified;
processedResponse.etag = response.responseId;
processedResponse.lastUpdateTime = response.lastUpdateTime;
return processedResponse;
},
_parseResponse: function _parseResponse(jsonResponse, responseId) {
if (!jsonResponse || !jsonResponse.clusters) {
return null;
}
var that = this;
var clusters = jsonResponse.clusters;
for (var i = 0; i < clusters.length; i++) {
var cluster = clusters[i];
if (cluster.entityList && cluster.entityList.collectionId === that._collectionId) {
var entities = cluster.entityList.entities;
var results = [];
for (var j = 0; j < entities.length; j++) {
var entity = entities[j];
var result = SportsJS.Utilities.convertCMSArticle(entity);
if (!result) {
continue;
}
result.editorialCollectionType = that._editorialCollectionType;
results.push(result);
}
SportsJS.Utilities.setClusterArticles(results);
var rval = {
native: true,
newsItems: results,
cacheID: that._cacheId,
dataCacheID: that._cacheKey,
clusterID: that._clusterId,
uniqueResponseID: responseId,
};
return rval;
}
}
},
_getJsCacheKey: function _getJsCacheKey(queryService, queryParams) {
if (!queryService || !queryParams) {
return null;
}
var that = this;
var requestUrl = queryService.getUrl(queryParams);
var jsCacheKey = requestUrl;
if (that._maxItemsToProcess) {
jsCacheKey = jsCacheKey + "&maxItemsToProcess=" + that._maxItemsToProcess;
}
if (that._clusterId) {
jsCacheKey = jsCacheKey + "&clusterId=" + that._clusterId;
}
return jsCacheKey;
},
_error: function _error(msg, parameter) {
var that = this;
var tag = that._errorTag;
if (parameter) {
msg = SportsJS.Utilities.stringFormat(msg, parameter);
}
SportsJS.Utilities.error(tag, msg);
},
}),        
});
WinJS.Namespace.define('SportsJS.Common.EditorialCollection', {
/* use this provider for editorial collection clusters powered via cloud */
DynamicEditorialCollectionClusterProvider: WinJS.Class.derive(SportsJS.Common.EditorialCollection.EditorialCollectionClusterProvider, function (league, configParams) {
var that = this;
if (!configParams || !league || !configParams.entityType || !configParams.entityId || !configParams.maxcolumns || !configParams.shouldHandleProgress || !configParams.collectionId) {
SportsJS.Utilities.interfaceException("SportsJS.Common.EditorialCollection.DynamicEditorialCollectionClusterProvider", "configParamas missing one of mandatory properties");
return;
}
that._collectionId = configParams.collectionId;
if (configParams.endpointId) {
that._isUniqueEndpoint = true;
that._endpointId = configParams.endpointId;
}
SportsJS.Common.EditorialCollection.EditorialCollectionClusterProvider.call(that, league, AppEx.Sports.Services.TypeDefs.EditorialCollectionType.cloud, configParams.entityType, configParams.entityId, configParams.maxcolumns, configParams.shouldHandleProgress);
}, {
/* Assuming NearLive update right now, this will be more sophisticated when we streamline the querying process */
_isUniqueEndpoint: false,
_collectionId: null,
_queryServiceIdentifier: {
get: function get() {
return $SpMgr.cmsPreviewEnabled ? "EditorialCollectionPreviewDataSource" : "EditorialCollectionNearLiveDataSource";
}
},
/* cluster id is needed to uniquily identify the cluster, using a combination of endpointId and collectionId to do this */
_clusterId: {
get: function get() {
return this._endpointId ? this._endpointId + this._collectionId : this._collectionId;
}
},
_errorTag: {
get: function get() {
return "SportsJS.Common.EditorialCollection.DynamicEditorialCollectionClusterProvider";
}
},
}),
});
WinJS.Namespace.define('SportsJS.News', {
NewsProvider: WinJS.Class.derive(SportsJS.Common.EditorialCollection.EditorialCollectionClusterProvider, function (queryServiceIdentifier, queryParams, maxcolumns, shouldHandleProgress) {
this._qsIdentifier = queryServiceIdentifier;
this._queryParams = queryParams;
SportsJS.Common.EditorialCollection.EditorialCollectionClusterProvider.call(this, queryParams.league, AppEx.Sports.Services.TypeDefs.EditorialCollectionType.news, queryParams.type, queryParams.query, maxcolumns, shouldHandleProgress);
}, {
_queryServiceIdentifier: {
get: function get() {
return this._qsIdentifier;
}
},
_clusterId: {
get: function get() {
return SportsJS.UI.ClusterType.News;
}
},
_errorTag: {
get: function get() {
return "SportsJS.News.NewsProvider";
}
},
_queryParams: null,
_addToJSCache: function _addToJSCache(key, response) {
var that = this;
if (that._queryParams && that._queryParams.type === SportsJS.UI.EntityType.Today) {
$SpMgr.jsCache.addObject(key, response, { storeToDisk: true, storageType: SportsJS.Consts.storageType.IE });
} else {
$SpMgr.jsCache.addObject(key, response, { storeToDisk: true });
}
},
_readFromJSCacheAsync: function _readFromJSCacheAsync(key) {
var that = this;
if (that._queryParams && that._queryParams.type === SportsJS.UI.EntityType.Today) {
return $SpMgr.jsCache.getObjectAsync(key, { storageType: SportsJS.Consts.storageType.IE });
}
return $SpMgr.jsCache.getObjectAsync(key);
},
_constructQueryParamsAsync: function _constructQueryParamsAsync(query) {
var that = this;
var queryParams = PlatformJS.Collections.createStringDictionary();
queryParams.insert("appid", this._applicationIdentifier);
var querystr = query["query"]; //fallback query                
var pageid = null;
var pagekey = null;
var editorialNewsEnabled = PlatformJS.Services.appConfig.getBool("EditorialNewsEnabled");
var querypromise = null;
switch (that._queryParams.type) {
case SportsJS.UI.EntityType.Today:
querypromise = WinJS.Promise.wrap({ query: that._queryParams.query });
pagekey = that._queryParams.league;
if (pagekey && editorialNewsEnabled) {
pageid = SportsJS.Utilities.getLeagueCmsMappings(pagekey);
}
break;
case SportsJS.UI.EntityType.League:
queryParams.insert("leagueName", that._queryParams.league);
querypromise = WinJS.Promise.wrap({ query: that._queryParams.query });
pagekey = that._queryParams.league;
if (pagekey && editorialNewsEnabled) {
pageid = SportsJS.Utilities.getLeagueCmsMappings(pagekey);
}
break;
case SportsJS.UI.EntityType.Team:
queryParams.insert("leagueName", that._queryParams.leagueName);
queryParams.insert("teamId", that._queryParams.teamId);
querypromise = WinJS.Promise.wrap({ query: that._queryParams.query });
pagekey = that._queryParams.league + "_" + that._queryParams.teamId;
if (pagekey && editorialNewsEnabled) {
pageid = "";
}
break;
case SportsJS.UI.EntityType.Player:
querypromise = WinJS.Promise.wrap({ query: that._queryParams.query });
break;
}
var serviceName = SportsJS.Utilities.getNewsServiceName();
if (WinJS.Promise.is(querypromise)) {
return querypromise.then(function (res) {
if (res && res.query) {
querystr = res.query;
}
queryParams.insert("market", query["market"]);
queryParams.insert("count", query["count"]);
queryParams.insert("middleTierServer", SportsJS.Utilities.getMiddleTierServer());
queryParams.insert("serviceName", serviceName);
if (pageid) {
queryParams.insert("pageid", "&pageid=" + pageid);
}
else {
queryParams.insert("pageid", "");
}
if (that._queryServiceIdentifier.toLowerCase() !== "rssnews") {
queryParams.insert("query", querystr);
queryParams.insert("category", query["category"]);
queryParams.insert("sortByDate", query["sortByDate"]);
}
return WinJS.Promise.wrap(queryParams);
});
}
else {
// return the same query. THis will happen only in failure scenario
return WinJS.Promise.wrap(query);
}
},
_parseResponse: function _parseResponse(response, responseId) {
var editorialVideoAndSlideShowInNewsEnabled = PlatformJS.Services.appConfig.getBool("IsEditorialVideoAndSlideShowInNewsEnabled");
var newsType = SportsJS.UI.NewsType.rss;
//get the news version and news version config                
var newsVersion = SportsJS.Utilities.getCurrentNewsVersion();
var newsResults = [];
if (newsVersion === "2.0") {
if (response !== null && response.Results !== null && response.Results.length > 0) {
if (response.Results[0] !== null) {
response = response.Results[0].Response;
}
}
else {
response = null;
}
}
if (response && response.NewsItems && response.NewsItems.length > 0) {
var newsItems = response.NewsItems;
//// editorialArticleInfos has one property articleInfos which is an array of editorial articleIds to power ArticleReader back/forward buttons.
var editorialArticleInfos = {
articleInfos: []
};
for (var i = 0; i < newsItems.length; i++) {
var publishTime = null;
var updateTime = null;
var description = null;
var title = null;
var sourceImageUrl = "";
var isLeadArticle = false;
if (newsItems[i].ItemSource && newsItems[i].ItemSource.toLowerCase() === SportsJS.UI.NewsSource.rss) {
publishTime = CommonJS.Utils.convertRSSTimeToFriendlyTime(newsItems[i].PublishTime);
var parser;
try {
parser = new DOMParser();
var descDom = parser.parseFromString(newsItems[i].Snippet, "text/html");
description = SportsJS.Utilities.ParseTextNodes(descDom);
}
catch (e) {
description = newsItems[i].Snippet;
}
//do more cleanup in any case
description = SportsJS.Utilities.ExtractHtmlText(description);
try {
parser = new DOMParser();
var titleDom = parser.parseFromString(newsItems[i].Title, "text/html");
title = SportsJS.Utilities.ParseTextNodes(titleDom);
}
catch (e) {
title = SportsJS.Utilities.ExtractHtmlText(newsItems[i].Title);
}
}
else if (newsItems[i].ItemSource && newsItems[i].ItemSource.toLowerCase() === SportsJS.UI.NewsSource.bing) {
publishTime = CommonJS.Utils.convertBDITimeToFriendlyTime(newsItems[i].PublishTimeValue);
description = newsItems[i].Snippet;
title = newsItems[i].Title;
sourceImageUrl = newsItems[i].SourceImageUrl ? newsItems[i].SourceImageUrl : "";
}
else { //editorial
var appUri = AppEx.Sports.Services.Utilities.SportsAppExUriManager.instance.createAppUri(newsItems[i].ArticleUrl);
if (appUri) {
newsItems[i].entitytype = appUri.entitytype;
if (appUri.entitytype === SportsJS.UI.EditorialEntity.article) {
var articleId = appUri.pageId && appUri.pageId.length > 0 ? appUri.pageId : null;
var contentId = appUri.contentId && appUri.contentId.length > 0 ? appUri.contentId : null;                                    
if (contentId) {
articleId = articleId + '/' + contentId;
}
editorialArticleInfos.articleInfos.push({
articleId: articleId,
});
}
else if (editorialVideoAndSlideShowInNewsEnabled) {
newsItems[i].entitytype = appUri.entitytype;
if (appUri.entitytype === SportsJS.UI.EditorialEntity.slideshow) {
newsItems[i].contentId = appUri.pageId;
}
else if (appUri.entitytype === SportsJS.UI.EditorialEntity.video) {
newsItems[i].videoOptions = {
videoSource: appUri.contentId,
source: newsItems[i].Source,
title: toStaticHTML(newsItems[i].Title),
sourceImageUrl: newsItems[i].SourceImageUrl,
thumbnail: newsItems[i].Thumbnail && newsItems[i].Thumbnail.Url ? newsItems[i].Thumbnail.Url : "",
};
}
}
else {
continue;
}
}
if (newsItems[i].PublishTimeValue && (newsItems[i].PublishTimeValue !== 0)) {
publishTime = CommonJS.Utils.convertBDITimeToFriendlyTime(newsItems[i].PublishTimeValue);
}
else {
publishTime = "";
}
if (newsItems[i].UpdateTimeValue && (newsItems[i].UpdateTimeValue !== 0)) {
updateTime = CommonJS.Utils.convertBDITimeToFriendlyTime(newsItems[i].UpdateTimeValue);
}
else {
updateTime = "";
}
description = toStaticHTML(newsItems[i].Snippet);
title = toStaticHTML(newsItems[i].Title);
sourceImageUrl = newsItems[i].SourceImageUrl ? newsItems[i].SourceImageUrl : "";
}
//TODO:saurabkh enable all fields, handle separately for editorial and rest
var convertednewsItem = {
articleUrl: newsItems[i].ArticleUrl,
entityType: newsItems[i].entitytype,
title: title,
category: "",
snippet: description,
source: newsItems[i].Source,
sourceImageUrl: sourceImageUrl,
byline: "",
publishTime: publishTime,
updatedTime: updateTime,
newsSource: newsItems[i].ItemSource,
template: newsItems[i].Template,
templateClass: newsItems[i].TemplateClass,
isLead: isLeadArticle,
imageAttribution: newsItems[i].Thumbnail && newsItems[i].Thumbnail.Attribution ? newsItems[i].Thumbnail.Attribution : "",
};
if (newsItems[i].Thumbnail && newsItems[i].Thumbnail.Url) {
convertednewsItem.thumbnail = {
url: newsItems[i].Thumbnail.Url,
height: newsItems[i].Thumbnail.Height ? newsItems[i].Thumbnail.Height : 100,
width: newsItems[i].Thumbnail.Width ? newsItems[i].Thumbnail.Width : 100,
altText: newsItems[i].Thumbnail.AltText ? newsItems[i].Thumbnail.AltText : title,
attribution: newsItems[i].Thumbnail.Attribution ? newsItems[i].Thumbnail.Attribution : ""
};
}
convertednewsItem.index = newsResults.length;
if (newsItems[i].entitytype === SportsJS.UI.EditorialEntity.slideshow) {
convertednewsItem.contentId = newsItems[i].contentId;
}
else if (newsItems[i].entitytype === SportsJS.UI.EditorialEntity.video) {
if (convertednewsItem.thumbnail) {
convertednewsItem.thumbnail.videoOptions = newsItems[i].videoOptions;
}
}
newsResults.push(convertednewsItem);
}
if (editorialArticleInfos.articleInfos.length > 0) {
var index = 0;
for (var j = 0; j < newsResults.length; j++) {
if (newsResults[j].newsSource && newsResults[j].newsSource.toLowerCase() === SportsJS.UI.NewsSource.editorial && newsResults[j].entityType === SportsJS.UI.EditorialEntity.article) {
newsResults[j].clusterArticles = editorialArticleInfos;
newsResults[j].articleIndex = index;
index++;
}
}
}
}
// Lot of issues with sending more than required items.
// This directly impacts the UI performance with more number of elements in the DOM.
// Compare 10 required with 30 sent
if (newsItems && this._maxItemsToProcess && this._maxItemsToProcess < newsItems.length) {
newsResults = newsResults.slice(0, this._maxItemsToProcess);
}
var uniqueId = this._maxItemsToProcess ? this._clusterId + "&maxItemsToProcess=" + this._maxItemsToProcess : this._clusterId;
return {
native: true,
newsItems: newsResults,
cacheID: this._cacheId,
dataCacheID: this._cacheKey,
clusterID: uniqueId,
uniqueResponseID: responseId,
};
},
},
{
})
});
WinJS.Namespace.define('SportsJS.Magazine', {
MagazineClusterProvider: WinJS.Class.derive(SportsJS.Common.EditorialCollection.EditorialCollectionClusterProvider, function (leagueName, entityType, entityId, maxcolumns, shouldHandleProgress) {
var that = this;
SportsJS.Common.EditorialCollection.EditorialCollectionClusterProvider.call(that, leagueName, AppEx.Sports.Services.TypeDefs.EditorialCollectionType.magazine, entityType, entityId, maxcolumns, shouldHandleProgress);
}, {
_queryServiceIdentifier: {
get: function get() {
return $SpMgr.cmsPreviewEnabled ? "MagazinePreviewDataSource" : "MagazineDataSource";
}
},
_isUniqueEndpoint: {
get: function get() {
return false;
}
},
_collectionId: {
get: function get() {
return "featuredArticles";
}
},
_clusterId: {
get: function get() {
return SportsJS.UI.ClusterType.Magazine;
}
},
_errorTag: {
get: function get() {
return "SportsJS.Magazine.MagazineClusterProvider";
}
},
}),
});
WinJS.Namespace.define('SportsJS.Video', {
VideoClusterProvider: WinJS.Class.derive(SportsJS.Common.EditorialCollection.EditorialCollectionClusterProvider, function (leagueName, entityType, entityId, maxcolumns, shouldHandleProgress) {
var that = this;
SportsJS.Common.EditorialCollection.EditorialCollectionClusterProvider.call(that, leagueName, AppEx.Sports.Services.TypeDefs.EditorialCollectionType.videos, entityType, entityId, maxcolumns, shouldHandleProgress);
}, {
_queryServiceIdentifier: {
get: function get() {
return $SpMgr.cmsPreviewEnabled ? "VideoClusterPreviewDataSource" : "VideoClusterDataSource";
}
},
_isUniqueEndpoint: {
get: function get() {
return false;
}
},
_collectionId: {
get: function get() {
return "videos";
}
},
_clusterId: {
get: function get() {
return SportsJS.UI.ClusterType.Video;
}
},
_errorTag: {
get: function get() {
return "SportsJS.Video.VideoClusterProvider";
}
},
}),
});
WinJS.Namespace.define('SportsJS.MatchPreviewRecap', {
MatchPreviewRecapClusterProvider: WinJS.Class.derive(SportsJS.Common.EditorialCollection.EditorialCollectionClusterProvider, function (leagueName, configParams) {
var that = this;
var type = AppEx.Sports.Services.TypeDefs.EditorialCollectionType;
if (!(configParams.editorialCollectionType === type.preview || configParams.editorialCollectionType === type.recap)) {
this._error("Invalid editorialCollectionType");
}
if (!configParams.collectionId) {
SportsJS.Utilities.interfaceException("SportsJS.Common.EditorialCollection.MatchPreviewRecapClusterProvider", "configParamas missing one of mandatory properties");
return;
}
that._collectionId = configParams.collectionId;
SportsJS.Common.EditorialCollection.EditorialCollectionClusterProvider.call(that, leagueName, configParams.editorialCollectionType, configParams.entityType, configParams.entityId, configParams.maxcolumns, configParams.shouldHandleProgress);
}, {
_collectionId: null,
_queryServiceIdentifier: {
get: function get() {
return "PreviewRecapDataSource";
}
},
_isUniqueEndpoint: {
get: function get() {
return true;
}
},            
_clusterId: {
get: function get() {
//// Appending entityId is necessary to make sure layout caches are separate for different game preview/recap powered through same endpoint.
return SportsJS.UI.ClusterType.MatchPreviewRecap + this._entityId;
}
},
_errorTag: {
get: function get() {
return "SportsJS.MatchPreviewRecap.MatchPreviewRecapClusterProvider";
}
},
_getNoDataEntity: function _getNoDataEntity() {
return {
editorial: true,
title: PlatformJS.Services.resourceLoader.getString("MatchupPreviewRecapComingSoon"),
templateClass: "NoData",
snippet: "",
};
},
_parseResponse: function _parseResponse(jsonResponse, responseId) {
var that = this;
//// No JsonResponse is an error scenario
if (!jsonResponse) {
return null;
}
var parsedResponse = {
native: true,
newsItems: [],
cacheID: that._cacheId,
dataCacheID: that._cacheKey,
clusterID: that._clusterId,
uniqueResponseID: responseId,
};
/// Otherwise, everything is NoData scenario
if (!jsonResponse.clusters || jsonResponse.clusters.length === 0) {
parsedResponse.newsItems.push(this._getNoDataEntity());
}
else {
var clusters = jsonResponse.clusters;
var newsItems = [];
var foundEntity = false;
for (var i = 0; i < clusters.length; i++) {
var cluster = clusters[i];
if (cluster.entityList && cluster.entityList.collectionId === that._collectionId) {
var entities = cluster.entityList.entities;
for (var j = 0; j < entities.length; j += 2) {
var dummyEntity = entities[j];
var actualEntity = entities[j + 1];
if (!dummyEntity || !actualEntity || !dummyEntity.content || !dummyEntity.content.byline) {
continue;
}
var res = SportsJS.Utilities.convertCMSArticle(actualEntity);
if (!res) {
continue;
}
//// Need to hardcode templateClass to A
res.templateClass = "A";
res.editorialCollectionType = that._editorialCollectionType;
//// set game time, this is needed to set up circling of articles in article reader
var gameTime;
if (that._leagueName === $SpMgr.getLeagueString(Microsoft.AppEx.Sports.SportsEnums.League.nfl)) {
res.gameTime = parseInt(res.template);
}
else {
var content = dummyEntity.content;
var bdiTime = content.publicationDate && content.publicationDate.published && content.publicationDate.published.utctime ? content.publicationDate.published.utctime : null;
res.gameTime = SportsJS.DateTimeHelpers.convertBdiTimeToETDate(bdiTime);
}
newsItems.push(res);
var currentEntityId = dummyEntity.content.byline;
if (currentEntityId && currentEntityId === this._entityId) {
foundEntity = true;
parsedResponse.newsItems.push(res);
}
}
}
}
if (!foundEntity) {
parsedResponse.newsItems.push(this._getNoDataEntity());
}
//// Set up the circling on articles in article reader, to circle through all games on same date
else {
var newsItem = parsedResponse.newsItems[0];
var sameDateArticles = [];
var output;
for (var ii = 0; ii < newsItems.length; ii++) {
output = SportsJS.Utilities.PreviewRecapTryIsGameTimeEqual(that._leagueName, newsItems[ii].gameTime, newsItem.gameTime);
if (output.success && output.value === true) {
sameDateArticles.push(newsItems[ii]);
}
}
//// For a date, clusters are sorted by most recent first
sameDateArticles.sort(function (article1, article2) {
return article2.publishUTCTime - article1.publishUTCTime;
});
SportsJS.Utilities.setClusterArticles(sameDateArticles);
}
}
return parsedResponse;
},
}),
});
})();
