﻿(function () {
'use strict';
WinJS.Namespace.define("SportsJS", {
FramePage: WinJS.Class.derive(SportsJS.Page, function (state) {
if (!state || !state.sourceUrl) {
throw new Error("SportsJS.FramePage: Missing state infromation");
}
var that = this;
that._state = state;
that._sourceUrl = state.sourceUrl;
that._leagueType = (state.leagueType && state.leagueType !== "") ? state.leagueType : SportsJS.UI.LeagueType.all;
that._leagueName = that._leagueType;
that._pageType = SportsJS.UI.PageType.Frame;
that.isImmersive = true;
that._basePageConstructor(state);           
that._initializeFrameElement();
that._initializeBottomEdgy();
},
{
_frameElement: null,
_initializeFrameElement: function _initializeFrameElement() {
var that = this;
if (!that._frameElement) {
that._frameElement = document.getElementById("SportsFrameElement");
if (that._frameElement) {
that._frameElement.contentEditable = true;
that._frameElement.sandbox = "allow-scripts allow-same-origin";
CommonJS.Progress.showProgress(CommonJS.Progress.headerProgressType);
that._frameElement.addEventListener("load", that._onLoadHandler);
that._frameElement.src = that._sourceUrl;
// This call will ensure any one time work is run such as the splash screen dismissal
// only if this control was loaded as the initial startup page.
PlatformJS.mainProcessManager.afterFirstView();
}
}
},
_browserButtonControl: null,
_initializeBottomEdgy: function _initializeBottomEdgy() {
var that = this;
var buttonData = {
icon: SportsJS.UI.IconType.browser,
title: PlatformJS.Services.resourceLoader.getString("BrowserButtonLabel"),
onclick: that._viewInBrowserButtonHandler.bind(that),
placement: "right",
className: "viewBrowserBtn"
};
var button = new SportsJS.Controls.BottomEdgyButton(null, buttonData);
that._browserButtonControl = that.bottomEdgy.addButton(button);
},
_viewInBrowserButtonHandler: function _viewInBrowserButtonHandler() {
var that = this;
if (that._sourceUrl) {
var uri = new Windows.Foundation.Uri(that._sourceUrl);
Windows.System.Launcher.launchUriAsync(uri);
}
},
_pageInitAsync: function _pageInitAsync() {
// Dont do anything...
},
getClusterConfig: function getClusterConfig() {
// Dont do anything...
},
_refreshPage: function _refreshPage() {
var that = this;
CommonJS.Error.removeError();
CommonJS.Progress.hideProgress(CommonJS.Progress.headerProgressType);
if (that._frameElement) {
CommonJS.Progress.showProgress(CommonJS.Progress.headerProgressType);
that._frameElement.src = that._sourceUrl;
}
},
pageUri: {
get: function get() {
return this._sourceUrl;
}
},
_isDeeplinkSharable: true,
getPageData: function getPageData() {
var that = this;
var pageData = {
title: "",
subTitle: "",
sourceUrl: that._sourceUrl,
};
var promise = new WinJS.Promise(function (complete, error) {
that._timeoutWrapper(function () { complete(pageData); }, that.pageDataTimeout);
});
return promise;
},
_onLoadHandler: function _onLoadHandler() {
CommonJS.Progress.hideProgress(CommonJS.Progress.headerProgressType);
},
onNavigateAway: function onNavigateAway(event) {
var that = this;
if (that._frameElement) {
that._frameElement.removeEventListener("load", that._onLoadHandler);
}
var framePageContainer = document.querySelector(".SportsFramePageContainer");
if (framePageContainer) {
framePageContainer.innerHTML = "";
}
SportsJS.Page.prototype.onNavigateAway.call(this, event);
}
})
});
})();
