﻿(function () {
"use strict";
var Control = WinJS.Class.define(null, {
raiseEvent: function raiseEvent(type, details) {
/// <summary locid="170">
/// Raises an event of the specified type and with additional properties.
/// </summary>
/// <param name="type" locid="171">
/// The type (name) of the event.
/// </param>
/// <param name="details" locid="172">
/// The set of additional properties to be attached to the event object when the event is raised.
/// </param>
/// <returns type="Boolean" locid="173">
/// Boolean indicating whether preventDefault was called on the event.
/// </returns>
this.dispatchEvent(type, details);
}
});
WinJS.Class.mix(Control, WinJS.UI.DOMEventMixin);
WinJS.Namespace.define('SportsJS.Common.Hero', {
TeamSummaryModuleControl: WinJS.Class.derive(Control, function (element, options) {
var that = this;
that.league = options.params.league ? options.params.league : "";
that.teamId = options.params.teamId ? options.params.teamId : "";
that.heroSummaryType = options.params.heroSummaryType ? options.params.heroSummaryType : "";
if (that.league === "" || that.teamId === "") {
this._trace(SportsJS.Msg.ModuleParamsNotFound);
}
that.element = element;
element.winControl = that;
var moduleInfo = {
fragmentPath: '/leagues/common/Hero/TeamSummaryModuleControl/TeamSummaryModuleControl.html',
templateId: (that.heroSummaryType === "combinedTeamSeasonSummary") ? 'teamScheduleSummaryModuleTemplate' : 'teamSummaryModuleTemplate',
};
var noDataIndicator = PlatformJS.Services.resourceLoader.getString("NoDataIndicator");
if (that.heroSummaryType === "combinedTeamSeasonSummary") {
that.placeHolderDataSource = WinJS.Binding.as({
isVisible: "none",
hasGameOne: false,
gameOneStaticLabel: noDataIndicator,
gameOneLeague: noDataIndicator,
gameOneOpponentTeamName: noDataIndicator,
gameOneAtOrVs: noDataIndicator,
gameOneOutcome: noDataIndicator,
hasGameTwo: false,
gameTwoStaticLabel: noDataIndicator,
gameTwoLeague: noDataIndicator,
gameTwoOpponentTeamName: noDataIndicator,
gameTwoAtOrVs: noDataIndicator,
gameTwoDate: noDataIndicator,
gameTwoTime: noDataIndicator,
hasBothGames: false,
});
}
else {
that.placeHolderDataSource = WinJS.Binding.as({
isVisible: "none",
stat1Name: noDataIndicator,
stat1Value: noDataIndicator,
stat2Name: noDataIndicator,
stat2Value: noDataIndicator,
stat3Name: noDataIndicator,
stat3Value: noDataIndicator,
stat4Name: noDataIndicator,
stat4Value: noDataIndicator,
});
}
CommonJS.loadModule(moduleInfo, that.placeHolderDataSource, null, null, null).then(function (container) {
if (container) {
WinJS.UI.processAll(container);
that.element.appendChild(container);
}                
});
that.TeamSummaryDataProvider(that.league, that.teamId, that.heroSummaryType).then(function (res) {
if (res === false) {
this._trace(SportsJS.Msg.InvalidDataProviderResponse);
}
});
},
{
league: "",
teamId: "",
placeHolderDataSource: null,
TeamSummaryDataProvider: function TeamSummaryDataProvider(league, teamId, heroSummaryType) {
var that = this;
var promise = new WinJS.Promise(function (complete) {
if (!teamId || !league) {
return SportsJS.Utilities.fallbackResponsePromise();
}
var controller = AppEx.Sports.Services.SportsController();
var uiQuery;
if (that.heroSummaryType === "combinedTeamSeasonSummary") {
uiQuery = new AppEx.Sports.Services.TypeDefs.Request.TeamScheduleSeasonSummaryQuery(league, teamId);
controller.request(uiQuery).then(function (res) {
if (res !== null) {
var response = SportsJS.Utilities.nativeObjectToJsObject(res);
var teamSeasonSummary = response.teamScheduleSeasonSummaryData;
if (teamSeasonSummary) {
that.placeHolderDataSource.hasGameOne = teamSeasonSummary.hasGameOne;
if (teamSeasonSummary.hasGameOne) {
that.placeHolderDataSource.gameOneStaticLabel = teamSeasonSummary.gameOneStaticLabel;
that.placeHolderDataSource.gameOneLeague = teamSeasonSummary.gameOneLeague;
that.placeHolderDataSource.gameOneOpponentTeamName = teamSeasonSummary.gameOneOpponentTeamName;
that.placeHolderDataSource.gameOneAtOrVs = teamSeasonSummary.gameOneAtOrVs;
that.placeHolderDataSource.gameOneOutcome = teamSeasonSummary.gameOneOutcome;
}
that.placeHolderDataSource.hasGameTwo = teamSeasonSummary.hasGameTwo;
if (teamSeasonSummary.hasGameTwo) {
that.placeHolderDataSource.gameTwoStaticLabel = teamSeasonSummary.gameTwoStaticLabel;
that.placeHolderDataSource.gameTwoLeague = teamSeasonSummary.gameTwoLeague;
that.placeHolderDataSource.gameTwoOpponentTeamName = teamSeasonSummary.gameTwoOpponentTeamName;
that.placeHolderDataSource.gameTwoAtOrVs = teamSeasonSummary.gameTwoAtOrVs;
that.placeHolderDataSource.gameTwoDate = teamSeasonSummary.gameTwoDate;
that.placeHolderDataSource.gameTwoTime = teamSeasonSummary.gameTwoTime;
}
that.placeHolderDataSource.hasBothGames = that.placeHolderDataSource.hasGameOne && that.placeHolderDataSource.hasGameTwo;
//// make the module visible now
that.placeHolderDataSource.isVisible = "";
}
complete(true);
}
else {
complete(false);
}
});
}
else {
uiQuery = new AppEx.Sports.Services.TypeDefs.Request.TeamSeasonSummaryQuery(league, teamId);
controller.request(uiQuery).then(function (res) {
if (res !== null) {
var response = SportsJS.Utilities.nativeObjectToJsObject(res);
var teamSeasonSummary = response.teamSeasonSummaryData;
if (teamSeasonSummary && teamSeasonSummary.length > 0) {
that.placeHolderDataSource.stat1Name = teamSeasonSummary[0].stat1.name;
that.placeHolderDataSource.stat1Value = teamSeasonSummary[0].stat1.value;
that.placeHolderDataSource.stat2Name = teamSeasonSummary[0].stat2.name;
that.placeHolderDataSource.stat2Value = teamSeasonSummary[0].stat2.value;
that.placeHolderDataSource.stat3Name = teamSeasonSummary[0].stat3.name;
that.placeHolderDataSource.stat3Value = teamSeasonSummary[0].stat3.value;
that.placeHolderDataSource.stat4Name = teamSeasonSummary[0].stat4.name;
that.placeHolderDataSource.stat4Value = teamSeasonSummary[0].stat4.value;
//// make the module visible now
that.placeHolderDataSource.isVisible = "";
}
complete(true);
}
else {
complete(false);
}
});
}
});
return promise;
},
},
{
showGameGrid: WinJS.Binding.converter(function (hasGame) {
if (!hasGame) {
return "none";
} else {
return "-ms-grid";
}
}),
showVerticalRule: WinJS.Binding.converter(function (hasBothGames) {
if (!hasBothGames) {
return "none";
} else {
return "";
}
})
}
)
});
})();