﻿(function () {
'use strict';
WinJS.Namespace.define("SportsJS.Common", {
NoSearchResults: WinJS.Class.define(
/// <summary>
/// Constructor for your IPage class
/// </summary>
/// <param name="state">
/// The state object passed to WinJS.Navigation.navigate or the state object
/// preserved when the page has been navigated away from
/// </param>
function (state) {
},
{
// IPAGE interface
/// <summary>
/// This function is invoked by the UX Framework when the page is being navigated away and when the app is suspending.
/// Return any data that you need to resurrect your UX when the page is recreated
/// Keep this state object as small as possible
/// </summary>
/// <returns>
/// This function must return a JSON object that can be serializable. Do not pass a Managed object
/// </returns>
getPageState: function getPageState() {
return null;
},
/// <summary>
/// This function is invoked by the UX Framework when the page is being created and when
/// it is necessary to bind data to the UX.
/// </summary>
/// <returns>
/// Returns a promise that contains data to bind the UX to
/// </returns>
getPageData: function getPageData() {
var that = this;
var resourceLoader = PlatformJS.Services.resourceLoader;
return WinJS.Promise.wrap({
noSearchResultsTitle: resourceLoader.getString("SearchResultPageTitle"),
noSearchResultsSubTitle: resourceLoader.getString("SearchResultClusterTitle")
});
},
getPageImpressionContext: function getPageImpressionContext() {
return SportsJS.Telemetry.PagesExtra.searchNoResults;
}
})
});
})();
