﻿// TODO(saarya) 
// 1. What about pageUri/NavController?
(function () {
'use strict';
WinJS.Namespace.define("SportsJS.Common.PreviewRecap", {
PreviewRecapPage: WinJS.Class.derive(SportsJS.Common.EditorialCollection.EditorialCollectionPage,
/// <summary>
/// Constructor for your IPage class
/// </summary>
/// <param name="state">
/// The state object passed to WinJS.Navigation.navigate or the state object
/// preserved when the page has been navigated away from
/// </param>
function (state) {
var that = this;
SportsJS.Common.EditorialCollection.EditorialCollectionPage.call(that, state);
this._setUpTelemetryLogging(this._editorialCollectionType, this._leagueType);
},
{
_providerType: "SportsJS.Common.PreviewRecap.PreviewRecapProvider",
_errorTag: "SportsJS.Common.PreviewRecap.PreviewRecapPage",
_setUpTelemetryLogging: function _setUpTelemetryLogging(collectionType, leagueType) {
// setup item realized
var element = document.querySelector(".mainPanorama");
if (!element || !element.winControl || !element.winControl._panel) {
return;
}
var panel = element.winControl._panel;
// chthakur - careful with closure here. We should not access context inside the attached handler. Or else leak, this frees us from removing the handler on navigate away
// removing would be good, but minimizing the code right now. binding with null to avoid any leak scenarios
panel.addEventListener("itemrealizedcomplete", this._onClusterRealized.bind(null, leagueType, collectionType));
return;
},
_onClusterRealized: function _onClusterRealized(leagueType, collectionType, e) {
// chthakur - log on first cluster load only. This will be logged on refresh also to be consistent with other sports pages
// if there are no clusters. We will not be logging. This is the best compromise we have right now
if (!e || !e.detail || e.detail.index !== 0) {
return;
}
if (AppEx.Sports.Services.TypeDefs.EditorialCollectionType.recap === collectionType) {
SportsJS.Telemetry.logPreviewRecap(leagueType, SportsJS.UI.PageType.Recap);
}
else if (AppEx.Sports.Services.TypeDefs.EditorialCollectionType.preview === collectionType) {
SportsJS.Telemetry.logPreviewRecap(leagueType, SportsJS.UI.PageType.Preview);
}
}
})
});
})();
