﻿(function () {
'use strict';
WinJS.Namespace.define("SportsJS.Common.Clusters", {
SnapScheduleClusterControl: WinJS.Class.derive(SportsJS.UI.SportsCluster, function (element, options) {
SportsJS.UI.SportsCluster.call(this, element, options);
this._currentFilter = this.league;
this._addFilterBar();
}, {
_currentFilter : null,
getModuleConfigs: function getModuleConfigs() {
var configs = [];
var that = this;
var snapScheduleModuleConfig = SportsJS.Modules.Configs.Common.SnapScheduleModule(that._currentFilter, that.currentDate, that.isInteractive);
configs.push(snapScheduleModuleConfig);
return WinJS.Promise.wrap(configs);
},
_addFilterBar: function _addFilterBar() {
var that = this;
var inSeasonSports = SportsJS.SnapViewHome.snapModeRequiredLeagues();
var filterBar = document.createElement('select');
WinJS.Utilities.addClass(filterBar, "snapScheduleListBox");
filterBar.setAttribute("aria-label", "select league");
for (var j = 0, maxLength = inSeasonSports.length; j < maxLength; j++) {
// TODO: arengak: Need to enable F1 and Golf later
var sport = AppEx.Sports.Services.Utils.getSportsFromLeague(inSeasonSports[j]);
if (sport === $SpMgr.enumStrings.SportsType[Microsoft.AppEx.Sports.SportsEnums.Sport.racing]
|| sport === $SpMgr.enumStrings.SportsType[Microsoft.AppEx.Sports.SportsEnums.Sport.golf]
|| sport === $SpMgr.enumStrings.SportsType[Microsoft.AppEx.Sports.SportsEnums.Sport.tennis]
|| sport === $SpMgr.enumStrings.SportsType[Microsoft.AppEx.Sports.SportsEnums.Sport.cricket]) {
continue;
}
var displayText = SportsJS.Utilities.getLocLeagueDisplayText(inSeasonSports[j]);
var optionElem = document.createElement("option");
optionElem.value = inSeasonSports[j];
optionElem.innerText = displayText;
optionElem.selected = inSeasonSports[j] === that._currentFilter ? true : false;
filterBar.appendChild(optionElem);
}
// Add Favorite teams filter
var myTeamOption = document.createElement("option");
myTeamOption.value = SportsJS.UI.LeagueType.today;
myTeamOption.innerText = CommonJS.resourceLoader.getString("MyTeams");
myTeamOption.selected = that._currentFilter === SportsJS.UI.LeagueType.today ? true : false;
filterBar.appendChild(myTeamOption);
filterBar.onchange = that._onFilterSelectionChanged.bind(that);
that.element.appendChild(filterBar);
that._filterBar = filterBar;
},
_onFilterSelectionChanged: function _onFilterSelectionChanged(filter) {
var that = this;
if (!that._filterBar || !that._filterBar.value) {
return;
}
// new filter value has been selected, destroy the old submodules
for (var ii = 0; ii < that.submodules.length; ii++) {
that.submodules[ii].destroy();
}
//cleanUp error module if there happens to be one
//TODO(chthakur): Need more sophisticated method to handle error/retry scenario here.
that.cleanUpErrorTemplate();
that.submodules = [];
that._hasSubmodulesLoaded = false;
that._currentFilter = that._filterBar.value;
SportsJS.mainProcessManager.snappedSport = that._currentFilter;
SportsJS.Common.Clusters.SnapScheduleClusterControl.setBackgroundAndProminentText(that._currentFilter);
// re-render the cluster and its submodules
that.render();
}
},
{
setBackgroundAndProminentText: function setBackgroundAndProminentText(leagueType) {
var snapViewContainer = document.querySelector(".snappedHomeContainer");
if (!snapViewContainer) {
return;
}
// reset leagueType specific class.
snapViewContainer.className = "snappedHomeContainer";
SportsJS.Page.setSportsPageRootElement(".snappedHomeContainer", leagueType);
}
})
});
})();