﻿(function () {
'use strict';
WinJS.Namespace.define("SportsJS.Common.Modules", {
SnapScheduleModuleControl: WinJS.Class.derive(SportsJS.Common.Modules.LeagueScheduleModuleControl, function (element, options) {
var _options = this._initializeOptions(options);
SportsJS.UI.SportsModule.call(this, element, _options);
},
{
_initializeOptions: function _initializeOptions(options) {
var _options = options ? options : {};
_options.templateId = "moduleFragment";
_options.fragmentPath = "/leagues/common/modules/LeagueScheduleModule/LeagueScheduleModule.html";
_options.dataProvider = this.dataProvider;
_options.rendererInfo = this.rendererInfo;
_options.eventHandler = SportsJS.Common.Modules.SnapScheduleModuleControl.snapScheduleEventHandler;
_options.usesItemsContainer = options && options.usesItemsContainer ? options.usesItemsContainer : false;
_options.innerListViewOptions = {
layout: { type: WinJS.UI.ListLayout},
};
return _options;
},
//gets the snapmode leagues and appends the favorite teams' leagues to it.
_getLeagueList: function _getLeagueList() {
var requiredLeagues = SportsJS.SnapViewHome.snapModeRequiredLeagues();
var favTeams = SportsJS.Services.Roaming.RoamingDataManager.tryReadCollection(SportsJS.UI.SportsEntityCollectionType.MyTeams.name);
if (favTeams.value && favTeams.collection.length > 0) {
favTeams = favTeams.collection;
for (var i = 0, favTeamLen = favTeams.length; i < favTeamLen; i++) {
var leagueNameFav = SportsJS.Utilities.mapCStoJSLeagueType(favTeams[i].entityLeague);
var sport = AppEx.Sports.Services.Utils.getSportsFromLeague(leagueNameFav);
if (sport === $SpMgr.enumStrings.SportsType[Microsoft.AppEx.Sports.SportsEnums.Sport.racing]
|| sport === $SpMgr.enumStrings.SportsType[Microsoft.AppEx.Sports.SportsEnums.Sport.golf]
|| sport === $SpMgr.enumStrings.SportsType[Microsoft.AppEx.Sports.SportsEnums.Sport.tennis]
|| sport === $SpMgr.enumStrings.SportsType[Microsoft.AppEx.Sports.SportsEnums.Sport.cricket]) {
continue;
}
if (leagueNameFav && requiredLeagues.indexOf(leagueNameFav) === -1) {
requiredLeagues.push(leagueNameFav);
}
}
}
return requiredLeagues;
},
_filterSchedulesByLeague: function _filterSchedulesByLeague(leagueName, origSchedules) {
var schedules = origSchedules;
if (origSchedules && leagueName) {
schedules = [];
// TODO: arengak: Move this to data model later
// fitler the schedules by favorites teams
if (leagueName === SportsJS.UI.LeagueType.today) {
var favTeams = SportsJS.Services.Roaming.RoamingDataManager.tryReadCollection(SportsJS.UI.SportsEntityCollectionType.MyTeams.name);
if (favTeams.value && favTeams.collection.length > 0) {
favTeams = favTeams.collection;
var teamMap = {};
for (var i = 0, favTeamLen = favTeams.length; i < favTeamLen; i++) {
// create team map... key = leagueName, value = array of teamIds
var leagueNameFav = SportsJS.Utilities.mapCStoJSLeagueType(favTeams[i].entityLeague);
if (leagueNameFav) {
if (!teamMap[leagueNameFav]) {
teamMap[leagueNameFav] = [];
}
teamMap[leagueNameFav].push(favTeams[i].entityId);
}
}
for (var j = 0, totalSchedule = origSchedules.length; j < totalSchedule; j++) {
var leagueNameOrig = origSchedules[j].league;
var homeTeamId = origSchedules[j].homeTeamLocalId;
var visitingTeamId = origSchedules[j].visitingTeamLocalId;
// select the schedule if the team map has entry for the league and any one of home or visiting team id is present in the team id array.
if (leagueNameOrig && teamMap[leagueNameOrig] && (teamMap[leagueNameOrig].indexOf(homeTeamId) !== -1 || teamMap[leagueNameOrig].indexOf(visitingTeamId) !== -1)) {
schedules.push(origSchedules[j]);
}
}
}
} else {
for (var k = 0, scheduleLength = origSchedules.length; k < scheduleLength; k++) {
if (origSchedules[k].league === leagueName) {
schedules.push(origSchedules[k]);
}
}
}
}
return schedules;
},
dataProvider: function dataProvider(bypassCache) {
var that = this;
var promise = new WinJS.Promise(function (complete, error, progress) {
if (that.currentDate) {
var timeframe = that.currentDate;
var controller = SportsJS.mainProcessManager.scheduleController;
var leagueList = that._getLeagueList();
var uiQuery = new AppEx.Sports.Services.TypeDefs.Request.TodayScheduleQuery(SportsJS.UI.LeagueType.today, timeframe, leagueList, SportsJS.Common.Modules.SnapScheduleModuleControl.gamesPerLeague);
uiQuery.bypassCache = bypassCache;
var processResponse = function (response) {
if (response) {
response = SportsJS.Utilities.nativeObjectToJsObject(response);
if (response.noGameToday) {
response.data = [{ status: "NoGame", day: that.currentDate, fragmentPath: that.fragmentPath }];
return response;
}
else if (response.todaySchedule) {
var todaySchedule = that._filterSchedulesByLeague(that.league, response.todaySchedule);
if (todaySchedule.length > 0) {
response.data = todaySchedule;
for (var k = 0; k < todaySchedule.length; k++) {
todaySchedule[k].fragmentPath = that.fragmentPath;
}
} else {
response.data = [{ status: "NoGame", day: that.currentDate, fragmentPath: that.fragmentPath }];
}
return response;
}
else {
return null;
}
}
else {
////TODO: trace
return null;
}
};
controller.request(uiQuery).then(function (response) {
response = response ? response.dataObject : null;
if (response && that._canRejectCompleteResponse({ etag: response.responseId, lastUpdateTime: response.lastUpdateTime })) {
that._updateStalenessParameters(response);
promise.cancel();
return;
}
var pResponse = processResponse(response);
if (pResponse) {
pResponse.etag = response.responseId;
complete({ data: pResponse.data, response: pResponse });
}
else {
SportsJS.Utilities.dataFetchErrorCallBack(complete);
}
}, function () { },
function (progressData) {
if (that.shouldHandleProgress === false || bypassCache) {
return;
}
if (progressData) {
var response = processResponse(progressData.modelResponse);
if (response) {
response.etag = progressData && progressData.cachedResponse ? progressData.cachedResponse.responseId : null;
progress({ data: response.data, response: response });
}
}                        
});
}
else {
return SportsJS.Utilities.fallbackResponsePromise();
}
});
return promise;
}
},
{
unSnap: function unSnap() {
if (Windows.UI.ViewManagement.ApplicationView.value === Windows.UI.ViewManagement.ApplicationViewState.snapped) {
return Windows.UI.ViewManagement.ApplicationView.tryUnsnap();
}
return true;
},
snapScheduleEventHandler: function snapScheduleEventHandler(eventObject, item) {
// in case of items container, item.data is actually our item
if (this.usesItemsContainer) {
item = item && item.data ? item.data : item;
}
if (!item || !item.clickTarget) {
return;
}
SportsJS.SnapViewHome.unSnapTargetPage = null;
if (item.clickTarget.indexOf("http://") === -1) {
var uri;
var success = Platform.Utilities.AppExUri.tryCreate(item.clickTarget);
if (!success.value) {
return;
}
SportsJS.SnapViewHome.unSnapTargetPage = {
pageInfo: {
fragment: "/html/defaultPanoPage.html",
page: "SportsJS.MatchBase"
},
resetHistory: true,
state: {
leagueType: item.league,
matchId: success.appExUri.queryParameters.id,
}
};
SportsJS.Common.Modules.SnapScheduleModuleControl.unSnap();
}
else {
var leagueType = SportsJS.UI.LeagueType.all;
if (SportsJS.Utilities.isValidLeagueTypeStrict(SportsJS.mainProcessManager.snappedSport)) {
leagueType = SportsJS.mainProcessManager.snappedSport;
}
SportsJS.SnapViewHome.unSnapTargetPage = {
pageInfo: {
fragment: "/leagues/common/Frame/SportsFramePage.html",
page: "SportsJS.FramePage"
},
resetHistory: true,
state: { sourceUrl: item.clickTarget, leagueType: leagueType }
};
SportsJS.Common.Modules.SnapScheduleModuleControl.unSnap();
}              
},
// Maximum - inifinity. send whatever number is available
gamesPerLeague: 99
})
});
})();