﻿(function () {
'use strict';
WinJS.Namespace.define("SportsJS", {
SnapViewHome: WinJS.Class.derive(SportsJS.Page,
function (state) {
// make Favorite team as default for invalid sports and LeagueType.all
if (SportsJS.mainProcessManager && SportsJS.mainProcessManager.snappedSport) {
this._leagueType = SportsJS.mainProcessManager.snappedSport;
} else {
this._leagueType = SportsJS.UI.LeagueType.today;
}
SportsJS.Telemetry.logSnapView(this._leagueType);
this._pageType = SportsJS.UI.PageType.Snap;
this._snappedSport = this._leagueType;
if (!SportsJS.Utilities.isValidLeagueType(this._snappedSport) || this._snappedSport === SportsJS.UI.LeagueType.all) {
this._snappedSport = SportsJS.UI.LeagueType.today;
} else {
// TODO: arengak: Need to enable F1 and Golf later
var sport = AppEx.Sports.Services.Utils.getSportsFromLeague(this._snappedSport);
if (sport === $SpMgr.enumStrings.SportsType[Microsoft.AppEx.Sports.SportsEnums.Sport.racing]
|| sport === $SpMgr.enumStrings.SportsType[Microsoft.AppEx.Sports.SportsEnums.Sport.golf]
|| sport === $SpMgr.enumStrings.SportsType[Microsoft.AppEx.Sports.SportsEnums.Sport.tennis]
|| sport === $SpMgr.enumStrings.SportsType[Microsoft.AppEx.Sports.SportsEnums.Sport.cricket]) {
this._snappedSport = SportsJS.UI.LeagueType.today;
}
}
SportsJS.Page.setSportsPageRootElement(".snappedHomeContainer", this._snappedSport);
SportsJS.mainProcessManager.snappedSport = this._snappedSport;
},
{
_snappedSport: null,
getPageState: function getPageState() {
return null;
},
/// <summary>
/// This function is invoked by the UX Framework when the data binding is complete
/// </summary>
/// <returns>
/// Nothing
/// </returns>
onBindingComplete: function onBindingComplete() {
var that = this;
SportsJS.Page.prototype.onBindingComplete.call(that);
that._createClusterControls();
},
/// <summary>
/// This function is invoked by the UX Framework when the layout has changed
/// </summary>
/// <param name="layoutState">
/// The current layout state
/// </param>
/// <returns>
/// pageInfo of the page to be navigated based on currently selected filter
/// </returns>
onLayoutChange: function onLayoutChange(layoutState) {
var that = this;
if (typeof layoutState !== 'undefined' && layoutState !== Windows.UI.ViewManagement.ApplicationViewState.snapped &&
SportsJS.mainProcessManager && typeof SportsJS.mainProcessManager.snappedSport !== 'undefined') {
// User switched out of snap mode. Navigate to the appropriate page
var newPageInfo = null;
if (SportsJS.Utilities.isFirstRunOfflineExperience()) {
// Navigate back to FRE home page
newPageInfo = {
pageInfo: {
fragment: "/leagues/allsports/HomePage/AllSportsHomePage.html",
page: "SportsJS.AllSports.HomePage"
},
resetHistory: true,
state: { leagueType: SportsJS.UI.LeagueType.all }
};
} else {
var unsnapTarget = SportsJS.SnapViewHome.unSnapTargetPage;
if (unsnapTarget && unsnapTarget.pageInfo && unsnapTarget.state) {
newPageInfo = unsnapTarget;
SportsJS.SnapViewHome.unSnapTargetPage = null;
}
else if (SportsJS.Utilities.isValidLeagueTypeStrict(SportsJS.mainProcessManager.snappedSport)) {
// Navigate to selected page
newPageInfo = {
pageInfo: {
channelId: "none",
fragment: "/html/defaultPanoPage.html",
page: "SportsJS.HomeBase"
},
resetHistory: true,
state: { leagueType: SportsJS.mainProcessManager.snappedSport }
};
} else {
// Navigate back to standard home page
newPageInfo = {
pageInfo: {
channelId: "Home",
fragment: "/leagues/today/HomePage/TodayHomePage.html",
page: "SportsJS.Today.TodayHomePage"
},
resetHistory: true,
state: null
};
}
}
that._cleanUpSnapPage();
return newPageInfo;
}
},
_cleanUpSnapPage: function _cleanUpSnapPage() {
var that = this;
if (that.control && typeof that.control.cleanUp === 'function') {
that.control.cleanUp();
}
},
_refreshPage: function _refreshPage() {
// TODO: angoe Evaluate if this can be optimized instead of removing the clusters everytime on page refresh.
this._cleanUpSnapPage();
CommonJS.Error.removeError();
CommonJS.forceRefresh();
},
/// <summary>
/// Gets the Cluster-Config for the page
/// </summary>
getClusterConfig: function getClusterConfig() {
var that = this;
if (SportsJS.mainProcessManager.countryBlocked === true) {
return that._clusterConfig = [];
}
if (that._clusterConfig) {
return that._clusterConfig;
}
var ETDate = SportsJS.DateTimeHelpers.getCurrentDateinET();
that._currentDate = SportsJS.DateTimeHelpers.formatDateAsPerBackend(ETDate);
var cfgs = SportsJS.Cluster.Configs.Common;
var snapScheduleConfig = cfgs.snapSchedule(that._snappedSport, that._currentDate);
var clusterConfigs = that._clusterConfig = [snapScheduleConfig];
return clusterConfigs;
},
_createClusterControls: function _createClusterControls() {
var that = this;
var pageRoot = document.querySelector(".snappedHomeContent");
if (!pageRoot) {
return;
}
var clusterCfgs = that.getClusterConfig();
for (var ii = 0; ii < clusterCfgs.length; ii++) {
var controlObject = clusterCfgs[ii].clusterContent.contentControl;
var control = PlatformJS.Utilities.createObject(controlObject, null, clusterCfgs[ii].clusterContent.contentOptions);
that.control = control;
pageRoot.appendChild(control.element);
control.render().then(function () {
});
}
},
getPageData: function getPageData() {
var that = this;
that._pageTitle = CommonJS.resourceLoader.getString("SnapTitle");
var pageData = {
title: that._pageTitle,
subtitle: ""
};
var promise = new WinJS.Promise(function (complete, error) {
that._timeoutWrapper(function () { complete(pageData); }, that.pageDataTimeout);
});
return promise;
},
}, {
unSnapTargetPage: null,
//Returns an array of userleagues and the league that is snapped from.
snapModeRequiredLeagues: function snapModeRequiredLeagues() {
var requiredLeagues = SportsJS.mainProcessManager.userLeagues;
var snappedLeague = SportsJS.mainProcessManager.snappedSport;
if (snappedLeague !== "today" && !SportsJS.mainProcessManager.isValidUserLeague(snappedLeague)) {
requiredLeagues.push(snappedLeague);
}
var ret = [];
for (var i = 0, numLeagues = requiredLeagues.length; i < numLeagues; i++) {
var league = requiredLeagues[i];
var sport = AppEx.Sports.Services.Utils.getSportsFromLeague(league);
if (sport === $SpMgr.enumStrings.SportsType[Microsoft.AppEx.Sports.SportsEnums.Sport.racing]
|| sport === $SpMgr.enumStrings.SportsType[Microsoft.AppEx.Sports.SportsEnums.Sport.golf]
|| sport === $SpMgr.enumStrings.SportsType[Microsoft.AppEx.Sports.SportsEnums.Sport.tennis]
|| sport === $SpMgr.enumStrings.SportsType[Microsoft.AppEx.Sports.SportsEnums.Sport.cricket]) {
continue;
}
ret.push(league);
}
return ret;
}
})
});
})();