﻿(function () {
'use strict';
WinJS.Namespace.define("SportsJS.Common.Clusters", {
LeaderBoardClusterControl: WinJS.Class.derive(SportsJS.UI.SportsCluster,
function (element, options) {
SportsJS.UI.SportsCluster.call(this, element, options);
},
{
getModuleConfigs: function getModuleConfigs() {
var clusterConfigs = [];
var that = this;
var league = that.league;
var clusterId = that.id;
var clusterType = SportsJS.UI.ClusterType.LeaderBoardCluster;
var requireListViewIncrementalFetching = that.requireListViewIncrementalFetching;
var usesItemsContainer = that.usesItemsContainer;
if (!league) {
return clusterConfigs;
}
var tournamentIds = [];
SportsJS.Utilities.sportsMsWriteProfilerMark("Sports:LeaderBoardBasicInfo:s");
var basicInfoPromise = new WinJS.Promise(function (complete, error) {
that._promiseStack(SportsJS.Common.Clusters.getLeaderBoardBasicInfoAsync(league)).then(function (leagueBasicInfo) {
if (leagueBasicInfo && leagueBasicInfo.isValid) {
tournamentIds = leagueBasicInfo.tourIds;
var configParams;
configParams = {};
configParams.leagueType = league;
configParams.league = league;
configParams.clusterId = clusterId;
configParams.requireListViewIncrementalFetching = requireListViewIncrementalFetching;
configParams.usesItemsContainer = usesItemsContainer;
for (var i = 0; i < tournamentIds.length; i++) {
configParams.tournamentId = tournamentIds[i];
clusterConfigs.push(SportsJS.Modules.Configs.Common.sportsTable(configParams));
}
complete(clusterConfigs);
SportsJS.Utilities.sportsMsWriteProfilerMark("Sports:LeaderBoardBasicInfo:e");
}
else {
error(false);
}
}, function () {
error(false);
});
});
return basicInfoPromise;
}
}),
getLeaderBoardBasicInfoAsync: function getLeaderBoardBasicInfoAsync(leaguename) {
var promise = new WinJS.Promise(function (complete, error) {
var controller = AppEx.Sports.Services.SportsController();
var uiQuery = new AppEx.Sports.Services.TypeDefs.Request.LeaderBoardTourInfoQuery(leaguename);
controller.request(uiQuery).then(function (res) {
var basicResponse;
if (res && (basicResponse = SportsJS.Utilities.nativeObjectToJsObject(res)) && basicResponse.isValid) {
complete(basicResponse);
}
else {
error();
}
}, function () {
error();
});
});
return promise;
}
});
})();