﻿(function () {
'use strict';
WinJS.Namespace.define("SportsJS.Common.Clusters", {
LeagueScheduleClusterControl: WinJS.Class.derive(SportsJS.UI.SportsCluster,
function (element, options) {
SportsJS.UI.SportsCluster.call(this, element, options);
},
{
_getDateString: function _getDateString(date) {
var month = date.getMonth() + 1;
var day = date.getDate();
var year = date.getFullYear();
var dateString = AppEx.Sports.Services.Utilities.DateTimeStringConstructor.tryGetDateTimeString(year, month, day, 0, 0, "MMMM dd");
if (dateString) {
return dateString.dateTimeString;
}
else {
return month + " / " + day;
}
},
getModuleConfigs: function getModuleConfigs() {
var that = this;
var today = SportsJS.DateTimeHelpers.getCurrentDateinET();
var yesterday = SportsJS.DateTimeHelpers.getCurrentDateinET();
yesterday.setDate(yesterday.getDate() - parseInt(1));
var todayDate = that._getDateString(today);
var yesterdayDate = that._getDateString(yesterday);
var moduleConfigs = [];
var league = this.league ? this.league : "";
var sportsType = AppEx.Sports.Services.Utils.getSportsFromLeague(league);
var twoDayScheduleLeagues = { basketball:true, icehockey:true, baseball:true};
if (sportsType in twoDayScheduleLeagues) {
var configParamsToday = that.configParams;
var configParamsYesterday = that.configParams;                        
configParamsYesterday.scheduleDate = yesterday;                        
configParamsYesterday.headerDate = PlatformJS.Services.resourceLoader.getString("DayYesterday");
var yesterdayModule = SportsJS.Modules.Configs.Common.leagueScheduleDaily(configParamsYesterday, that.isInteractive);
configParamsToday.scheduleDate = today;
configParamsToday.headerDate = PlatformJS.Services.resourceLoader.getString("DayToday");
var todayModule = SportsJS.Modules.Configs.Common.leagueScheduleDaily(configParamsToday, that.isInteractive);
moduleConfigs = [yesterdayModule, todayModule];
}
else {
var configParams = that.configParams;
configParams.scheduleDate = today;
var weeklyModule = SportsJS.Modules.Configs.Common.leagueScheduleWeekly(configParams);
moduleConfigs = [weeklyModule];
}
return WinJS.Promise.wrap(moduleConfigs);
},
// Checks if we need to display "No games schedule" or "ErrorCluster"
_clusterRenderFailure: function _clusterRenderFailure(complete, errRes) {
var count = 0;
var that = this;
if (errRes && that.submodules) {
var modulesData = errRes;
// maxNumber of modules which errored out while calling this clusterRenderFailure
var maxErroredModules = 0;
var modulesPendingRemoval = [];
// total number of submodules in the cluster
var maxSubmodules = that.submodules.length;
var numberOfModulesWithNoGamesToday = 0;
var numberOfModulesWithValidData = 0; // either hasData is true or it is noGameToday
// wrapper to remove module elements from cluster
var removeModulesElement = function (modulesToRemove) {
if (!modulesToRemove) { return; }
for (var ii = 0; ii < modulesToRemove.length; ii++) {
if (!modulesToRemove[ii] || !modulesToRemove[ii].element) {
continue;
}
try {
this.element.removeChild(modulesToRemove[ii].element);
} catch (e) {
// if we could not remove, do nothing
}
}
};
// find out maxErroredClusters, numberOfModulesWithNoGamesToday, numberOfModulesWithValidData
for (var k = 0; k < modulesData.length; k++) {
if (!modulesData[k]) {
continue;
}
if (typeof modulesData[k] !== "undefined" && typeof modulesData[k].response !== "undefined" && modulesData[k].response.status === "noGameToday") {
modulesPendingRemoval.push(this.submodules[k]);
numberOfModulesWithNoGamesToday++;
numberOfModulesWithValidData++;
} else if (typeof modulesData[k] !== "undefined" && typeof modulesData[k].response !== "undefined" && modulesData[k].response.isValid === true) {
numberOfModulesWithValidData++;
} else {
// need to remove modules with invalid data if required
modulesPendingRemoval.push(this.submodules[k]);
}
maxErroredModules++;
}
// if Errored modules is equal to total submodules and there exist a one module with invalid data. 
// we need to render error
if (maxErroredModules === maxSubmodules && numberOfModulesWithValidData < maxErroredModules) {
SportsJS.UI.SportsCluster.prototype._clusterRenderFailure.call(that, complete);
return;
}
//  if Errored modules are equal to total submodules and all the modules are valid and all the modules are noGamesToday
//  we are good to show NoGameTodayTemplate
else if (maxErroredModules === maxSubmodules && numberOfModulesWithValidData === maxSubmodules && numberOfModulesWithNoGamesToday > 0 && numberOfModulesWithNoGamesToday === maxSubmodules) {
// remove all the submodule elements
removeModulesElement.call(this, modulesPendingRemoval);
// TODO(ashondik) : use CommonJS.LoadModule 
WinJS.UI.Fragments.renderCopy("/html/templates.html").then(function (noGameModuleFragment) {
if (noGameModuleFragment) {
var noGameModuleTemplate = noGameModuleFragment.querySelector("#NoGameTemplate");
if (noGameModuleTemplate) {
WinJS.Resources.processAll(noGameModuleTemplate);
that.element.style.visibility = 'visible';
that.element.appendChild(noGameModuleTemplate);
that._makeSportsItemsNavigable();
}
}
});
that._onRenderComplete(true);
complete(false);
}
//  This means Errored modules are equal to total submodules. Some of them has actual full schedule to show. In this case we should remove modules with invalid data & noGamesToday
// ideally this wouldn't be hit as errResponse is not called out in case of successful completion.
else {
// remove the submodules which say "NoGameToday"
removeModulesElement.call(this, modulesPendingRemoval);
complete(true);
return;
}
}
else {
SportsJS.UI.SportsCluster.prototype._clusterRenderFailure.call(that, complete);
}
}
}),
});
})();