﻿(function () {
"use strict";
WinJS.Namespace.define("SportsJS.Common.Modules", {
AllSportsModuleControl: WinJS.Class.derive(SportsJS.UI.SportsModule, function (element, options) {
},
{
cleanUp: function cleanUp() {
if (!SportsJS.Utilities.isNavigationBarEnabled()) {
SportsJS.Utilities.enableNavigationBar();
}
SportsJS.UI.SportsModule.prototype.cleanUp.call(this);
}
},
{
onAddLeagueClick: function onAddLeagueClick(e) {
var addToUserLeagues = function (event, leagueToAdd) {
var isSuccess = false;
if (!SportsJS.Networking.isInternetAvailable) {
var messageBar = new CommonJS.MessageBar(PlatformJS.Services.resourceLoader.getString("AddLeaguesFailedOnOffline"), { level: CommonJS.MessageBarLevelWarning, autoHide: true });
messageBar.show();
return isSuccess;
}
var userLeagues = SportsJS.mainProcessManager.userLeagues;
if (SportsJS.Services.RoamingData.addUserLeagueName(leagueToAdd)) {//do this only if successful
SportsJS.Telemetry.logFavLeagueAction(leagueToAdd, SportsJS.Telemetry.ActionType.add, SportsJS.Telemetry.ElementType.ClusterTile);
SportsJS.mainProcessManager.processListener.onUserLeaguesChanged(event);
isSuccess = true;
}
return isSuccess;
};
var removeFromUserLeagues = function (event, leagueToRemove) {
var isSuccess = false;
if (!SportsJS.Networking.isInternetAvailable) {
var messageBar = new CommonJS.MessageBar(PlatformJS.Services.resourceLoader.getString("RemoveLeaguesFailedOnOffline"), { level: CommonJS.MessageBarLevelWarning, autoHide: true });
messageBar.show();
return isSuccess;
}
var userLeagues = SportsJS.mainProcessManager.userLeagues;
//verify the remove operation is not causing zero leagues leagues, if that is the case, reject remove operation
if (userLeagues.length === 1) {
messageBar = new CommonJS.MessageBar(PlatformJS.Services.resourceLoader.getString("AllSportsMsgRemoveAllLeaguesFailure"), { level: CommonJS.MessageBarLevelWarning, autoHide: true });
messageBar.show();
return isSuccess;
}
if (SportsJS.Services.RoamingData.removeUserLeagueName(leagueToRemove)) {
SportsJS.Telemetry.logFavLeagueAction(leagueToRemove, SportsJS.Telemetry.ActionType.remove, SportsJS.Telemetry.ElementType.ClusterTile);
SportsJS.mainProcessManager.processListener.onUserLeaguesChanged(event);
isSuccess = true;
}
return isSuccess;
};
if (e === null || e.srcElement === null) {
return;
}
e.preventDefault();
var srcElement = e.srcElement;
var leagueType = srcElement.leagueType;
if (!leagueType) {
return;
}
var isAdd = WinJS.Utilities.hasClass(srcElement, "userLeague");
var isupdate = false;
if (isAdd) {
isupdate = removeFromUserLeagues(e, leagueType);
} else {
isupdate = addToUserLeagues(e, leagueType);
}
// toggle only if add/remove was successful
if (isupdate) {
SportsJS.Controls.Utilities.dispatchCustomEvent(srcElement, "onUserLeagueChanged", e);
}
},
navigateToLeaguePage: function navigateToLeaguePage(element, leagueType) {
if (!element) {
return;
}
var srcElement = element;
PlatformJS.Navigation.navigateToChannel("LeagueHome", { leagueType: leagueType });
},
allSportsEventHandler: function allSportsEventHandler(eventObject, item) {
if (!item || !item.data) {
return;
}
PlatformJS.Navigation.navigateToChannel("LeagueHome", { leagueType: item.data.leagueType });
},
// set the userLeague class using this converter.
setUserLeague: WinJS.Binding.converter(function (isUserLeague) {
if (isUserLeague) {
return "sportsAddbutton userLeague";
}
return "sportsAddbutton";
}),
}),
});
})();