﻿(function () {
'use strict';
WinJS.Namespace.define('SportsJS.Common.Modules', {
CommonScheduleModuleControl: WinJS.Class.derive(SportsJS.UI.SportsModule, function (element, options) {
var _options = options ? options : {};
_options.useOrderedRendering = true;
_options._isModuleScrollable = true;
_options.usesItemsContainer = true;
_options.rendererInfo = this.rendererInfo.bind(this);
_options.isInteractive = true;
_options.eventHandler = SportsJS.Common.Modules.CommonScheduleModuleControl.commonScheduleEventHandler;
SportsJS.UI.SportsModule.call(this, element, _options);
},
{
rendererInfo: function rendererInfo(item) {
var that = this;
if (!item || !item.data || !item.data.moduleInfo) {
return null;
}
var fragmentPath = "/leagues/common/modules/CommonScheduleModule/CommonScheduleModule.html";
var templateId = "CommonScheduleLayout";
var templateClass = "gameTemplate";
if (item.data.status && item.data.status.toLowerCase() === SportsJS.UI.GameState.nogame) {
fragmentPath = "/html/templates.html";
templateClass = "SportsNoDataMessage";
if (that._options && that._options.scheduleView === Microsoft.AppEx.Sports.Schemas.TypeDefs.ScheduleView.resultsOnly) {
templateId = "sportsNoDataTemplate";
}
else {
templateId = "NoGameTemplate";
}
}
else if (item.data.isHeader) {                    
templateId = "commonScheduleHeader";
templateClass = "commonScheduleHeader";
}
var moduleInfo = {
fragmentPath: fragmentPath,
templateId: templateId,
};
if (item.data.clickTarget) {
item.data.moduleInfo.isInteractive = false;
}
var customRendererInfo;
if (item.data.isHeader) {
item.data.moduleInfo.isInteractive = true;
customRendererInfo = { data: item.data, moduleInfo: moduleInfo };
}
else {
customRendererInfo = { data: item.data, moduleInfo: moduleInfo, className: "scheduleSmallTile sportsTile " + templateClass };
}
return customRendererInfo;
},
_isNoGamesResponse: function _isNoGamesResponse(response) {
var that = this;
var isNoGameResponse = response && response.status === "noGameToday";
if (isNoGameResponse) {
return true;
}
else {
return false;
}
}                   
},
{
commonScheduleEventHandler: function commonScheduleEventHandler(eventObject, item) {
// in case of items container, item.data is actually our item
if (this.usesItemsContainer) {
item = item && item.data ? item.data : item;
}
if (!item || !item.clickTarget) {
return;
}
//// Below logic for instrumentation
if (PlatformJS.Navigation && PlatformJS.Navigation.currentIPage && PlatformJS.Navigation.currentIPage._leagueType) {
var leagueType = PlatformJS.Navigation.currentIPage._leagueType;
if (leagueType === SportsJS.UI.LeagueType.today) {
SportsJS.Telemetry.logScheduleClick(item, SportsJS.UI.PageType.Today);
}
else {
SportsJS.Telemetry.logScheduleClick(item, SportsJS.UI.PageType.League);
}
}
//// we need only this line to navigate
msSetImmediate(function () {
SportsJS.Utilities.navigateTo(item.clickTarget);
});
},
commonScheduleInGameText: WinJS.Binding.converter(
function (inGameText) {
if (!inGameText) {
return "hideStatusBadge";
}
else {
return "showStatusBadge sportsSubtitleTextTiny";
}
}),
commonScheduleFirstTeamDetail: WinJS.Binding.converter(
function (gameStatus) {
var className = "sportsStatSmall gameDetail firstTeam";
if (!gameStatus || typeof gameStatus !== "string") {
return className;
}
gameStatus = gameStatus.toLowerCase();
if (gameStatus === SportsJS.UI.GameState.pregame) {
className = "sportsSubtitleTextTiny gameDetail firstTeam";
}
return className;
}),
commonScheduleSecondTeamDetail: WinJS.Binding.converter(
function (gameStatus) {
var className = "sportsStatSmall gameDetail secondTeam";
if (!gameStatus || typeof gameStatus !== "string") {
return className;
}
gameStatus = gameStatus.toLowerCase();
if (gameStatus === SportsJS.UI.GameState.pregame) {
className = "sportsSubtitleTextTiny gameDetail secondTeam";
}
return className;
}),
commonScheduleAggregateText: WinJS.Binding.converter(
function (aggregateScore) {
var className = "aggregate";
if (!aggregateScore || aggregateScore.length > 0) {
return className;
}
return className + "Off";
})
})
});
})();