﻿(function () {
'use strict';
WinJS.Namespace.define("SportsJS.Common.Modules", {
LeadingEntitiesModuleControl: WinJS.Class.derive(SportsJS.UI.SportsModule, function (element, options) {
//// inch forward to make programmatic config - chthakur to complete, This will be more clean
var _options = options ? options : {};
_options.templateId = "moduleFragment";
_options.fragmentPath = "/leagues/common/modules/LeadingEntitiesModule/LeadingEntitiesModule.html";
_options.eventHandler = this.onItemClick;
_options.dataProvider = this.dataProvider;
_options.usesItemsContainer = true;
_options.rendererInfo = this.rendererInfo.bind(this);
SportsJS.UI.SportsModule.call(this, element, _options);
},
{
// TODO: chthakur -> ashokkul - fix header click
rendererInfo: function rendererInfo(item) {
var that = this;
if (!item || !item.data) {
return null;
}
var moduleInfo = item.data.moduleInfo;
if (item.data.status === "NoData") {
var templateSelector = "sportsNoDataTemplate";
var fragmentPath = "/html/templates.html";
moduleInfo = {
fragmentPath: fragmentPath,
templateId: templateSelector,
};
}
var customRendererInfo = { data: item.data, moduleInfo: moduleInfo };
return customRendererInfo;
},
constructUiQuery: function constructUiQuery() {
var that = this;
var uiScenarioName = that.uiScenarioName ? that.uiScenarioName : "";
var conference = that.conference ? that.conference : "";
var league = that.league ? that.league : "";
var uiQuery;
if (uiScenarioName === SportsJS.Utilities.stringProperCase(league) + 'LeagueLeadingPlayers') {
uiQuery = new AppEx.Sports.Services.TypeDefs.Request.LeagueLeadingPlayersQuery(league, conference);
}
else if (uiScenarioName === SportsJS.Utilities.stringProperCase(league) + 'LeagueLeadingTeamStats') {
uiQuery = new AppEx.Sports.Services.TypeDefs.Request.LeagueLeadingTeamStatsQuery(league, conference);
}
if (!uiQuery || !uiQuery.isValid) {
return null;
}
return uiQuery;
},
onItemClick: function onItemClick(eventObject, item) {
var that = this;
that.eventObject = eventObject;
that.item = item;
SportsJS.Telemetry.logClusterClick(that.telemetryId);
SportsJS.Utilities.ECV.handleTileSelection.apply(that, eventObject, item);
},
processResponse: function processResponse(res) {
if (!res) {
return null;
}
//// single response contains arrays. Need to be converted into direct properties of the object
var response = {};
if (res.isValid && res.leadingEntitesList && res.leadingEntitesList.length > 0) {
var convertArrayElementsToProperties = true;
response = SportsJS.Utilities.copyCsResponseMeta(res, response);
var leadingEntitesList = SportsJS.Utilities.nativeArrayToJsArray(res.leadingEntitesList, convertArrayElementsToProperties);
SportsJS.Utilities.padDummyLeadingEntities(leadingEntitesList);
response.data = leadingEntitesList;
}
else if (res.isNoData) {
response = SportsJS.Utilities.nativeObjectToJsObject(res);
response.isValid = true;
response.data = [{ status: "NoData" }];
}
return response;
},
},
{
showEntityRank: WinJS.Binding.converter(function (entityRank) {
if (!entityRank) {
return "none";
}           
})
})
});
})();