﻿(function () {
'use strict';
//requires utilities and modulesconfig, TODO: provide overriding for properties
WinJS.Namespace.define("SportsJS.Common.Modules", {
LeagueScheduleModuleControl: WinJS.Class.derive(SportsJS.UI.SportsModule, function (element, options) {
//// inch forward to make programmatic config - chthakur to complete, This will be more clean
var _options = options ? options : {};
_options.templateId = "moduleFragment";
_options.fragmentPath = "/leagues/common/modules/LeagueScheduleModule/LeagueScheduleModule.html";
_options.dataProvider = this.dataProvider;
_options.rendererInfo = this.rendererInfo.bind(this);
_options.isInteractive = true;
_options.useOrderedRendering = true;
_options.usesItemsContainer = options && options.usesItemsContainer ? options.usesItemsContainer : false;
SportsJS.UI.SportsModule.call(this, element, _options);
this.dataProviderKey = null;
},
{
_getDataProviderKey: function _getDataProviderKey() {
var that = this;
var league = that.league ? that.league : "";
var ETDate = SportsJS.DateTimeHelpers.getCurrentDateinET();
var timeFrame = SportsJS.DateTimeHelpers.formatDateAsPerBackend(ETDate);
var uiQuery = new AppEx.Sports.Services.TypeDefs.Request.LeagueScheduleQuery(league, timeFrame);
var key = null;
if (uiQuery && uiQuery.isValid) {
key = AppEx.Sports.Services.SportsController.getUrl(uiQuery);
}
return key;
},
_leagueName: null,
dataProvider: function dataProvider(bypassCache, bypassProgress) {
var that = this;
var promise = new WinJS.Promise(function (complete, error, progress) {
if (that.league) {
var league = that.league;
var controller = AppEx.Sports.Services.SportsController();
var leagueBasicInfo;
that._leagueName = league;
var ETDate = SportsJS.DateTimeHelpers.getCurrentDateinET();
var timeFrame = SportsJS.DateTimeHelpers.formatDateAsPerBackend(ETDate);                        
var processResponse = function (res) {
if (!res) {
return null;
}
var currentDay = SportsJS.Utilities.getCurrentDay();
var response = SportsJS.Utilities.nativeObjectToJsObject(res);
// check not required for NFL. TODO: chthakur - merge this day/week concept across leagues. hinders extensibility
if ((leagueBasicInfo && leagueBasicInfo.inSeason && leagueBasicInfo.todaysMatchCount === 0) || res.noGameToday === true) {
response.data = [{ status: "NoGame", day: currentDay, fragmentPath: that.fragmentPath }];
}
else if (res.weekSchedule) {
var weekSchedule = response.weekSchedule;
for (var k = 0; k < weekSchedule.length; k++) {
weekSchedule[k].fragmentPath = that.fragmentPath;
}
response.data = weekSchedule;
if (!SportsJS.Utilities.checkScheduleDataRefreshValidity(response, that.providerResponse, response.data, that.dataSource)) {
return null;
}
}
if (!response.data) {
return null;
}
return response;
};
var uiQuery = new AppEx.Sports.Services.TypeDefs.Request.LeagueScheduleQuery(league, timeFrame);
uiQuery.bypassCache = bypassCache;
//// Create a request for LKG schedule Date Response
var lkgScheduleDateResponsePromise = null;
var lkgScheduleDate = SportsJS.Utilities.getLKGScheduleDate(that.league);
if (lkgScheduleDate && lkgScheduleDate !== timeFrame) {
lkgScheduleDateResponsePromise = new WinJS.Promise(function (completeFn) {
var lkgScheduleUiQuery = new AppEx.Sports.Services.TypeDefs.Request.LeagueScheduleQuery(league, lkgScheduleDate);
controller.request(lkgScheduleUiQuery).then(function (res) {
//// Dont want to do anything here as we would get data in progress handler
}, function () {
}, function (progressRes) {
var response = processResponse(progressRes.modelResponse);
if (response) {
//// We should not inline refresh using lkgScheduleDateResponse
response.nextRefreshInterval = -1;
completeFn(response);
}
});
});
}
controller.request(uiQuery).then(function (res) {
if (that._canRejectCompleteResponse(res)) {
that._updateStalenessParameters(res);
promise.cancel();
return;
}
var response = processResponse(res);
if (response) {
SportsJS.Utilities.setLKGScheduleDate(timeFrame, that.league);
complete({ data: response.data, response: response });
}
else {
//// Before showing error, we want to see if we have lkgScheduleDateResponse.
//// We will have lkgScheduleDateResponse only when the lkgScheduleDate is not same as currentDate.
//// If they are same, the responses woould be same, so no use
//// This would never take us back in time since the lkgScheduleDate is set as soon as schedule for a particular date is rendered
if (lkgScheduleDateResponsePromise) {
lkgScheduleDateResponsePromise.then(function (resp) {
complete({ data: resp.data, response: resp });
});
}
else {
SportsJS.Utilities.dataFetchErrorCallBack(complete);
}
}
}, function () { },
function (progressData) {
if (that.shouldHandleProgress === false || bypassCache || bypassProgress) {
return;
}
if (progressData) {
var response = processResponse(progressData.modelResponse);
if (response) {
SportsJS.Utilities.setLKGScheduleDate(timeFrame, that.league);
progress({ data: response.data, response: response });
}
}
});
}
else {
return SportsJS.Utilities.fallbackResponsePromise();
}
});
return promise;
},
rendererInfo: function rendererInfo(item) {
var that = this;
if (!item || !item.data) {
return null;
}
var templateId = "LeagueScheduleCommonLayout";
if (item.data.status && item.data.status.toLowerCase() === SportsJS.UI.GameState.nogame) {
templateId = "leagueScheduleNoGame";
}
var className = "scheduleSmallTile sportsTile";
if (that.showLogos === false) {
className = "scheduleNoLogosSmallTile sportsTile";
templateId = "LeagueScheduleNoLogosLayout";
}
var moduleInfo = {
fragmentPath: item.data.fragmentPath,
templateId: templateId,
};
item.data.moduleInfo.isInteractive = true;
if (item.data.moduleInfo && item.data.clickTarget) {
item.data.moduleInfo.isInteractive = false;
}
var customRendererInfo = { data: item.data, moduleInfo: moduleInfo, className: className };
if (!that.usesItemsContainer) {
var itemRendererCompleteCallBack = function (scheduleTile) {
if (item.data.moduleInfo.isInteractive && scheduleTile && scheduleTile.children && scheduleTile.children[0]) {
WinJS.Utilities.addClass(scheduleTile.children[0], "win-interactive");
}
};
customRendererInfo.itemRendererCompleteCallBack = itemRendererCompleteCallBack;
}
return customRendererInfo;
},
},
{
HasPossession: WinJS.Binding.converter(
function (possessionFlag) {
if (!possessionFlag) {
return "none";
}
}),
ScoreColor: WinJS.Binding.converter(
function (isLeading) {
if (isLeading === true) {
return "sportsWinColor";
}
return "";
}),
setTeamsOrder: WinJS.Binding.converter(
function (homeVisitingOrder) {
if (homeVisitingOrder === true) {
return "homeVisitingOrder";
}
return "visitingHomeOrder";
}),
setScheduleTheme: WinJS.Binding.converter(
function (gameStatus) {
var theme = "sportsTile commonTemplate";
if (!gameStatus || typeof gameStatus !== "string") {
return theme;
}
gameStatus = gameStatus.toLowerCase();
if (gameStatus === SportsJS.UI.GameState.final
|| gameStatus === $SpMgr.getGameStateString(Microsoft.AppEx.Sports.SportsEnums.GameState.final).toLowerCase()) {
theme += " completedTemplate";
} else if (gameStatus === SportsJS.UI.GameState.pregame
|| gameStatus === $SpMgr.getGameStateString(Microsoft.AppEx.Sports.SportsEnums.GameState.preGame).toLowerCase()
|| gameStatus === SportsJS.UI.GameState.suspended
|| gameStatus === $SpMgr.getGameStateString(Microsoft.AppEx.Sports.SportsEnums.GameState.suspended).toLowerCase()
|| gameStatus === SportsJS.UI.GameState.postponed
|| gameStatus === $SpMgr.getGameStateString(Microsoft.AppEx.Sports.SportsEnums.GameState.postponed).toLowerCase()) {
theme += " upcomingTemplate";
}
else if (gameStatus === SportsJS.UI.GameState.inprogress
|| gameStatus === $SpMgr.getGameStateString(Microsoft.AppEx.Sports.SportsEnums.GameState.inProgress).toLowerCase()
|| gameStatus === SportsJS.UI.GameState.halftime
|| gameStatus === $SpMgr.getGameStateString(Microsoft.AppEx.Sports.SportsEnums.GameState.halfTime).toLowerCase()) {
theme = "sportsProminentTile commonTemplate inprogressTemplate";
} 
return theme;
})
})
});
})();