﻿(function () {
'use strict';
//requires utilities and modulesconfig, TODO: provide overriding for properties
WinJS.Namespace.define("SportsJS.Common.Modules", {
LeagueScheduleWeeklyModuleControl: WinJS.Class.derive(SportsJS.Common.Modules.CommonScheduleModuleControl, function (element, options) {
//// inch forward to make programmatic config - chthakur to complete, This will be more clean
var _options = options ? options : {};
_options.templateId = "moduleFragment";
_options.fragmentPath = "/leagues/common/modules/LeagueScheduleWeeklyModule/LeagueScheduleWeeklyModule.html";
_options.dataProvider = this.dataProvider;
SportsJS.Common.Modules.CommonScheduleModuleControl.call(this, element, _options);
WinJS.Utilities.addClass(this.element, "weeklyLeagueModule");
this.onrendercomplete = this._onRenderComplete.bind(this);
},
{
_leagueName: null,
_stickyHeaderAnimator: null,
_onRenderComplete: function _onRenderComplete() {
var that = this;
if (!that._ListControl || !that._ListControl.element) {
return;
}
that._onScrollBinding = that._onScroll.bind(that);
that._ListControl.element.addEventListener("scroll", that._onScrollBinding);
},
_onScrollBinding: null,
_onScroll: function _onScroll() {
var that = this;
if (!that._ListControl || !that._ListControl.element) {
return;
}
that._ListControl.element.removeEventListener("scroll", that._onScrollBinding);
if (!that._ListControl.element.parentNode) {
return;
}
var listContainerElement = that._ListControl.element;
var listContainerWrapper = listContainerElement.parentNode;
var headerElements = listContainerElement.querySelectorAll(".commonScheduleHeader");
if (!headerElements || headerElements.length === 0) {
return;
}
var actualHeaders = [];
for (var i = 0; i < headerElements.length; i++) {
actualHeaders.push(headerElements[i].parentNode);
}
that._stickyHeaderAnimator = new SportsJS.Controls.Components.StickyHeaderAnimator(listContainerWrapper, listContainerElement, actualHeaders);
},
constructUiQuery: function constructUiQuery() {
var that = this;
var ETDate = that.scheduleDate;
var timeFrame = SportsJS.DateTimeHelpers.formatDateAsPerBackend(ETDate);
var uiQuery;
if (that.type) {
uiQuery = new AppEx.Sports.Services.TypeDefs.Request.LeagueScheduleQuery(that.league, timeFrame, that.type);
} else if (typeof that.stageId !== "undefined" && that.stageId !== null && that.stageId !== "") {
uiQuery = new AppEx.Sports.Services.TypeDefs.Request.StagedLeagueScheduleQuery(that.league, that.stageId, that.scheduleView);
} else {
uiQuery = new AppEx.Sports.Services.TypeDefs.Request.LeagueScheduleQuery(that.league, timeFrame);
}
if (!uiQuery.isValid) {
return null;
}
return uiQuery;
},
processResponse: function processResponse(res) {
var that = this;
if (!res) {
return null;
}
var response = SportsJS.Utilities.nativeObjectToJsObject(res);
if (response.noGameToday === true) {
response.data = [{ status: "NoGame", fragmentPath: that.fragmentPath }];
}
else if (response.isValid === false) {
return null;
}
else if (res.weekSchedule) {
var weekSchedule = response.weekSchedule;
var schedule = [];
var headerDate = "";
var weekScheduleHeaderdate = "";
var isEnUSMarket = AppEx.Sports.Services.Utils.checkUSMarket();
var j = 0;
var k;
if (!isEnUSMarket && that.league === $SpMgr.enumStrings.LeagueType[Microsoft.AppEx.Sports.SportsEnums.League.nfl]) {
var weekString = SportsJS.Utilities.stringFormat(PlatformJS.Services.resourceLoader.getString("/Common/WeekNum"), weekSchedule[j].matchWeek.toString());
schedule[j] = { headerDate: weekString, moduleInfo: true, isHeader: true };
j++;
for (k = 0; k < weekSchedule.length ; k++) {
schedule[j] = weekSchedule[k];
response.weekSchedule = null;
j++;
}
}
else {        
for (k = 0; k < weekSchedule.length ; k++) {
weekScheduleHeaderdate = weekSchedule[k].gameMonthDate;
if (weekScheduleHeaderdate !== headerDate) {
schedule[j] = { headerDate: weekScheduleHeaderdate, moduleInfo: true, isHeader: true };
headerDate = weekScheduleHeaderdate;
j++;
}
schedule[j] = weekSchedule[k];
response.weekSchedule = null;
j++;
}
}
response.data = schedule;
if (!SportsJS.Utilities.checkScheduleDataRefreshValidity(response, that.providerResponse, response.data, that.dataSource)) {
return null;
}
}
if (!response.data) {
return null;
}
return response;
},            
cleanUp: function cleanUp(isNavigating) {
var that = this;
if (that._stickyHeaderAnimator) {
that._stickyHeaderAnimator.cleanUp();
}
if (that._ListControl && that._ListControl.element) {
that._ListControl.element.removeEventListener("scroll", that._onScrollBinding);
}
SportsJS.UI.SportsModule.prototype.cleanUp.call(that, isNavigating);
}       
})
});
})();