﻿(function () {
"use strict";
WinJS.Namespace.define("SportsJS.Common.Modules", {
MyLeaguesModuleControl: WinJS.Class.derive(SportsJS.Common.Modules.EntityCollectionModuleControl, function (element, options) {
//// inch forward to make programmatic config - chthakur to complete, This will be more clean
var _options = options ? options : {};
options.pageType = SportsJS.UI.PageType.Today;
var that = this;
_options.templateId = "moduleFragment";
_options.fragmentPath = "/leagues/common/modules/MyLeaguesModule/MyLeaguesModule.html";
_options.dataProvider = this.dataProvider;
_options.rendererInfo = this.rendererInfo;
_options.entityCollectionType = SportsJS.UI.SportsEntityCollectionType.MyLeagues,
SportsJS.Common.Modules.EntityCollectionModuleControl.call(this, element, _options);
this.onrendercomplete = this._onRenderComplete.bind(this);
},
{
_getInnerListOptions: function _getInnerListOptions() {
var that = this;
var innerListViewOptions = {
friendlyName: "myLeaguesList",
//need single selection mode to be able to reorder in ListView2
selectionMode: "multi",
handleOutOfOrderItems: CommonJS.UI.ListView2.HANDLEOUTOFORDERITEMS.MOVETOBOTTOM,
enabledFeatures: CommonJS.UI.ListView2.FEATURES.ALL,
controlKey: "LeaguesPersistenceKey",
onadditeminvoked: function onadditeminvoked(event) {
that.gotoAllLeagues();
},
onitemdeleted: function onitemdeleted(event) {
that.removeEntityFromCollection(event);
},
onlistreordered: function onlistreordered(event) {
that.reorderEntityCollection(event);
}
};
return innerListViewOptions;
},
networkOnlineEventHandler: function networkOnlineEventHandler() {
var that = this;
if (!that.listControl) {
return;
}
if (SportsJS.Utilities.getUserLeagues().length <= 1) {
that.listControl.enabledFeatures = CommonJS.UI.ListView2.FEATURES.ALL - CommonJS.UI.ListView2.FEATURES.REMOVE;
}
else {
that.listControl.enabledFeatures = CommonJS.UI.ListView2.FEATURES.ALL;
}
},
networkOfflineEventHandler: function networkOfflineEventHandler() {
var that = this;
if (!that.listControl) {
return;
}
that.listControl.enabledFeatures = CommonJS.UI.ListView2.FEATURES.PERSISTENCE;
},
dataProvider: function dataProvider(bypassCache) {
var that = this;
var leagueType = that.leagueType;
var pageType = that.pageType;
var promise = new WinJS.Promise(function (complete) {
var response = { data: [], isValid: true };
var userLeagues = SportsJS.Utilities.getUserLeagues();
for (var index = 0; index < userLeagues.length; index++) {
response.data[index] = {};
response.data[index].tileType = "LeagueTile";
response.data[index].itemKey = userLeagues[index];
response.data[index].title = SportsJS.Utilities.getLocLeagueDisplayText(userLeagues[index]);
response.data[index].image = 'icon' + AppEx.Sports.Services.Utils.getSportsFromLeague(userLeagues[index]);
}
complete({ response: response });
});
return promise;
},
gotoAllLeagues: function gotoAllLeagues() {
SportsJS.Utilities.navigateTo(Platform.Utilities.AppExUriBuilder.toUriString(SportsJS.NavControllers.allsports, "", "", null));                
},
entityTileClickEventHandler: function entityTileClickEventHandler(event, itemData) {
if (itemData && itemData.itemKey) {
SportsJS.Telemetry.logMyLeagues(itemData.itemKey, SportsJS.Telemetry.ActionType.click);
PlatformJS.Navigation.navigateToChannel("LeagueHome", { leagueType: itemData.itemKey });
}
},
reorderEntityCollection: function reorderEntityCollection(event) {
if (this.listControl) {
var listOrder = this.listControl.getOrder();
if (listOrder) {
SportsJS.Utilities.reorderUserLeagues(listOrder); 
SportsJS.mainProcessManager.processListener.onUserLeaguesReordered(event);
}
}
},
removeEntityFromCollection: function removeEntityFromCollection(event) {
var that = this;
if (event && event.detail && event.detail.itemKey) {
var entityLeague = event.detail.itemKey;
//no clean way of doing this..but this works for now
if (SportsJS.Utilities.getUserLeagues().length === 2 && that.listControl) {
var element = that.listControl.elementFromIndex(0);
if (element.id.indexOf(event.detail.itemKey) !== -1) {
that.listControl._removeFromEditList(1);
}
else {
that.listControl._removeFromEditList(0);
}
}
that._logTelemetryRemove(entityLeague);
if (SportsJS.Services.RoamingData.removeUserLeagueName(entityLeague)) {
SportsJS.Instrumentation.incrementInt32("LeaguesRemovedCount");
SportsJS.mainProcessManager.processListener.onUserLeaguesChanged(event);
}
}
},
rendererInfo: function rendererInfo(item) {
var that = this;                
var ariaLabel = null;
var templateSelectors = {};
templateSelectors["LeagueTile"] = "leagueTileTemplate";
var templateSelector = null;
var customRendererInfo = null;
if (item.data.tileType && templateSelectors.hasOwnProperty(item.data.tileType)) {
templateSelector = templateSelectors[item.data.tileType];
}                   
if (templateSelector) {
var moduleInfo = {
fragmentPath: that.fragmentPath,
templateId: templateSelector,
};
customRendererInfo = { data: item.data, moduleInfo: moduleInfo, ariaLabel: ariaLabel };
}
return customRendererInfo;
},
_logTelemetryAdd: function _logTelemetryAdd(entity) {
//dummy implementation because adding leagues do not happen from this module
return;
},
_logTelemetryRemove: function _logTelemetryRemove(league) {
SportsJS.Telemetry.logFavLeagueAction(league, SportsJS.Telemetry.ActionType.remove, SportsJS.Telemetry.ElementType.ClusterTile);
return;
},
})
});
})();