﻿(function () {
"use strict";
WinJS.Namespace.define("SportsJS.Common.Modules", {
MyTeamsModuleControl: WinJS.Class.derive(SportsJS.Common.Modules.EntityCollectionModuleControl, function (element, options) {
//// inch forward to make programmatic config - chthakur to complete, This will be more clean
var _options = options ? options : {};
var that = this;
_options.templateId = "moduleFragment";
_options.fragmentPath = "/leagues/common/modules/MyTeamsModule/MyTeamsModule.html";
_options.dataProvider = this.dataProvider;
_options.rendererInfo = this.rendererInfo;
_options.entityCollectionType = SportsJS.UI.SportsEntityCollectionType.MyTeams,
SportsJS.Common.Modules.EntityCollectionModuleControl.call(this, element, _options);
},
{
_getInnerListOptions: function _getInnerListOptions() {
var that = this;
var innerListViewOptions = {
friendlyName: "myTeamsList",
//need single selection mode to be able to reorder in ListView2
selectionMode: "multi",
handleOutOfOrderItems: CommonJS.UI.ListView2.HANDLEOUTOFORDERITEMS.MOVETOBOTTOM,
enabledFeatures: CommonJS.UI.ListView2.FEATURES.ALL,
controlKey: "MyTeamsPersistenceKey",
onadditeminvoked: function onadditeminvoked(event) {
that.showEntitySearchUI();
},
onitemdeleted: function onitemdeleted(event) {
that.removeEntityFromCollection(event);
},
};
return innerListViewOptions;
},
dataProvider: function dataProvider(bypassCache) {
var that = this;
var leagueType = that.leagueType;
var pageType = that.pageType;
var promise = new WinJS.Promise(function (complete, error, progress) {
var myTeams = SportsJS.Services.Roaming.RoamingDataManager.tryReadCollection(that._entityCollectionType.name);
//// We want to show all the favorite teams.
var currentMyTeams = AppEx.Sports.Services.Utilities.Collections.createSportsEntityInfoList();
var currentLeagues = [];
//// If my Teams collection exists and has length > 0
if (myTeams.value && myTeams.collection.length > 0) {
var teams = myTeams.collection;
for (var i = 0; i < teams.length; i++) {
var teamLeague = SportsJS.Utilities.mapCStoJSLeagueType(teams[i].entityLeague);                            
currentMyTeams.append(teams[i]);
if (currentLeagues.indexOf(teamLeague) === -1) {
currentLeagues.push(teamLeague);
}                          
}
}
if (currentMyTeams.length > 0) {
var controller = AppEx.Sports.Services.SportsController();
var uiQuery = AppEx.Sports.Services.TypeDefs.Request.MyTeamsQuery(leagueType, currentMyTeams, currentLeagues);
if (!uiQuery || !uiQuery.isValid) {
return SportsJS.Utilities.fallbackResponsePromise();
}
uiQuery.bypassCache = bypassCache;
var processResponse = function (res) {
if (res) {
var response = SportsJS.Utilities.nativeObjectToJsObject(res);
if (response.myTeamsEntities) {
//// Add tile type for the team tiles
for (var index = 0; index < response.myTeamsEntities.length; index++) {
response.myTeamsEntities[index].tileType = "TeamTile";
response.myTeamsEntities[index].itemKey = response.myTeamsEntities[index].entityInfo.entityId;
}
response.data = response.myTeamsEntities;
response.myTeamsEntities = null;
return response;
}
else {
return null;
}
}
else {
return null;
}
};
controller.request(uiQuery).then(function (res) {
if (res
&& res.progressResponseNotModified === true
&& res.shouldHandleProgress !== false) {
that._updateStalenessParameters(res);
promise.cancel();
return;
}
var response = processResponse(res);
if (response && response.data) {
complete({ response: response });
}
else {
SportsJS.Utilities.dataFetchErrorCallBack(complete);
}
}, function (err) {
}, function (progressRes) {
var response = processResponse(progressRes.modelResponse);
if (response && response.data) {
progress({ response: response });
}
});
}
else {
var editableData = [];
complete({ data: editableData, response: { data: editableData, isValid: true } });
}
});
return promise;
},
//// Get Data for a newly added Team
getEntityData: function getEntityData(teamInfo) {
var that = this;
if (!teamInfo) {
return WinJS.Promise.wrap(null);
}
var leagueType = that.leagueType;
var leaguesList = [];
var teamLeague = SportsJS.Utilities.mapCStoJSLeagueType(teamInfo.entityLeague);
if (!teamLeague) {
return WinJS.Promise.wrap(null);
}
leaguesList.push(teamLeague);
var teamList = AppEx.Sports.Services.Utilities.Collections.createSportsEntityInfoList();
teamList.append(teamInfo);
var uiQuery = AppEx.Sports.Services.TypeDefs.Request.MyTeamsQuery(leagueType, teamList, leaguesList);
if (!uiQuery || !uiQuery.isValid) {
return WinJS.Promise.wrap(null);
}
var promise = new WinJS.Promise(function (complete, error) {
var controller = AppEx.Sports.Services.SportsController();
controller.request(uiQuery).then(function (res) {
if (res) {
var response = SportsJS.Utilities.nativeObjectToJsObject(res);
if (response.myTeamsEntities && response.myTeamsEntities.length === 1) {
var teamData = response.myTeamsEntities[0];
teamData.tileType = "TeamTile";
complete(teamData);
}
else {
complete(null);
}
}
else {
complete(null);
}
});
});
return promise;
},
entityTileClickEventHandler: function entityTileClickEventHandler(event, itemData) {
var teamInfo = itemData.entityInfo;
if (teamInfo) {
var teamLeague = SportsJS.Utilities.mapCStoJSLeagueType(teamInfo.entityLeague);
var teamId = teamInfo.entityId;
if (teamLeague && teamId) {
// Windows bug with keyboard enter causing app to crash, App is navigating to new page quickly causing the bug
// TODO(chthakur) - fix this with windows, adding small delay before navigation to fix the crash
// observe and change msSetImmediate to setTimeout with 20ms if this doesn't work out
var teamUnivId = SportsJS.Utilities.stringFormat(
"{0}/{1}",
teamLeague,
teamId);
SportsJS.Telemetry.logFavTeamAction(teamUnivId, SportsJS.Telemetry.ActionType.click, SportsJS.Telemetry.ElementType.ClusterTile);
msSetImmediate(function () {
PlatformJS.Navigation.navigateToChannel(SportsJS.UI.PageType.Team, { leagueType: teamLeague, teamId: teamId });
});
}
}
},
rendererInfo: function rendererInfo(item) {
var that = this;                
var ariaLabel = null;
var templateSelectors = {};
templateSelectors["TeamTile"] = "teamTileTemplate";
var templateSelector = null;
var customRendererInfo = null;
if (item.data.tileType && templateSelectors.hasOwnProperty(item.data.tileType)) {
templateSelector = templateSelectors[item.data.tileType];
}                   
if (templateSelector) {
var moduleInfo = {
fragmentPath: that.fragmentPath,
templateId: templateSelector,
};
customRendererInfo = { data: item.data, moduleInfo: moduleInfo, ariaLabel: ariaLabel };
}
return customRendererInfo;
},
_logTelemetryAdd: function _logTelemetryAdd(entityInfo) {
var teamUnivId = SportsJS.Utilities.stringFormat(
"{0}/{1}",
SportsJS.Utilities.mapCStoJSLeagueType(entityInfo.entityLeague),
entityInfo.entityId);
SportsJS.Telemetry.logFavTeamAction(teamUnivId, SportsJS.Telemetry.ActionType.add, SportsJS.Telemetry.ElementType.ClusterTile);
},
_logTelemetryRemove: function _logTelemetryRemove(entityInfo) {
var teamUnivId = SportsJS.Utilities.stringFormat(
"{0}/{1}",
SportsJS.Utilities.mapCStoJSLeagueType(entityInfo.entityLeague),
entityInfo.entityId);
SportsJS.Telemetry.logFavTeamAction(teamUnivId, SportsJS.Telemetry.ActionType.remove, SportsJS.Telemetry.ElementType.ClusterTile);
},
},
{
showTeamTile: WinJS.Binding.converter(
function (tileType) {
if (tileType !== "TeamTile") {
return 'none';
}
}),
showComma: WinJS.Binding.converter(
function (streakKind) {
if (!streakKind) {
return 'none';
}
else {
return 'inline';
}
}),
showStreakColor: WinJS.Binding.converter(   
function (streakKind) {
if (SportsJS.UI.StreakIndicator.win === streakKind) {
return 'sportsWinColor';
}
else if (SportsJS.UI.StreakIndicator.tie === streakKind) {
return 'sportsTieColor';
}
else if (SportsJS.UI.StreakIndicator.loss === streakKind) {
return 'sportsLossColor';
}                
}),
}),
});
})();