﻿(function () {
'use strict';
WinJS.Namespace.define("SportsJS.Common.Modules", {
NoImageLeadingEntitiesModuleControl: WinJS.Class.derive(SportsJS.UI.SportsModule, function (element, options) {
var _options = options ? options : {};
_options.templateId = "moduleFragment";
_options.fragmentPath = "/leagues/common/modules/NoImageLeadingEntitiesModule/NoImageLeadingEntitiesModule.html";
if (_options.isItemClickEnabled === false) {
_options.eventHandler = null;
} else {
_options.eventHandler = this.onItemClick;
}
_options.dataProvider = this.dataProvider;
_options.rendererInfo = this.rendererInfo;
_options.usesItemsContainer = true;
SportsJS.UI.SportsModule.call(this, element, _options);
},
{
constructUiQuery: function constructUiQuery() {
var that = this;
var league = that.league ? that.league : "";
var teamId = that.teamId ? that.teamId : "";
var conference = that.conference ? that.conference : "";
var entityType = that.entityType ? that.entityType : "";
var uiQuery = null;
//// Currently we are assuming everywhere we are showing top3 players in each category
//// In future if we want to change the number, this is the place to change the number
//// and down the line datamodel will require some changes
if (conference !== "") {
if ((!uiQuery || !uiQuery.isValid) && (entityType === SportsJS.UI.EntityType.League)) {
uiQuery = new AppEx.Sports.Services.TypeDefs.Request.LeagueLeadingPlayersQuery(league, conference);
}
else if (entityType === "teams") {
uiQuery = new AppEx.Sports.Services.TypeDefs.Request.LeagueLeadingTeamStatsQuery(league, conference);
}
else if (entityType === SportsJS.UI.EntityType.Team) {
uiQuery = new AppEx.Sports.Services.TypeDefs.Request.TeamLeadersV2Query(league, teamId);
}
} else {
if (entityType === SportsJS.UI.EntityType.League) {
uiQuery = new AppEx.Sports.Services.TypeDefs.Request.LeagueLeadingPlayersV2Query(league, SportsJS.Consts.LeaguePageLeadersPerCategory);
}
else if (entityType === "teams") {
uiQuery = new AppEx.Sports.Services.TypeDefs.Request.LeagueLeadingTeamStatsQuery(league, "");
}
else if (entityType === SportsJS.UI.EntityType.Team) {
uiQuery = new AppEx.Sports.Services.TypeDefs.Request.TeamLeadersV2Query(league, teamId);
}
}
if (!uiQuery || !uiQuery.isValid) {
return null;
}
return uiQuery;
},
onItemClick: function onItemClick(eventObject, item) {
var that = this;
that.eventObject = eventObject;
that.item = item;
SportsJS.Telemetry.logClusterClick(that.telemetryId);
SportsJS.Utilities.ECV.handleTileSelection.apply(that, eventObject, item);
},
processResponse: function processResponse(res) {
if (res) {
//// single response contains arrays. Need to be converted into direct properties of the object
var response = {};
if (res.isValid && res.leadingEntitesList && res.leadingEntitesList.length > 0) {
var convertArrayElementsToProperties = true;
response = SportsJS.Utilities.copyCsResponseMeta(res, response);
var leadingEntitesList = SportsJS.Utilities.nativeArrayToJsArray(res.leadingEntitesList, convertArrayElementsToProperties);
SportsJS.Utilities.padDummyLeadingEntities(leadingEntitesList);
response.data = leadingEntitesList;
}
else {
response.isValid = true;
response.data = [{ status: "NoData" }];
}
return response;
}
return null;
},
rendererInfo: function rendererInfo(item) {
var that = this;
var fragmentPath = that.fragmentPath;
var templateSelector = "InnerListItemTemplate";
if (item.data.status === "NoData") {
templateSelector = "sportsNoDataTemplate";
fragmentPath = "/html/templates.html";
}
var moduleInfo = {
fragmentPath: fragmentPath,
templateId: templateSelector,
};
var customRendererInfo = { data: item.data, moduleInfo: moduleInfo };
return customRendererInfo;
},
}, {
showEntityRank: WinJS.Binding.converter(function (entityRank) {
if (!entityRank) {
return "none";
}
})
})
});
})();