﻿(function () {
"use strict";
WinJS.Namespace.define("SportsJS.Common.Modules", {
PlayerBioModuleControl: WinJS.Class.derive(SportsJS.UI.SportsModule, function (element, options) {
var _options = options ? options : {};
_options.templateId = "moduleFragment";
_options.fragmentPath = "/leagues/common/modules/PlayerBioModule/PlayerBioModule.html";
_options.rendererInfo = this.rendererInfo.bind(this);
_options.dataProvider = this.dataProvider;
_options.usesItemsContainer = true;
SportsJS.UI.SportsModule.call(this, element, _options);
},
{
constructUiQuery: function constructUiQuery() {
var that = this;
var playerId = that.playerId ? that.playerId : "";
var league = that.league ? that.league : "";
if (playerId === "" || league === "") {
return null;
}
var uiQuery = new AppEx.Sports.Services.TypeDefs.Request.PlayerBasicInfoQuery(league, playerId);
if (!uiQuery || !uiQuery.isValid) {
return null;
}
return uiQuery;
},
onClickTeamLogo: function onClickTeamLogo(teamId) {
var that = this;
if (teamId) {
PlatformJS.Navigation.navigateToChannel(SportsJS.UI.PageType.Team, { leagueType: that.league, teamId: teamId });
}
},
rendererInfo: function rendererInfo(item) {
var that = this;
if (!item || !item.data) {
return null;
}
var moduleInfo = item.data.moduleInfo;   
item.data.imgClick = WinJS.Utilities.markSupportedForProcessing(this.onClickTeamLogo.bind(this, item.data.teamID));
var customRendererInfo = { data: item.data, moduleInfo: moduleInfo };
return customRendererInfo;
},
dataProvider: function dataProvider(bypassCache) {
var that = this;
var playerId = that.playerId ? that.playerId : "";
var league = that.league ? that.league : "";
var promise;
if (!playerId || !league) {
promise = SportsJS.Utilities.fallbackResponsePromise();
}
else {
promise = new WinJS.Promise(function (complete) {
SportsJS.Shared.Promises.Player.playerBio(league, playerId, bypassCache).then(function (playerData) {
var response = SportsJS.Utilities.copyCsResponseMeta(playerData.meta, {});
response.data = [];
response.data.push(playerData.response); //has 1 data item only
complete( { response : response});
});
});
}
return promise;
}
},
{
injuryTextDisplay: WinJS.Binding.converter(
function (injuryStatus) {
if (!injuryStatus) {
return 'none';
}
else {
return '';
}
}
)
})
});
})();