﻿(function () {
"use strict";
WinJS.Namespace.define("SportsJS.Common.Modules", {
PlayerGameLogModuleControl: WinJS.Class.derive(SportsJS.UI.SportsModule, function (element, options) {
var _options = options ? options : {};
_options.templateId = "moduleFragment";
_options.fragmentPath = "/leagues/common/modules/PlayerGameLogModule/PlayerGameLogModule.html";
_options.dataProvider = this.dataProvider;
_options.usesItemsContainer = true;
// following flag marks the module as vertically scroallable, so baseclass will handle scroll etc. events on module
_options._isModuleScrollable = true;
SportsJS.UI.SportsModule.call(this, element, _options);
},
{
constructUiQuery: function constructUiQuery() {
var that = this;
var playerId = that.playerId ? that.playerId : "";
var league = that.league ? that.league : "";
if (playerId === "" || league === "") {
return null;
}
var uiQuery = new AppEx.Sports.Services.TypeDefs.Request.PlayerGameLogsQuery(league, playerId);
if (!uiQuery || !uiQuery.isValid) {
return null;
}
return uiQuery;
},
processResponse: function processResponse(res) {
if (res) {
//// single response contains arrays. Need to be converted into direct properties of the object
var convertArrayElementsToProperties = true;
var response = SportsJS.Utilities.copyCsResponseMeta(res, {});
response.data = SportsJS.Utilities.nativeArrayToJsArray(res.gameLogs, convertArrayElementsToProperties);
return response;
}
else {
return null;
}
}
},
{
_setHeaderStyle: function _setHeaderStyle(source, sourceProperty, dest, destProperty) {
if (source["isHeader"]) {
dest[destProperty[0]] += " sportsStatNameSmall";
}
else {
dest[destProperty[0]] += " sportsStatValueSmall";
}
},
setHeaderStyle: {
get: function get() {
this._setHeaderStyle.supportedForProcessing = true;
return this._setHeaderStyle;
}
},
setDirection: WinJS.Binding.converter(
function (isHeader) {
if (isHeader === false) {
return "ltr";
}
return "";
}),
_setStatSpecificHeaderStyle: function _setStatSpecificHeaderStyle(source, sourceProperty, dest, destProperty) {
if (source[sourceProperty[0]][sourceProperty[1]] && source["isHeader"]) {
dest[destProperty[0]] = " barHeaderDiv" + " sportsStatNameSmall";
}
},
setStatSpecificHeaderStyle: {
get: function get() {
this._setStatSpecificHeaderStyle.supportedForProcessing = true;
return this._setStatSpecificHeaderStyle;
}
},
_setBarDisplay: function _setBarDisplay(source, sourceProperty, dest, destProperty) {
if (!source[sourceProperty[0]][sourceProperty[1]] || source["isHeader"]) {
dest[destProperty[0]][destProperty[1]] = "none";
}
},
setBarDisplay : {
get: function get(){
this._setBarDisplay.supportedForProcessing = true;
return this._setBarDisplay;
}
},
getNoGameLogsColumnSpan: WinJS.Binding.converter(
function (isNoGameLogsIndicator) {
if (isNoGameLogsIndicator) {
return 6;
}
return 1;
}),
setStatDisplay: WinJS.Binding.converter(
function (value) {
if (!value) {
return "none";
}
}),
getScoreSeparator: WinJS.Binding.converter(
function (isHeader) {
if (!isHeader) {
return "-";
}
return "";
}),
getNoGameLogsGameSeparatorDisplay: WinJS.Binding.converter(
function (isNoGameLogsIndicator) {
if (isNoGameLogsIndicator) {
return "none";
}
return "";
}),
getWinLossLegend: WinJS.Binding.converter(
function (matchOutCome) {
if (parseInt(matchOutCome) === SportsJS.UI.MatchOutCome.won) {
return PlatformJS.Services.resourceLoader.getString("WinsAcronym");
}
else if (parseInt(matchOutCome) === SportsJS.UI.MatchOutCome.lost) {
return PlatformJS.Services.resourceLoader.getString("LossAcronym");
}
else if (parseInt(matchOutCome) === SportsJS.UI.MatchOutCome.notDetermined || parseInt(matchOutCome) === SportsJS.UI.MatchOutCome.tied) { // need to handle tied state
return "";
}
}),
getWinLossLegendVisibility: WinJS.Binding.converter(
function (isHeader) {
if (isHeader === true) {
return "hidden";
}
else {
return "visible";
}
}),
setMatchOutcomeColor:  WinJS.Binding.converter(
function (isOutcomeWin){
if (isOutcomeWin) {
return "#FFFFFF"; // [dongpark/Craftsmanship] To enhance the readability on background image, we use white here
}
else {
return "#FFFFFF"; // [dongpark/Craftsmanship] To enhance the readability on background image, we use white here
}
}),
})
});
})();