﻿(function () {
"use strict";
WinJS.Namespace.define("SportsJS.Common.Modules", {
PlayerStatsModuleControl: WinJS.Class.derive(SportsJS.UI.SportsModule, function (element, options) {
var _options = options ? options : {};
_options.templateId = "moduleFragment";
_options.fragmentPath = "/leagues/common/modules/PlayerStatsModule/PlayerStatsModule.html";
_options.dataProvider = this.dataProvider;
_options.usesItemsContainer = true;
SportsJS.UI.SportsModule.call(this, element, _options);
},
{
constructUiQuery: function constructUiQuery() {
var that = this;
var playerId = that.playerId ? that.playerId : "";
var league = that.league ? that.league : "";
if (playerId === "" || league === "") {
return null;
}
var uiQuery = new AppEx.Sports.Services.TypeDefs.Request.PlayerStatsQuery(league, playerId);
if (!uiQuery || !uiQuery.isValid) {
return null;
}
return uiQuery;
},
processResponse: function processResponse(res) {
if (res && res.isValid) {
//// single response contains arrays. Need to be converted into direct properties of the object
var convertArrayElementsToProperties = true;
var statsData = {};
statsData.stats = res.stats;
statsData.numStats = res.numStats;
statsData.seasonYear = res.seasonYear;
statsData.title = res.title;
statsData.hashCode = res.hashCode;
statsData = SportsJS.Utilities.nativeObjectToJsObject(statsData, convertArrayElementsToProperties);
statsData.stats = null;
var response = SportsJS.Utilities.copyCsResponseMeta(res, {});
response.data = [statsData];
return response;
}
else {
return null;
}
}
},
{
setStatDisplay: WinJS.Binding.converter(function (value) {
if (!value) {
return "none";
}
}),
}),
});
})();