﻿(function () {
"use strict";
WinJS.Namespace.define("SportsJS.Common.Slideshow", {
SlideshowModuleControl: WinJS.Class.derive(SportsJS.UI.SportsModule, function (element, options) {
this._leagueName = options.leagueName;
this._entityType = options.entityType;
var _options = this._initializeOptions(options);
SportsJS.UI.SportsModule.call(this, element, _options);
},
{
_entityType: null,
leagueName: null,
_initializeOptions: function _initializeOptions(options) {
var _options = options ? options : {};
_options.templateId = "moduleFragment";
_options.fragmentPath = "/leagues/common/modules/SlideshowModule/SlideshowModule.html";
_options.dataProvider = this.dataProvider;
_options.eventHandler = this.onItemClick;
_options.usesItemsContainer = true;
return _options;
},
constructUiQuery: function constructUiQuery() {
var that = this;
// ideally collection id should be generated in c#, chthakur -> ankurg
var collectionId = SportsJS.Utilities.getEditorialCollectionId(that._leagueName, AppEx.Sports.Services.TypeDefs.EditorialCollectionType.headlines, that._entityType, null, false);
var uiQuery = new AppEx.Sports.Services.TypeDefs.Request.SlideshowQuery(collectionId, $SpMgr.cmsPreviewEnabled);
if (!uiQuery.isValid) {
return null;
}
return uiQuery;
},
processResponse: function processResponse(res) {
var that = this;
var processedResponse = { data: null, isValid: false };
if (!res || !res.dataString) {
return processedResponse;
}
processedResponse = SportsJS.Utilities.copyCsSportsResponseMeta(res, processedResponse);
var parsedResponse = that._parseSlideShowResponse(res.dataString);
if (parsedResponse && parsedResponse.data) {
processedResponse.data = parsedResponse.data;
// chthakur - parsed response time is utc milliseconds. We deliberately want to store
// cache update time, which is already present in processedResponse. 
// processedResponse.lastUpdateTime = parsedResponse.lastUpdateTime;
processedResponse.isValid = true;
}
return processedResponse;
},
slideshowsClusterGroupId: "slideshows",
_parseSlideShowResponse: function _parseSlideShowResponse(jsonString) {
var jsonResponse = SportsJS.Utilities.jsonParse(jsonString);
if (!jsonResponse) {
return;
}
//TODO (angupt) : The code logic is because of test json. It will change with original data
var clusters = jsonResponse.clusters;
if (!clusters) {
return null;
}
var slideShowCluster;
for (var i = 0; i < clusters.length; i++) {
var cluster = clusters[i];
if (cluster.entityList && cluster.entityList.collectionId === this.slideshowsClusterGroupId) {
slideShowCluster = cluster;
break;
}
}
if (!slideShowCluster || !slideShowCluster.entityList || !slideShowCluster.entityList.entities) {
return;
}
var entities = slideShowCluster.entityList.entities;
var result = {};
result.lastUpdateTime = jsonResponse.lastModified ? jsonResponse.lastModified.utctime : "";
result.data = [];
for (var j = 0; j < entities.length; j++) {
var entity = entities[j];
var res = this.constructSlideshowObject(entity);
result.data.push(res);
}
return result;
},
constructSlideshowObject: function constructSlideshowObject(result) {
if (!result) {
return null;
}
var slideshowObject = {};
if (result.content) {
var content = result.content;
}
var appUri = AppEx.Sports.Services.Utilities.SportsAppExUriManager.instance.createAppUri(result.destination);
if (appUri && appUri.pageId) {
slideshowObject.slideshowId = appUri.pageId;
}
//remove html tags and extra stuff from text
slideshowObject.slideshowTitle = content.headline ? content.headline.replace(/<(?:.|\n)*?>/gm, '') : "";
slideshowObject.slideshowSource = (content.source && content.source.name) ? content.source.name : "";
var imageArray = result.image.images;
//TODO (angupt): Talk to editorial team for thumbnail for each slideshow. As of now. first image from slideshow. 
if (imageArray) {
slideshowObject.slideshowThumbnailImage = imageArray[0].url;
}
return slideshowObject;
},
onItemClick: function onItemClick(eventObject, item) {
var state = {};
if (item && item.data && item.data.slideshowId) {
SportsJS.Telemetry.logSlideshowClick(item.data.slideshowId);
state.slideshowId = item.data.slideshowId;
PlatformJS.Navigation.navigateToChannel(SportsJS.UI.PageType.Slideshow, state);
return true;
}
},
})
});
})();