﻿(function () {
'use strict';
WinJS.Namespace.define("SportsJS.Common.Modules", {
StandingsModuleControl: WinJS.Class.derive(SportsJS.UI.SportsModule, function (element, options) {
//// inch forward to make programmatic config - chthakur to complete, This will be more clean
var _options = options ? options : {};
_options.templateId = "moduleFragment";
_options.fragmentPath = "/leagues/common/modules/StandingsModule/StandingsModule.html";
_options.eventHandler = this.onItemClick;
_options.rendererInfo = this.rendererInfo.bind(this);
_options.usesItemsContainer = true;
SportsJS.UI.SportsModule.call(this, element, _options);
},
{
// TODO: chthakur -> ashokkul - fix header click
rendererInfo: function rendererInfo(item) {
var that = this;
if (!item || !item.data) {
return null;
}
var moduleInfo = item.data.moduleInfo;
var callback = function (element) {
// binding results in leak. For standings using non-bindable template
// query selector is fairing well. chthakur -> use hardcoded paths if required
var teamLogo = element.querySelector(".teamLogo");
var teamName = element.querySelector(".teamName");
var clinchedInfo = element.querySelector(".clinchedInfoColor");
var record1 = element.querySelector(".record1");
var record2 = element.querySelector(".record2");
var record3 = element.querySelector(".record3");
// delay the image loading by 1s
var taskId = setTimeout(function () {
if (teamLogo && item && item.data && item.data.teamImg) {
var teamImgControl = new SportsJS.Utilities.ImgControl(teamLogo);
if (teamLogo.winControl) {
teamLogo.winControl.imgData = item.data.teamImg;
}
}
}, 1000);
that._imageLoadingTasks = that._imageLoadingTasks ? that._imageLoadingTasks : [];
that._imageLoadingTasks.push(taskId);
teamName.innerText = item.data.teamname;
clinchedInfo.innerText = item.data.clinchedInfo;
record1.innerText = item.data.recordStats0.value;
record2.innerText = item.data.recordStats1.value;
record3.innerText = item.data.recordStats2.value;
};
var customRendererInfo = { data: item.data, moduleInfo: moduleInfo, itemRendererCompleteCallBack: callback };
return customRendererInfo;
},
// explicitly call out
dataProvider: null,
// TODO: arengak and chthakur: create a control/component that will take care of creating custom place holder.
createModulePlaceHolder: function createModulePlaceHolder() {
var that = this;
var placeholderElement = document.createElement("div");
WinJS.Utilities.addClass(placeholderElement, "sportsModulePlaceholder");
if (that.moduleId && $SpMgr.moduleLayoutCache.hasKey(that.moduleId)) {
var layoutStr = $SpMgr.moduleLayoutCache.getItem(that.moduleId);
var layout = JSON.parse(layoutStr);
if (layout && layout.division && layout.totalItems) {
WinJS.Utilities.removeClass(placeholderElement, "sportsModulePlaceholder");
WinJS.Utilities.addClass(placeholderElement, "sportsStandingsModulePlaceholder");
var textElement = document.createElement("div");
WinJS.Utilities.addClass(textElement, "sportsModuleTitle");
textElement.innerText = layout.division;
placeholderElement.appendChild(textElement);
var placeholderItemContainer = document.createElement("div");
WinJS.Utilities.addClass(placeholderItemContainer, "sportsPlaceholderItemsContainer");
placeholderItemContainer.style.height = (layout.totalItems * 45) + "px";
for (var i = 0, totalItems = layout.totalItems; i < totalItems; i++) {
var placeholderItem = document.createElement("div");
WinJS.Utilities.addClass(placeholderItem, "sportsPlaceholderItem");
placeholderItemContainer.appendChild(placeholderItem);
}
placeholderElement.appendChild(placeholderItemContainer);
}
if (layout && layout.height && layout.width) {
WinJS.Utilities.removeClass(placeholderElement, "sportsModulePlaceholder");
placeholderElement.style.height = layout.height;
placeholderElement.style.width = layout.width;
} 
} 
return placeholderElement;
},
updateModuleLayoutInfo: function updateModuleLayoutInfo() {
var that = this;
var layout = {
height: that.element.offsetHeight + "px",
width: that.element.offsetWidth + "px",
division: that.division,
totalItems: that.dataSource.length
};
var layoutStr = JSON.stringify(layout);
$SpMgr.moduleLayoutCache.addItem(that.moduleId, layoutStr);
},
onItemClick: function onItemClick(eventObject, item) {
var that = this;
if (this.league && item && item.data && item.data.localid) {
var league = this.league;
SportsJS.Telemetry.logClusterClick(that.telemetryId);
PlatformJS.Navigation.navigateToChannel(SportsJS.UI.PageType.Team, { leagueType: league, teamId: item.data.localid });
}
}
},
{
setModuleStyle: WinJS.Binding.converter(
function (league) {
return "StandingsCommonModuleTemplate";
})
})
});
})();
