﻿(function () {
"use strict";
WinJS.Namespace.define("SportsJS.Common.Modules", {
TeamRosterModuleControl: WinJS.Class.derive(SportsJS.UI.SportsModule, function (element, options) {
//// inch forward to make programmatic config - chthakur to complete, This will be more clean
var _options = options ? options : {};
_options.templateId = "moduleFragment";
_options.fragmentPath = "/leagues/common/modules/TeamRosterModule/TeamRosterModule.html";
_options.dataProvider = this.dataProvider;
_options.usesItemsContainer = true;
_options.eventHandler = this.TeamRosterEventHandler;
SportsJS.UI.SportsModule.call(this, element, _options);
},
{
constructUiQuery: function constructUiQuery() {
var that = this;
var teamId = that.teamId ? that.teamId : "";
var league = that.league ? that.league : "";
if (teamId === "" || league === "") {
return null;
}
var uiQuery = new AppEx.Sports.Services.TypeDefs.Request.TeamRosterQuery(league, teamId, PlatformJS.Services.appConfig.getInt32("MaxNumberOfPlayersInRosterModule"));
if (!uiQuery || !uiQuery.isValid) {
return null;
}
return uiQuery;
},
processResponse: function processResponse(res) {
if (res !== null) {
var response = SportsJS.Utilities.nativeObjectToJsObject(res);
if (response.teamPlayers) {
response.data = response.teamPlayers;
response.teamPlayers = null;
return response;
}
else {
////TODO: trace
return null;
}
}
else {
////TODO: trace
return null;
}
},
TeamRosterEventHandler: function TeamRosterEventHandler(eventObject, item) {
var that = this;
if (item && item.data && item.data.localId) {
SportsJS.Telemetry.logClusterClick(that.telemetryId);
PlatformJS.Navigation.navigateToChannel(SportsJS.UI.PageType.Player, {
leagueType: that.league, playerId: item.data.localId, teamId: item.data.teamId, playerFullName: item.data.fullName
});
}
},
},
{
showInjuredBand: WinJS.Binding.converter(
function (injuryText) {
if (injuryText === "") {
return 'none';
}
}),
})
});
})();