﻿(function () {
"use strict";
WinJS.Namespace.define("SportsJS.Common.Modules", {
TeamScheduleModuleControl: WinJS.Class.derive(SportsJS.UI.SportsModule, function (element, options) {
//// inch forward to make programmatic config - chthakur to complete, This will be more clean
var _options = options ? options : {};
_options.templateId = "moduleFragment";
_options.fragmentPath = "/leagues/common/modules/TeamScheduleModule/TeamScheduleModule.html";
_options.dataProvider = this.dataProvider;
_options.usesItemsContainer = _options.usesItemsContainer ? _options.usesItemsContainer : false;
_options.rendererInfo = this.rendererInfo.bind(this);
_options.isInteractive = true;
_options.eventHandler = this.onItemClick;
SportsJS.UI.SportsModule.call(this, element, _options);
},
{
constructUiQuery: function constructUiQuery() {
var that = this;
var teamId = that.teamId ? that.teamId : "";
var gamecount = that.gamecount ? that.gamecount : 0;
var league = that.league ? that.league : "";
if (teamId === "" || league === "") {
return null;
}
var uiQuery;
if (that.type) {
uiQuery = new AppEx.Sports.Services.TypeDefs.Request.TeamScheduleQuery(league, teamId, gamecount, that.type);
} else {
uiQuery = new AppEx.Sports.Services.TypeDefs.Request.TeamScheduleQuery(league, teamId, gamecount);
}
if (!uiQuery || !uiQuery.isValid) {
return null;
}
return uiQuery;
},
processResponse: function processResponse(res) {
var that = this;
if (res) {
var response = SportsJS.Utilities.nativeObjectToJsObject(res);
if (response.isValid) {
if (response.noGameToday) {
response.data = [{ status: "NoGame", fragmentPath: "/html/templates.html" }];
}
else if (response.teamSchedule) {
var teamSchedule = response.teamSchedule;
for (var k = 0; k < teamSchedule.length; k++) {
teamSchedule[k].fragmentPath = that.fragmentPath;
}
response.data = response.teamSchedule;
response.teamSchedule = null;
if (!SportsJS.Utilities.checkScheduleDataRefreshValidity(response, that.providerResponse, response.data, that.dataSource)) {
return null;
}
}
}
return response;
}
else {
////TODO: trace
return null;
}
},
rendererInfo: function rendererInfo(item) {
var that = this;
if (!item || !item.data) {
return null;
}
var templateId = "GameInnerTeamScheduleCommanTemplate";
if (item.data.status.toLowerCase() === SportsJS.UI.GameState.nogame) {
templateId = "NoGameTemplate";
}
if (that.showLogos === false) {
templateId = "GameInnerTeamScheduleNoLogosTemplate";
}
var moduleInfo = {
fragmentPath: item.data.fragmentPath,
templateId: templateId,
};
if (item.data.moduleInfo && item.data.clickTarget) {
item.data.moduleInfo.isInteractive = false;
}
var customRendererInfo = { data: item.data, moduleInfo: moduleInfo };
return customRendererInfo;
},
onItemClick: function onItemClick(eventObject, item) {
item = item && item.data ? item.data : item;
if (!item || !item.clickTarget) {
return;
}
//// we need only this line to navigate
msSetImmediate(function () {
SportsJS.Telemetry.logScheduleClick(item, SportsJS.UI.PageType.Team);
SportsJS.Utilities.navigateTo(item.clickTarget);
});
}
},
{
groupScheduleClusterInfo: function groupScheduleClusterInfo() {
return {
multiSize: true,
slotWidth: 5,
slotHeight: 5
};
},
setScheduleTheme: WinJS.Binding.converter(
function (gameStatus) {
var theme = "sportsTile teamScheduleLayout";
if (!gameStatus || typeof gameStatus !== "string") {
return theme;
}
gameStatus = gameStatus.toLowerCase();
if (gameStatus === "in-progress") {
theme = "sportsProminentTile teamScheduleLayout";
}
return theme;
}),
setTeamRecordStyle: WinJS.Binding.converter(
function (gameStatus) {
var theme = "sportsStatMedium";
if (!gameStatus || typeof gameStatus !== "string") {
return theme;
}
gameStatus = gameStatus.toLowerCase();
if (gameStatus === SportsJS.UI.GameState.pregame || gameStatus === "pregame") {
theme = ".sportsStatValueSmall .sportsSubduedText";
}
return theme;
}),
setTeamStatPadding: WinJS.Binding.converter(
function (gameStatus) {
var teamstatpadding = "";
if (!gameStatus || typeof gameStatus !== "string") {
return teamstatpadding;
}
gameStatus = gameStatus.toLowerCase();
if (gameStatus === "final" || gameStatus === "in-progress") {
teamstatpadding = "completedGameSpacing";
}
return teamstatpadding;
}),
setTeamPageOutcomeColor: WinJS.Binding.converter(
function (displayStatus) {
if (displayStatus === "W") {
return "#00bd00"; // [dongpark/Craftsmanship] should be same as @colorWin, please update PlayerGameLogModule.js together
}
else if (displayStatus === "L") {
return "#f91a1a"; // [dongpark/Craftsmanship] should be same as @colorLoss, please update PlayerGameLogModule.js together
}
else {
return "";
}
})
}
)
});
})();