﻿(function () {
"use strict";
WinJS.Namespace.define("SportsJS.Common.Modules", {
TeamSingleStatsModuleControl: WinJS.Class.derive(SportsJS.UI.SportsModule, function (element, options) {
//// inch forward to make programmatic config - chthakur to complete, This will be more clean
var _options = options ? options : {};
_options.templateId = "moduleFragment";
_options.fragmentPath = "/leagues/common/modules/TeamSingleStatsModule/TeamSingleStatsModule.html";
_options.dataProvider = this.dataProvider;
_options.usesItemsContainer = true;
SportsJS.UI.SportsModule.call(this, element, _options);
},
{
dataProvider: function dataProvider(bypassCache, bypassProgress) {
var that = this;
var teamId = that.teamId ? that.teamId : "";
var league = that.league ? that.league : "";
if (teamId === "" || league === "") {
return SportsJS.Utilities.fallbackResponsePromise();
}
var promise = new WinJS.Promise(function (complete, error, progress) {
var controller = AppEx.Sports.Services.SportsController();
var uiQuery = new AppEx.Sports.Services.TypeDefs.Request.TeamStatsQuery(league, teamId);
uiQuery.bypassCache = bypassCache;
var processResponse = function (res) {
var response = null;
if (res && (res.isValid || res.isNoData)) {
response = SportsJS.Utilities.nativeObjectToJsObject(res);
response.data = response.teamStats;
}
return response;
};
controller.request(uiQuery).then(function (res) {
if (that._canRejectCompleteResponse(res)) {
that._updateStalenessParameters(res);
promise.cancel();
return;
}
var response = processResponse(res);
if (response) {
complete({ data: response.data, response: response });
}
else {
SportsJS.Utilities.dataFetchErrorCallBack(complete);
}
}, function () { },
function (progressData) {
if (that.shouldHandleProgress === false || bypassCache || bypassProgress) {
return;
}
if (progressData) {
var response = processResponse(progressData.modelResponse);
if (response) {
progress({ data: response.data, response: response });
}
}
});
});
return promise;
},
})
});
})();