﻿(function () {
"use strict";
WinJS.Namespace.define("SportsJS.Common.Modules", {
TeamStatsModuleControl: WinJS.Class.derive(SportsJS.UI.SportsModule, function (element, options) {
//// inch forward to make programmatic config - chthakur to complete, This will be more clean
var _options = options ? options : {};
_options.templateId = "moduleFragment";
_options.fragmentPath = "/leagues/common/modules/TeamStatsModule/TeamStatsModule.html";
_options.dataProvider = this.dataProvider;
_options.usesItemsContainer = true;
_options.rendererInfo = this.rendererInfo.bind(this);
SportsJS.UI.SportsModule.call(this, element, _options);
},
{
rendererInfo: function rendererInfo(item) {
var that = this;
if (!item || !item.data) {
return null;
}
var moduleInfo = item.data.moduleInfo;
if (item.data.status === "NoData") {
var templateSelector = "sportsNoDataTemplate";
var fragmentPath = "/html/templates.html";
moduleInfo = {
fragmentPath: fragmentPath,
templateId: templateSelector,
};
}
var customRendererInfo = { data: item.data, moduleInfo: moduleInfo };
return customRendererInfo;
},
constructUiQuery: function constructUiQuery() {
var that = this;
var teamId = that.teamId ? that.teamId : "";
var league = that.league ? that.league : "";
if (teamId === "" || league === "") {
return null;
}
var uiQuery = new AppEx.Sports.Services.TypeDefs.Request.TeamStatsQuery(league, teamId);
if (!uiQuery || !uiQuery.isValid) {
return null;
}
return uiQuery;
},
processResponse: function processResponse(res) {
if (!res) {
return null;
}
var response = {};
if (res.isValid && res.teamStats) {
response = SportsJS.Utilities.nativeObjectToJsObject(res);
response.data = response.teamStats;
} else if (res.isNoData) {
response = SportsJS.Utilities.nativeObjectToJsObject(res);
response.isValid = true;
response.data = [{ status: "NoData" }];
}
return response;
}
},
{
})
});
})();