﻿(function () {
'use strict';
WinJS.Namespace.define("SportsJS.Today", {
TodayHomePage: WinJS.Class.derive(SportsJS.Page,
/// <summary>
/// Constructor for your IPage class
/// </summary>
/// <param name="state">
/// The state object passed to WinJS.Navigation.navigate or the state object
/// preserved when the page has been navigated away from
/// </param>
function (state) {
var that = this;
that._basePageConstructor(state);
that._initBottomEdgy();
},
{
_currentDate: null,
//// This will help us identify which leagues should be shown on the today page. If the leagueType is today, we show all user leagues
//// Else, we will show the leagues in that particulat sport
_leagueName: SportsJS.UI.LeagueType.today,
_leagueType: SportsJS.UI.LeagueType.today,
_pageType: SportsJS.UI.PageType.Today,
_myTeamsModuleControl: null,
getPageImpressionContext: function getPageImpressionContext() {
return "/" + SportsJS.UI.PageType.Today;
},
_logTelemetry: function _logTelemetry() {
//no need to log content for today page.
},
_getMyTeamsModuleControl: function _getMyTeamsModuleControl() {
var that = this;
if (!that._myTeamsModuleControl) {
that._myTeamsModuleControl = SportsJS.Utilities.getClusterModuleInsidePagePano(SportsJS.Common.Clusters.MyTeamsClusterControl, SportsJS.Common.Modules.MyTeamsModuleControl);
}
return that._myTeamsModuleControl;
},
pageUri: {
get: function get() {
return Platform.Utilities.AppExUriBuilder.toUriString(SportsJS.NavControllers.application, "", "", null);
}
},
_isDeeplinkSharable: false,
/// <summary>
/// This function is invoked by the UX Framework when the page is being created and when
/// it is necessary to bind data to the UX.
/// </summary>
/// <returns>
/// Returns a promise that contains data to bind the UX to
/// </returns>
getPageData: function getPageData() {
var that = this;
var isPageVisited = SportsJS.Utilities.getPageVisitedStatus(that.pageId);
var isAppInitSuccess = SportsJS.mainProcessManager.isInitialized;
var appPromise = WinJS.Promise.wrap(true);
if (!isPageVisited) {
return new WinJS.Promise(function (complete) {
that.pageRenderErrorHandler();
complete(null);
});
}
if (!isAppInitSuccess) {
appPromise = $SpMgr.initializeAsync(true);
} 
CommonJS.Progress.showProgress(CommonJS.Progress.headerProgressType);
return appPromise.then(function (isValid) {
if (!isValid) {
that.pageRenderErrorHandler();
return null;
}
that._traceMsProfileMarkInfo(SportsJS.UI.ProfilerMarkType.Start, "getPageData");
that._data = new WinJS.Binding.List();
that._trace(SportsJS.Msg.GetDataRequestReceived);
that.clusterConfigs = that.getClusterConfig();
that._pageTitle = PlatformJS.Services.resourceLoader.getString("TodayHomePageTitle");
var pageData = {
title: that._pageTitle,
listSource: that._data.dataSource,
semanticZoomRenderer: that.semanticZoomRenderer,
panoramaState: that._panoramaState
};
//// The panorama state has been consumed once..we dont want to use this again.
that._panoramaState = null;
that._traceMsProfileMarkInfo(SportsJS.UI.ProfilerMarkType.End, "getPageData");
return pageData;
}, function () {
that.pageRenderErrorHandler();
return null;
});
},
removeCluster: function removeCluster(cluster) {
var that = this;
if (!that._data || !that._data._dataSource || !cluster || !cluster._config || !cluster._config.clusterKey) {
return;
}
var clusterKey = cluster._config.clusterKey;
var clusterList = that._data._dataSource;
clusterList.beginEdits();
var todayHomePageRemoveClusterPromise =  SportsJS.Controls.Utilities.getItemsFromIListDataSource(clusterList).then(function TodayHomePage_removeCluster(listItems) {
var count = listItems.length;
for (var itemIndex = 0; itemIndex < count; itemIndex++) {
if (listItems[itemIndex].data.clusterKey === clusterKey) {
clusterList.remove(listItems[itemIndex].key);
if (cluster.cleanUp && typeof cluster.cleanUp === "function") {
cluster.cleanUp();
}
break;
}
}
}).then(function TodayHomePage_removeClusterComplete() {
clusterList.endEdits();
});
that._promiseStack.call(todayHomePageRemoveClusterPromise);
return todayHomePageRemoveClusterPromise;
},
/// <summary>
/// Gets the clusterConfigs for the page
/// </summary>
getClusterConfig: function getClusterConfig() {
var that = this;
if (that._clusterConfig) {
return that._clusterConfig;
}
var ETDate = SportsJS.DateTimeHelpers.getCurrentDateinET();
that._currentDate = SportsJS.DateTimeHelpers.formatDateAsPerBackend(ETDate);
var cfgs = SportsJS.Cluster.Configs.Today;
var commonCfgs = SportsJS.Cluster.Configs.Common;
//// For Today, we dont need any query, we just specify category as Sports
var dummyNewsQueryPromise = new WinJS.Promise.wrap({});
var numNews = 15;
that._clusterConfig = [];
var cmsheroClusterConfig = commonCfgs.cmsHeroClusterToday();
if (cmsheroClusterConfig) {
that._clusterConfig.push(cmsheroClusterConfig);
}
var gettingStartedClusterConfig = cfgs.gettingStartedCluster();
if (gettingStartedClusterConfig) {
gettingStartedClusterConfig.clusterContent.contentOptions.removeClusterCallback = this.removeCluster.bind(this);
that._clusterConfig.push(gettingStartedClusterConfig);
}
var newsCommonConfig = commonCfgs.categoryNewsCluster("", "");
if (newsCommonConfig) {
that._clusterConfig.push(newsCommonConfig);
}
var headlineClusterConfig = cfgs.todayHeadlineCluster();
if (headlineClusterConfig) {
that._clusterConfig.push(headlineClusterConfig);
}
var isMyTeamsEditable = true;
that._clusterConfig.push(commonCfgs.myTeams(that._leagueType, that._pageType, isMyTeamsEditable));
that._clusterConfig.push(commonCfgs.myLeagues(that._leagueType, that._pageType, true));
var todayScheduleConfig = cfgs.todaySchedule(that._leagueType, that._currentDate);
that._clusterConfig.push(todayScheduleConfig);
var videoClusterConfig = cfgs.todayVideoCluster();
if (videoClusterConfig) {
that._clusterConfig.push(videoClusterConfig);
}
//TODO (angupt) : Pass entityId when finalized
var slideshowClusterConfig = cfgs.todaySlideShow();
if (slideshowClusterConfig) {
that._clusterConfig.push(slideshowClusterConfig);
}
var magazineCommonConfig = cfgs.todayMagazineCluster();
if (magazineCommonConfig) {
that._clusterConfig.push(magazineCommonConfig);
}
PlatformJS.Ads.addOrderedAdsClusterConfig(that._clusterConfig);
// Platform code is setting platformInvisibleCluster to true, which removes cluster from participating in semantic zoom
// find the inserted ads control and set platformInvisibleCluster to false. We need to show ads in semantic zoom
var adsControl = "PlatformJS.Ads.AdsWrapperControl";
for (var mm = 0; mm < that._clusterConfig.length; mm++) {
var cfg = that._clusterConfig[mm];
if (cfg && cfg.clusterContent && cfg.clusterContent.contentControl === adsControl) {
cfg.platformInvisibleCluster = false;
// do not break as above code can potentially add multiple ads cluster
}
}
var nextStepsClusterConfig = cfgs.nextStepsCluster();
if (nextStepsClusterConfig) {
that._clusterConfig.push(nextStepsClusterConfig);
}
that._setPanoramaStyle();
that.injectRenderConfigInClusterConfigs();
return that._clusterConfig;
},
_initBottomEdgy: function _initBottomEdgy() {
if (!this.bottomEdgy) {
return;
}
},
_onTeamSearchSuggestionsRequested: function _onTeamSearchSuggestionsRequested(event, src) {
var that = this;
var myTeamsModuleControl = that._getMyTeamsModuleControl();
if (!myTeamsModuleControl) {
return;
}
myTeamsModuleControl.showEntitySearchSuggestions(event, src);
},
//// We will get the entity collection module control and call addEntityToCollection on it
_onTeamSelected: function _onTeamSelected(event) {
var that = this;
var myTeamsModuleControl = that._getMyTeamsModuleControl();
if (!myTeamsModuleControl) {
return;
}
myTeamsModuleControl.addEntityToCollection(event);
},
})
});
})();
