﻿(function () {
'use strict';
WinJS.Namespace.define("SportsJS.Today", {
MyTeamsPage: WinJS.Class.derive(SportsJS.Page,
/// <summary>
/// Constructor for your IPage class
/// </summary>
/// <param name="state">
/// The state object passed to WinJS.Navigation.navigate or the state object
/// preserved when the page has been navigated away from
/// </param>
function (state) {
var that = this;           
that._basePageConstructor(state);
that._initBottomEdgy();
},
{
_leagueName: SportsJS.UI.LeagueType.today,
_leagueType: SportsJS.UI.LeagueType.today,
_pageType: SportsJS.UI.PageType.MyTeams,
_myTeamsModuleControl: null,
_getMyTeamsModuleControl: function _getMyTeamsModuleControl() {
var that = this;
if (!that._myTeamsModuleControl) {
that._myTeamsModuleControl = SportsJS.Utilities.getClusterModuleInsidePagePano(SportsJS.Common.Clusters.MyTeamsClusterControl, SportsJS.Common.Modules.MyTeamsModuleControl);
}
return that._myTeamsModuleControl;
},
pageUri: {
get: function get() {
return Platform.Utilities.AppExUriBuilder.toUriString(SportsJS.NavControllers.favorites, "", "", null);
}
},
getPageImpressionContext: function getPageImpressionContext() {
return "/" + SportsJS.UI.PageType.MyTeams;
},
_logTelemetry: function _logTelemetry() {
//no need to log content for fav teams page
},
/// <summary>
/// This function is invoked by the UX Framework when the page is being created and when
/// it is necessary to bind data to the UX.
/// </summary>
/// <returns>
/// Returns a promise that contains data to bind the UX to
/// </returns>
getPageData: function getPageData() {
var that = this;
that._data = new WinJS.Binding.List();
SportsJS.Utilities.showProgressBar();
that._trace(SportsJS.Msg.GetDataRequestReceived);
that.clusterConfigs = that.getClusterConfig();
that._pageTitle = PlatformJS.Services.resourceLoader.getString("MyTeams");
var pageData = {
title: that._pageTitle,
listSource: that._data.dataSource,
semanticZoomRenderer: that.semanticZoomRenderer,
panoramaState: that._panoramaState,
};
//// The panorama state has been consumed once..we dont want to use this again.
that._panoramaState = null;
var p = new WinJS.Promise(function (complete) {
var promises = [];
promises.push(that._loadRequiredFragments());
WinJS.Promise.join(that._promiseStack(promises)).then(function (successResults) {
if (successResults && successResults.length >= 1) {
that._timeoutWrapper(function () { complete(pageData); }, that.pageDataTimeout);
}
}, function (e) {
if (SportsJS.Utilities.isCancellationError(e)) {
// simple return, no error if the promise has been cancelled
return;
}
that.pageRenderErrorHandler();
// error(null); //platform not handling error, wrap in complete 
complete(null);
});
});
return p;
},
/// <summary>
/// Gets the clusterConfigs for the page
/// </summary>
getClusterConfig: function getClusterConfig() {
var that = this;
if (that._clusterConfig) {
return that._clusterConfig;
}
var commonCfgs = SportsJS.Cluster.Configs.Common;
var isMyTeamsEditable = true;
var myTeamsConfig = commonCfgs.myTeams(that._leagueName, that._pageType, isMyTeamsEditable);
var clusterConfigs = that._clusterConfig = [myTeamsConfig];
PlatformJS.Ads.addAdsClusterConfig(clusterConfigs);
that.injectRenderConfigInClusterConfigs();
return clusterConfigs;
},
// we need to reset _myTeamsModuleControl to null on refresh page
_refreshPage: function _refreshPage() {
this._myTeamsModuleControl = null;
SportsJS.Page.prototype._refreshPage.call(this);
},
_onTeamSearchSuggestionsRequested: function _onTeamSearchSuggestionsRequested(event, src) {
var that = this;
var myTeamsModuleControl = that._getMyTeamsModuleControl();
if (!myTeamsModuleControl) {
return;
}
myTeamsModuleControl.showEntitySearchSuggestions(event, src);
},
//// We will get the entity collection module control and call addEntityToCollection on it
_onTeamSelected: function _onTeamSelected(event) {
var that = this;
var myTeamsModuleControl = that._getMyTeamsModuleControl();
if (!myTeamsModuleControl) {
return;
}
myTeamsModuleControl.addEntityToCollection(event);
},
_selectAllButtonClickHandler: function _selectAllButtonClickHandler(event) {
var that = this;
var myTeamsModuleControl = that._getMyTeamsModuleControl();
if (!myTeamsModuleControl) {
return;
}
myTeamsModuleControl.selectAllEntities(event);
},
_initBottomEdgy: function _initBottomEdgy() {
if (!this.bottomEdgy) {
return;
}
}
})
});
})();
